@echo off

set DIR=.\app
set FILE=UE.jar
set HELP=help.zip
set MAN=.\source\manifest
set BIN=.\bin
set HDIR=.\help

REM check for the bin dir
if exist %BIN% goto BinExists 
echo Error: Can not find the %BIN% directory.
goto Exit

:BinExists

if exist %BIN%\*.* goto Compiled
call compile.bat

:Compiled

REM create the app directory if not present
if exist %DIR% goto AppExists
mkdir %DIR%

:AppExists

REM remove existing jar if any
if not exist %DIR%\%FILE% goto NoJar
del %DIR%\%FILE%

:NoJar

REM remove help.zip if it exists
if not exist %DIR%\%HELP% goto NoHelp
del %DIR%\%HELP%

:NoHelp

REM move the compiled files into the jar
REM jar cfm ./app/UE.jar ./source/manifest -C ./bin .
echo Creating %DIR%\%FILE% from files in %BIN%...

jar cfm %DIR%\%FILE% %MAN% -C %BIN% .

echo Creating %DIR%\%HELP% from files in %HDIR%...

REM create help archive using 7zip command line version
7za a -xr!?svn -tzip %DIR%\%HELP% %HDIR%


:Exit