#!/bin/bash

DIR="./app"
FILE="UE.jar"
HELP="help.zip"
MAN="./source/manifest"
BIN="./bin"
HDIR="./help"

# check for the bin dir
if [ ! -d $BIN ]; then
	echo "Error: Can not find the" $BIN "directory."
	exit
fi
if [ $(ls -1 $BIN | wc -l) == 0 ]; then
	bash ./compile.sh
fi

# create the app directory if not present
if [ ! -d $DIR ]; then
	mkdir $DIR
fi

# remove existing jar if any
rm -f $DIR/$FILE
rm -f $DIR/$HELP

# move the compiled files into the jar
# jar cfm ./app/UE.jar ./source/manifest -C ./bin .

echo "Creating $DIR/$FILE from files in $BIN..."

jar cfm $DIR/$FILE $MAN -C $BIN .

echo "Creating $DIR/$HELP from files in $HDIR..."

# create help archive
zip -rq $DIR/$HELP $HDIR $HDIR

