/**
 * Ultimate Editor
 * Copyright (C) 2009 Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: BasicScannerID.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 26.8.2010
 */

package ue.edit.exe.trek;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import ue.edit.exe.InternalSegment;
import ue.exception.InvalidArgumentsException;
import ue.util.Tools;

/**
 *
 * @author Alan
 */
public class BasicScannerID extends InternalSegment
{
    private static final byte[] test = new byte[]{(byte)0x89, (byte)0xE2, (byte)0xB8};
    private int id;

    public BasicScannerID(InputStream in) throws Exception
    {
        byte[] b3 = new byte[3];

        in.read(b3);
        checkIfValid(b3, test, true);

        b3 = new byte[4];
        in.read(b3);
        id = Tools.toInt(b3, true);
    }

    @Override
    public void save(OutputStream out) throws Exception
    {
        out.write(test);                            // 3
        out.write(Tools.toByte(id, true));          // 4
    }

    @Override
    public Vector<String> check()
    {
        Vector<String> response = new Vector<String>();
        return response;
    }

    @Override
    public long getSize()
    {
        return 7;
    }

    public void setID(int id) throws InvalidArgumentsException
    {
        if (this.id != id)
        {
            this.id = id;
            this.markChanged();
        }
    }

    public int getID() throws InvalidArgumentsException
    {
        return id;
    }
}
