/**
 * Ultimate Editor
 * Copyright (C) 2009 Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: CompareBuildingID.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 9.9.2010
 */

package ue.edit.exe.trek;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import ue.edit.exe.InternalSegment;
import ue.exception.InvalidArgumentsException;

/**
 * cmp     word ptr [eax+50h], X
 */
public class CompareBuildingID  extends InternalSegment
{
    public static byte ADDRESS_EAX = (byte)0x78;
    public static byte ADDRESS_EDX = (byte)0x7A;

    private static final byte[] test = new byte[]{(byte)0x66, (byte)0x83};
    private byte[] test2 = new byte[]{0, 0x50};

    private int id;

    public CompareBuildingID(InputStream in, byte address_register) throws Exception
    {
        byte[] b2 = new byte[2];

        in.read(b2);
        checkIfValid(b2, test, true);

        test2[0] = address_register;

        in.read(b2);
        checkIfValid(b2, test2, true);

        id = in.read();
    }

    @Override
    public void save(OutputStream out) throws Exception
    {
        out.write(test);                            // 2
        out.write(test2);                            // 2
        out.write(id);                              // 5
    }

    @Override
    public Vector<String> check()
    {
        Vector<String> response = new Vector<String>();
        return response;
    }

    @Override
    public long getSize()
    {
        return 5;
    }

    public void setID(int value) throws InvalidArgumentsException
    {
        if (value < 0 || value > 255)
            throw new InvalidArgumentsException(
                    "Building ID out of range (0 - 255): %1".replace("%1", Integer.toString(value)));

        if (this.id != value)
        {
            this.id = value;
            this.markChanged();
        }
    }

    public int getID()
    {
        return this.id;
    }
}