/**
 * Ultimate Editor
 * Copyright (C) 2009 Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: MainBldStartingIDs.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 26.8.2010
 */

package ue.edit.exe.trek;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import ue.edit.exe.InternalSegment;
import ue.util.Tools;

/**
 *
 * @author Alan
 */
public class MainBldStartingIDs extends InternalSegment
{
    private static final byte[] test = new byte[]{(byte)0xB8};

    private int[] start_id = new int[5];
    private byte[] unknown1 = new byte[32];
    private byte[] unknown2 = new byte[17];
    private byte[] unknown3 = new byte[17];
    private byte[] unknown4 = new byte[17];

    public MainBldStartingIDs(InputStream in) throws Exception
    {
        byte[] b2 = new byte[1];

        // first
        in.read(b2);
        checkIfValid(b2, test, true);
        byte[] b4 = new byte[4];
        in.read(b4);
        start_id[0] = Tools.toInt(b4, true);

        // second
        in.read(unknown1);
        in.read(b2);
        checkIfValid(b2, test, true);
        in.read(b4);
        start_id[1] = Tools.toInt(b4, true);
        
        // third
        in.read(unknown2);
        in.read(b2);
        checkIfValid(b2, test, true);
        in.read(b4);
        start_id[2] = Tools.toInt(b4, true);

        // four
        in.read(unknown3);
        in.read(b2);
        checkIfValid(b2, test, true);
        in.read(b4);
        start_id[3] = Tools.toInt(b4, true);

        // five
        in.read(unknown4);
        in.read(b2);
        checkIfValid(b2, test, true);
        in.read(b4);
        start_id[4] = Tools.toInt(b4, true);
    }

    @Override
    public void save(OutputStream out) throws Exception
    {
        out.write(test);                            // 1
        out.write(Tools.toByte(start_id[0], true)); // 5
        out.write(unknown1);                        // 37
        out.write(test);                            // 38
        out.write(Tools.toByte(start_id[1], true)); // 42
        out.write(unknown2);                        // 59
        out.write(test);                            // 60
        out.write(Tools.toByte(start_id[2], true)); // 64
        out.write(unknown3);                        // 81
        out.write(test);                            // 82
        out.write(Tools.toByte(start_id[3], true)); // 86
        out.write(unknown4);                        // 103
        out.write(test);                            // 104
        out.write(Tools.toByte(start_id[4], true)); // 108
    }

    @Override
    public Vector<String> check()
    {
        Vector<String> response = new Vector<String>();
        return response;
    }

    @Override
    public long getSize()
    {
        return 108;
    }

    public void setStartID(int empire, int id)
    {
        if (start_id[empire] != id)
        {
            start_id[empire] = id;
            this.markChanged();
        }
    }
}
