/**
 * Ultimate Editor
 * Copyright (C) 2009 Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: MartialLawBld.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 26.8.2010
 */

package ue.edit.exe.trek;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import ue.edit.exe.InternalSegment;
import ue.util.Tools;

/**
 *
 * @author Alan
 */
public class MartialLawBld extends InternalSegment
{
    private static final byte[] test = new byte[]{(byte)0x89, (byte)0xE2, (byte)0xB8};

    private int[] ID = new int[5];

    private byte[] unknown1 = new byte[7];
    private byte[] unknown2 = new byte[7];
    private byte[] unknown3 = new byte[7];
    private byte[] unknown4 = new byte[7];

    public MartialLawBld(InputStream in) throws Exception
    {
        byte[] b3 = new byte[3];

        // first
        in.read(b3);
        checkIfValid(b3, test, true);
        byte[] b4 = new byte[4];
        in.read(b4);
        ID[0] = Tools.toInt(b4, true);

        // second
        in.read(unknown1);
        in.read(b3);
        checkIfValid(b3, test, true);
        in.read(b4);
        ID[2] = Tools.toInt(b4, true);

        // third
        in.read(unknown2);
        in.read(b3);
        checkIfValid(b3, test, true);
        in.read(b4);
        ID[1] = Tools.toInt(b4, true);

        // four
        in.read(unknown3);
        in.read(b3);
        checkIfValid(b3, test, true);
        in.read(b4);
        ID[3] = Tools.toInt(b4, true);

        // five
        in.read(unknown4);
        in.read(b3);
        checkIfValid(b3, test, true);
        in.read(b4);
        ID[4] = Tools.toInt(b4, true);
    }

    @Override
    public void save(OutputStream out) throws Exception
    {
        out.write(test);                            // 3
        out.write(Tools.toByte(ID[0], true));       // 7
        out.write(unknown1);                        // 14
        out.write(test);                            // 17
        out.write(Tools.toByte(ID[2], true));       // 21
        out.write(unknown2);                        // 28
        out.write(test);                            // 31
        out.write(Tools.toByte(ID[1], true));       // 35
        out.write(unknown3);                        // 42
        out.write(test);                            // 45
        out.write(Tools.toByte(ID[3], true));       // 49
        out.write(unknown4);                        // 56
        out.write(test);                            // 59
        out.write(Tools.toByte(ID[4], true));       // 63
    }

    @Override
    public Vector<String> check()
    {
        Vector<String> response = new Vector<String>();
        return response;
    }

    @Override
    public long getSize()
    {
        return 63;
    }

    public void setID(int empire, int id)
    {
        if (ID[empire] != id)
        {
            ID[empire] = id;
            this.markChanged();
        }
    }

    public int getID(int empire)
    {
        return ID[empire];
    }
}