/**
 * Ultimate Editor
 * Copyright (C) 2005-2011 Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: MartialLawBld3.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 12.8.2011
 */

package ue.edit.exe.trek;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import ue.edit.exe.InternalSegment;

/**
 *
 */
public class MartialLawBld3 extends InternalSegment
{
    private CompareByteReg[] values = new CompareByteReg[5];

    private byte[][] unknown = new byte[5][2];

    public MartialLawBld3(InputStream in) throws Exception
    {
        for (int i = 0; i < values.length; i++)
        {
            if (i == 1)
            {
                values[2] = new CompareByteReg(in, CompareByteReg.REGISTER_DX);
            }
            else if (i == 2)
            {
                values[1] = new CompareByteReg(in, CompareByteReg.REGISTER_DX);
            }
            else
            {
                values[i] = new CompareByteReg(in, CompareByteReg.REGISTER_DX);
            }

            in.read(unknown[i]);
        }
    }

    @Override
    public void save(OutputStream out) throws Exception
    {
        for (int i = 0; i < values.length; i++)
        {
            if (i == 1)
            {
                values[2].save(out);
            }
            else if (i == 2)
            {
                values[1].save(out);
            }
            else
            {
                values[i].save(out);
            }

            out.write(unknown[i]);
        }
    }

    @Override
    public Vector<String> check()
    {
        return null;
    }

    @Override
    public long getSize()
    {
        return 30;
    }

    public void setID(int empire, short id)
    {
        values[empire].setValue(id);

        if (values[empire].madeChanges())
        {
            markChanged();
        }
    }
}