/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ue.edit.exe.trek;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import ue.edit.exe.InternalSegment;
import ue.exception.InvalidArgumentsException;

/**
 *
 */
public class PlanetBonusTypes extends InternalSegment
{
    public static final int energy = 0xE9;
    public static final int food = 0xF6;

    private static byte[] test = new byte[]{(byte)0xEE, 0x43, 0x00};

    private int[] type = new int[6];

    /**
     * @param in the InputStream to read from
     * @param address location in file
     */
    public PlanetBonusTypes(InputStream in) throws Exception
    {
        byte[] b = new byte[3];

        for (int i = 0; i < 6; i++)
        {
            type[i] = in.read();
            in.read(b);
            checkIfValid(b, test, true);
        }
    }

    /**Used to save changes.
     * @param out the OutputStream to write the file to.
     */
    @Override
    public void save(OutputStream out) throws Exception
    {
        for (int i = 0; i < 6; i++)
        {
            out.write(type[i]);
            out.write(test);
        }
    }

    /**
     * @return uncompressed size of the file.
     */
    @Override
    public long getSize()
    {
        return 24;
    }

    @Override
    public Vector<String> check()
    {
        Vector<String> response = new Vector<String>();

        for (int i = 0; i < 6; i++)
        {
            if (type[i] != energy && type[i] != food)
            {
                String msg = "Invalid planet bonus type (0x%1) for planet type ID %2.";

                msg = msg.replace("%1", Integer.toHexString(type[i]));
                msg = msg.replace("%2", Integer.toString(i + 2));

                response.add(this.getCheckIntegrityString(InternalSegment.INTEGRITY_CHECK_ERROR, msg));
            }
        }
        
        return response;
    }

    /**
     */
    public void setBonusType(int planet_type, int bonus_type) throws InvalidArgumentsException
    {
        if (bonus_type != energy && bonus_type != food)
        {
            String msg = "Invalid planet bonus type: 0x%1";

            msg = msg.replace("%1", Integer.toHexString(bonus_type));

            throw new InvalidArgumentsException(msg);
        }

        planet_type = planet_type - 2;

        if (planet_type < 0 || planet_type > 5)
        {
            String msg = "Invalid or unsupported planet type: 0x%1";

            msg = msg.replace("%1", Integer.toString(planet_type + 2));

            throw new InvalidArgumentsException(msg);
        }

        if (type[planet_type] != bonus_type)
        {
            type[planet_type] = bonus_type;
            this.markChanged();
        }
    }

    /**
     * @return
     */
    public int getBonusType(int planet_type) throws InvalidArgumentsException
    {
        planet_type = planet_type - 2;

        if (planet_type < 0 || planet_type > 5)
        {
            return energy;
        }

        return type[planet_type];
    }
}
