/**
 * Ultimate Editor (dev)
 * Copyright (C) 2009 Alan Podlesek
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * File: PunyFarms.java
 * 
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 * 
 * Created: 13.2.2009
 */
package ue.edit.exe.trek;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;

import ue.edit.exe.InternalSegment;
import ue.util.Tools;

/**
 * @author Alan Podlesek
 */
public class PunyFarms extends InternalSegment
{
    private static byte[] TEST_MOV_EAX = new byte[]{(byte)0xB8};

    private int FARM_ID[] = new int[5];
    private int UNKNOWN_1;
    private byte[] UNKNOWN_2 = new byte[33];
    private byte[] UNKNOWN_3 = new byte[18];
    private byte[] UNKNOWN_4 = new byte[18];
    private byte[] UNKNOWN_5 = new byte[18];
    
    public PunyFarms(InputStream in) throws Exception
    {
        byte[] b = new byte[4];
        
        UNKNOWN_1 = in.read(); //1
        checkIfValid(new byte[]{(byte)UNKNOWN_1}, TEST_MOV_EAX, true);
        in.read(b); // 5
        FARM_ID[0] = Tools.toInt(b, true);
        in.read(UNKNOWN_2); // 38
        this.testLastBytes(UNKNOWN_2, TEST_MOV_EAX, true);
        in.read(b); // 42
        FARM_ID[1] = Tools.toInt(b, true);
        in.read(UNKNOWN_3); // 60
        this.testLastBytes(UNKNOWN_3, TEST_MOV_EAX, true);
        in.read(b); // 64
        FARM_ID[2] = Tools.toInt(b, true);
        in.read(UNKNOWN_4); // 82
        this.testLastBytes(UNKNOWN_4, TEST_MOV_EAX, true);
        in.read(b); // 86
        FARM_ID[3] = Tools.toInt(b, true);
        in.read(UNKNOWN_5); // 104
        this.testLastBytes(UNKNOWN_5, TEST_MOV_EAX, true);
        in.read(b); // 108
        FARM_ID[4] = Tools.toInt(b, true);
    }
    
    /* (non-Javadoc)
     * @see ue.edit.InternalFile#check()
     */
    @Override
    public Vector<String> check()
    {
        Vector<String> ret = new Vector<String>();
        // check if buildings can be build by specified empire
        
        return ret;
    }

    /* (non-Javadoc)
     * @see ue.edit.InternalFile#getSize()
     */
    @Override
    public long getSize()
    {
        return 108;
    }

    public void setPunyFarm(int empire, int farm_id)
    {
        if (FARM_ID[empire] == farm_id)
        {
            return;
        }
        FARM_ID[empire] = farm_id;
        this.markChanged();
    }

    public int getPunyFarm(int empire)
    {
        return FARM_ID[empire];
    }

    /* (non-Javadoc)
     * @see ue.edit.InternalFile#save(java.io.OutputStream)
     */
    @Override
    public void save(OutputStream out) throws Exception
    {
        out.write(UNKNOWN_1);
        out.write(Tools.toByte(FARM_ID[0], true));
        out.write(UNKNOWN_2);
        out.write(Tools.toByte(FARM_ID[1], true));
        out.write(UNKNOWN_3);
        out.write(Tools.toByte(FARM_ID[2], true));
        out.write(UNKNOWN_4);
        out.write(Tools.toByte(FARM_ID[3], true));
        out.write(UNKNOWN_5);
        out.write(Tools.toByte(FARM_ID[4], true));
    }
    
}
