/**
 * Ultimate Editor
 * Copyright (C) 2005-2010 Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: PushInt.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 21.9.2010
 */

package ue.edit.exe.trek;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import ue.edit.exe.InternalSegment;
import ue.util.Tools;

/**
 *
 */
public class PushInt extends InternalSegment
{
    private static final byte[] test = new byte[]{(byte)0x68};

    private int value;

    public PushInt(InputStream in) throws Exception
    {
        byte[] b = new byte[1];
        in.read(b);
        checkIfValid(b, test, true);

        b = new byte[4];
        in.read(b);
        value = Tools.toInt(b, true);
    }

    @Override
    public void save(OutputStream out) throws Exception
    {
        out.write(test);
        out.write(Tools.toByte(value, true));
    }

    @Override
    public Vector<String> check()
    {
        return null;
    }

    @Override
    public long getSize()
    {
        return 5;
    }

    public void setValue(int value)
    {
        if (this.value != value)
        {
            this.value = value;
            this.markChanged();
        }
    }
}