/**
 * Ultimate Editor
 * Copyright (C) 2005-2011 Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: MartialLawBld.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 12.8.2011
 */

package ue.edit.exe.trek;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import ue.edit.exe.InternalSegment;

/**
 *
 */
public class ShipyardBldIDs extends InternalSegment
{
    private static final byte[] test = new byte[]{(byte)0xC3};

    private MovIntToReg[] values;

    public ShipyardBldIDs(InputStream in) throws Exception
    {
        values = new MovIntToReg[6];
        byte[] b = new byte[1];

        for (int i = 0; i < values.length; i++)
        {
            values[i] = new MovIntToReg(MovIntToReg.EAX, in);
            in.read(b);
            checkIfValid(b, test, true);
        }
    }

    @Override
    public void save(OutputStream out) throws Exception
    {
        for (int i = 0; i < values.length; i++)
        {
            values[i].save(out);
            out.write(test);
        }
    }

    @Override
    public Vector<String> check()
    {
        return null;
    }

    @Override
    public long getSize()
    {
        return 36;
    }

    public void setID(int empire, int id)
    {
        values[empire].setValue(id);

        if (values[empire].madeChanges())
        {
            markChanged();
        }
    }

    public int getID(int empire)
    {
        return values[empire].getValue();
    }
}