/**
 * Ultimate Editor for Birth Of The Federation 1.02
 * Copyright (C) 2005-2008  Alan Podlesek
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *      
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *      
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * File: ResFile.java
 * 
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *      
 * Last modified: 18.9.2008
 */

package ue.edit.res;

//import list
import java.io.*;
import java.security.MessageDigest;

import ue.edit.mod.*;
import ue.edit.*;

public abstract class ResFile implements CanBeEdited
{
    public ModList MODS;
    
    @Override
    public byte[] getInternalFileHash(String filename) throws Exception
    {
        MessageDigest m = MessageDigest.getInstance("MD5"); //$NON-NLS-1$

        ByteArrayOutputStream baos = new ByteArrayOutputStream();

        InternalFile file = this.getInternalFile(filename, false);
        file.save(baos);

        m.update(baos.toByteArray(), 0, baos.size());
        baos.close();
        
        return m.digest();
    }
}