/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: ModFiles.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.edit.res.stbof.sst;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;

import ue.Language;
import ue.util.Tools;

/**Reprisents a ship in shiplist.sst.*/
public class Ship implements Comparable<Ship>{
	//[rights] [type] [name]                //[length] 	-	[ends at] [comment]
	public String NAME;                     //040 		- 	040
	public String CLASS;                    //044 		- 	084
	public int DESCRIPTION;                 //004 		- 	088
	public String GRAPHICS;                 //014 		- 	102
	public short ID;                        //002 		-	104
	public short SHIP_TYPE;                 //002 		-	106
	public short SHIPNAME_GROUP;            //002 		- 	108
	public int BEAM_ACCURACY;               //004 		- 	112
	public int BEAM_NUMBER;                 //004 		- 	116
	public int BEAM_MULTIPLIER;             //004 		- 	120
	public int BEAM_DAMAGE;                 //004 		- 	124
	public int SHIELD_PENETRATION;          //004 		- 	128
	public int TORP_ACCURACY;               //004 		- 	132
	public int TORP_NUMBER;                 //004 		- 	136
	public int TORP_MULTIPLIER;             //004 		- 	140
	public int TORP_DAMAGE;                 //004 		-	144
	public int SHIELD_LEVEL;                //004 		-	148
	public int SHIELD_STRENGTH;             //004 		-	152
	public int SHIELD_RECHARGE;             //004 		- 	156
	private byte[] UNKNOWN_1 = new byte[12];//012       -   168
	public int HULL_STRENGTH;               //004 		-	172
	public int DEFENSE;                     //004		-	176
	public int CLOAK_LVL;                   //004		-	180
	private byte[] UNKNOWN_2 = new byte[4];	//004       -   184 shared exp multiplier?			integer 1
	private byte[] UNKNOWN_3 = new byte[4];	//004       -   188 smt to do with shared exp?			integer 150
	private byte[] UNKNOWN_4 = new byte[4];	//004       -   192 smt to do with shared exp?			integer 8
	private byte[] UNKNOWN_5 = new byte[4];	//004       -   196 smt to do with shared exp?			integer 80
	private byte[] UNKNOWN_6 = new byte[4];	//004       -   200 smt to do with shared exp?			integer 12
	private byte[] UNKNOWN_7 = new byte[4];	//004       -   204 smt to do with shared exp? a multiplier?	integer 1
	private byte[] UNKNOWN_8 = new byte[8];	//008       -   212 0						double?
	public double AGILITY;                  //008		-	220
	public double BEAM_MIN_RANGE;	        //008 		-	228
	public double BEAM_MAX_RANGE;	        //008 		- 	236
	public double TORP_MIN_RANGE;	        //008 		- 	244
	public double TORP_MAX_RANGE;	        //008 		- 	252
	private byte[] UNKNOWN_14 = new byte[8];//008       -   260 shared exp range?				double 350
	public double MAP_RANGE;                //008 		- 	268
	public double MAP_SPEED;                //008 		- 	276
	public int SCAN_RANGE;                  //002 		- 	278 unsigned short!
	public int PRODUCTION;                  //002 		- 	280 unsigned short!
	public short RACE;                      //002 		- 	282
	public char PHASER_PREFIX;              //001       -   283
	public char TORPEDO_PREFIX;             //001       -   284
	public int BUILD_COST;                  //002 		- 	286 unsigned short!
	public int MAINTENANCE;                 //002 		- 	288 unsigned short!
	
	public short RACE_OVERRIDE; 	// this is not part of ship data, but is used for overriding ship race
	
	public Ship(InputStream in) throws Exception{
		//name and class 0-84
		byte[] b = new byte[84];
		in.read(b);
		NAME = Tools.toASCII(b, 0, 40);
		CLASS = Tools.toASCII(b, 40, 44);
		//description 84-88
		b = new byte[4];
		in.read(b);
		DESCRIPTION = Tools.toInt(b, true);
		//graphics 88-102
		b = new byte[14];
		in.read(b);
		GRAPHICS = Tools.toASCII(b).toLowerCase();
		//id 102-104
		b = new byte[2];
		in.read(b);
		ID = Tools.toShort(b, true);
		//ship type / function 104-106
		in.read(b);
		SHIP_TYPE = Tools.toShort(b, true);
		//shipname group used 106-108
		in.read(b);
		SHIPNAME_GROUP = Tools.toShort(b, true);
		//beam accuracy 108-112
		b = new byte[4];
		in.read(b);
		BEAM_ACCURACY = Tools.toInt(b, true);
		//beam number112-116
		in.read(b);
		BEAM_NUMBER = Tools.toInt(b, true);
		//beam multiplier / takes effect after hitting shields (effects only hull) 116-120
		in.read(b);
		BEAM_MULTIPLIER = Tools.toInt(b, true);
		//beam damage 120-124
		in.read(b);
		BEAM_DAMAGE = Tools.toInt(b, true);
		//beam shield penetration 124-128
		in.read(b);
		SHIELD_PENETRATION = Tools.toInt(b, true);
		//torpedo accuracy 128-132
		b = new byte[4];
		in.read(b);
		TORP_ACCURACY = Tools.toInt(b, true);
		//torpedo number 132-136
		in.read(b);
		TORP_NUMBER = Tools.toInt(b, true);
		//torpedo multiplier 136-140
		in.read(b);
		TORP_MULTIPLIER = Tools.toInt(b, true);
		//torpedo damage 140-144
		in.read(b);
		TORP_DAMAGE = Tools.toInt(b, true);
		//shield level 144-148
		in.read(b);
		SHIELD_LEVEL = Tools.toInt(b, true);
		//shield strength 148-152
		b = new byte[4];
		in.read(b);
		SHIELD_STRENGTH = Tools.toInt(b, true);
		//shield recharge 152-156
		in.read(b);
		SHIELD_RECHARGE = Tools.toInt(b, true);
		//unknown 156-168
		in.read(UNKNOWN_1);
		//hull strength 168-172
		b = new byte[4];
		in.read(b);
		HULL_STRENGTH = Tools.toInt(b, true);
		//defense 172-176
		in.read(b);
		DEFENSE = Tools.toInt(b, true);
		//cloak 176-180
		in.read(b);
		CLOAK_LVL = Tools.toInt(b, true);
		//shared experience multiplier ??????????????? 180-184
		in.read(UNKNOWN_2);
		//unknown 184-188
		in.read(UNKNOWN_3);
		//unknown 188-192
		in.read(UNKNOWN_4);
		//unknown 192-196
		in.read(UNKNOWN_5);
		//unknown 196-200
		in.read(UNKNOWN_6);
		//unknown 200-204
		in.read(UNKNOWN_7);
		//unknown 204-212
		in.read(UNKNOWN_8);
		//agility 212-220
		b = new byte[8];
		in.read(b);
		AGILITY = Tools.toDouble(b, true);
		//beam min range 220-228
		in.read(b);
		BEAM_MIN_RANGE = Tools.toDouble(b, true);
		//beam max range 228-236
		in.read(b);
		BEAM_MAX_RANGE = Tools.toDouble(b, true);
		//torpedo min range 236-244
		in.read(b);
		TORP_MIN_RANGE = Tools.toDouble(b, true);
		//torpedo max range 244-252
		in.read(b);
		TORP_MAX_RANGE = Tools.toDouble(b, true);
		//shared experience range ??????????????? 252-260
		in.read(UNKNOWN_14);
		//map range 260-268
		b = new byte[8];
		in.read(b);
		MAP_RANGE = Tools.toDouble(b, true);
		//map speed 268-276
		in.read(b);
		MAP_SPEED = Tools.toDouble(b, true);
		//scan range 276-278
		byte[] v = new byte[4];
		v[0] = (byte)in.read();
		v[1] = (byte)in.read();
		SCAN_RANGE = Tools.toInt(v, true);
		//production 278-280
		v[0] = (byte)in.read();
		v[1] = (byte)in.read();
		PRODUCTION = Tools.toInt(v, true);
		//race 280-282
		b = new byte[2];
		in.read(b);
		RACE = Tools.toShort(b, true);
		RACE_OVERRIDE = RACE;
		//phaser prefix 282-283
		PHASER_PREFIX = (char)in.read();
		//unknown 283-284
        TORPEDO_PREFIX = (char)in.read();
		//built cost 284-286
		v[0] = (byte)in.read();
		v[1] = (byte)in.read();
		BUILD_COST = Tools.toInt(v, true);
		//maintenance 286-288
		v[0] = (byte)in.read();
		v[1] = (byte)in.read();
		MAINTENANCE = Tools.toInt(v, true);
		
		//System.out.println(ID + ":" + NAME + ":" + SHARED_XP_u);
		//System.out.println(ID + ":" + NAME + ":" + Convert.toInt(UNKNOWN_4, true));
		//System.out.println(ID + ":" + NAME + ":" + Convert.toLong(UNKNOWN_8, true) + ":" + Convert.toDouble(UNKNOWN_9, true));
		//System.out.println(RACE);
		//if (RACE == 35) System.out.println("hohoho: " + NAME);
		//if (ID == 10) CLOAK_LVL = 6;
	}
	
	/**Saves changes.
	@return true if save has been successful.
	@throws Exception the function may throw an exception if an error occures.*/
	public void save(OutputStream out) throws Exception{
		//name and class
		out.write(Tools.toByte(NAME, 40, 39));
		out.write(Tools.toByte(CLASS, 44, 43));
		//description
		out.write(Tools.toByte(DESCRIPTION, true));
		//graphics
		out.write(Tools.toByte(GRAPHICS, 14, 13));
		//id
		out.write(Tools.toByte(ID, true));
		//ship type / function
		out.write(Tools.toByte(SHIP_TYPE, true));
		//shipname group used
		out.write(Tools.toByte(SHIPNAME_GROUP, true));
		//beam accuracy
		out.write(Tools.toByte(BEAM_ACCURACY, true));
		//beam number
		out.write(Tools.toByte(BEAM_NUMBER, true));
		//beam multiplier / takes effect after hitting shields (effects only hull)
		out.write(Tools.toByte(BEAM_MULTIPLIER, true));
		//beam damage
		out.write(Tools.toByte(BEAM_DAMAGE, true));
		//beam shield penetration
		out.write(Tools.toByte(SHIELD_PENETRATION, true));
		//torpedo accuracy
		out.write(Tools.toByte(TORP_ACCURACY, true));
		//torpedo number
		out.write(Tools.toByte(TORP_NUMBER, true));
		//torpedo multiplier
		out.write(Tools.toByte(TORP_MULTIPLIER, true));
		//torpedo damage
		out.write(Tools.toByte(TORP_DAMAGE, true));
		//torpedo shield penetration
		out.write(Tools.toByte(SHIELD_LEVEL, true));
		//shield strength
		out.write(Tools.toByte(SHIELD_STRENGTH, true));
		//shield recharge
		out.write(Tools.toByte(SHIELD_RECHARGE, true));
		//unknown
		out.write(UNKNOWN_1);
		//hull strength
		out.write(Tools.toByte(HULL_STRENGTH, true));
		//defense
		out.write(Tools.toByte(DEFENSE, true));
		//cloak
		out.write(Tools.toByte(CLOAK_LVL, true));
		//shared experience multi??????????
		out.write(UNKNOWN_2);
		//unknown
		out.write(UNKNOWN_3);
		//unknown
		out.write(UNKNOWN_4);
		//unknown
		out.write(UNKNOWN_5);
		//unknown
		out.write(UNKNOWN_6);
		//unknown
		out.write(UNKNOWN_7);
		//unknown
		out.write(UNKNOWN_8);
		//agility
		out.write(Tools.toByte(AGILITY, true));
		//beam min range
		out.write(Tools.toByte(BEAM_MIN_RANGE, true));
		//beam max range
		out.write(Tools.toByte(BEAM_MAX_RANGE, true));
		//torp min range
		out.write(Tools.toByte(TORP_MIN_RANGE, true));
		//torp max range
		out.write(Tools.toByte(TORP_MAX_RANGE, true));
		//shared experience range ???????????????????
		out.write(UNKNOWN_14);
		//map range
		out.write(Tools.toByte(MAP_RANGE, true));
		//map speed
		out.write(Tools.toByte(MAP_SPEED, true));
		//scan range
		byte[] v = Tools.toByte(SCAN_RANGE, true);
		out.write(v[0]);
		out.write(v[1]);
		//production
		v = Tools.toByte(PRODUCTION, true);
		out.write(v[0]);
		out.write(v[1]);
		//race
		out.write(Tools.toByte(RACE_OVERRIDE, true));
        // phaser prefix (works only if the appropriate trek.exe patch is applied)
		out.write(PHASER_PREFIX);
        // torpedo prefix (works only if the appropriate trek.exe patch is applied)
		out.write(TORPEDO_PREFIX);
		//built cost
		v = Tools.toByte(BUILD_COST, true);
		out.write(v[0]);
		out.write(v[1]);
		//maintenance
		v = Tools.toByte(MAINTENANCE, true);
		out.write(v[0]);
		out.write(v[1]);
	}
	/**This function checks the file for known problems/errors that may occur while editing the file.
	@return a Vector object containing results of the check as Strings.*/
	public Vector<String> check(String name){
		Vector<String> response = new Vector<String>();
		String msg;
		
		if (NAME.length()>39){
			msg = Language.getString("Ship.0"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			response.add(msg);
		}
		if (CLASS.length()>43){
			msg = Language.getString("Ship.1"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", CLASS); //$NON-NLS-1$
			response.add(msg);
		}
		if (DESCRIPTION<0){
			msg = Language.getString("Ship.2"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(DESCRIPTION)); //$NON-NLS-1$
			response.add(msg);
		}
		if (GRAPHICS.length()>13){
			msg = Language.getString("Ship.3"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", GRAPHICS); //$NON-NLS-1$
			response.add(msg);
		}
		if (SHIP_TYPE<0 || SHIP_TYPE>9){
			msg = Language.getString("Ship.4"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(SHIP_TYPE)); //$NON-NLS-1$
			response.add(msg);
		}
		if (SHIPNAME_GROUP<0 || SHIPNAME_GROUP>61){
			msg = Language.getString("Ship.5"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(SHIPNAME_GROUP)); //$NON-NLS-1$
			response.add(msg);
		}
		if (BEAM_ACCURACY<0){
			msg = Language.getString("Ship.6"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(BEAM_ACCURACY)); //$NON-NLS-1$
			response.add(msg);
		}
		if (BEAM_NUMBER<0){
			msg = Language.getString("Ship.7"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(BEAM_NUMBER)); //$NON-NLS-1$
			response.add(msg);
		}
		if (BEAM_DAMAGE<0){
			msg = Language.getString("Ship.8"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(BEAM_DAMAGE)); //$NON-NLS-1$
			response.add(msg);
		}
		if (TORP_ACCURACY<0){
			msg = Language.getString("Ship.9"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(TORP_ACCURACY)); //$NON-NLS-1$
			response.add(msg);
		}
		if (TORP_NUMBER<0){
			msg = Language.getString("Ship.10"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(TORP_NUMBER)); //$NON-NLS-1$
			response.add(msg);
		}
		if (TORP_DAMAGE<0){
			msg = Language.getString("Ship.11"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(TORP_DAMAGE)); //$NON-NLS-1$
			response.add(msg);
		}
		if (SHIELD_STRENGTH<0){
			msg = Language.getString("Ship.12"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(SHIELD_STRENGTH)); //$NON-NLS-1$
			response.add(msg);
		}
		if (SHIELD_RECHARGE<0){
			msg = Language.getString("Ship.13"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(SHIELD_RECHARGE)); //$NON-NLS-1$
			response.add(msg);
		}
		if (HULL_STRENGTH<0){
			msg = Language.getString("Ship.14"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(HULL_STRENGTH)); //$NON-NLS-1$
			response.add(msg);
		}
		if (DEFENSE<0){
			msg = Language.getString("Ship.15"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(DEFENSE)); //$NON-NLS-1$
			response.add(msg);
		}
		if (CLOAK_LVL<0 || CLOAK_LVL>6){
			msg = Language.getString("Ship.16"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(CLOAK_LVL)); //$NON-NLS-1$
			response.add(msg);
		}
		if (MAP_RANGE<-1 || MAP_RANGE>3){
			msg = Language.getString("Ship.17"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Double.toString(MAP_RANGE)); //$NON-NLS-1$
			response.add(msg);
		}
		if (MAP_SPEED<-1){
			msg = Language.getString("Ship.18"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Double.toString(MAP_SPEED)); //$NON-NLS-1$
			response.add(msg);
		}
		if (SCAN_RANGE<0){
			msg = Language.getString("Ship.19"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(SCAN_RANGE)); //$NON-NLS-1$
			response.add(msg);
		}
		if (PRODUCTION<0 || PRODUCTION>65535){
			msg = Language.getString("Ship.20"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(PRODUCTION)); //$NON-NLS-1$
			response.add(msg);
		}
		if (RACE<0 || RACE>36){
			msg = Language.getString("Ship.21"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(RACE)); //$NON-NLS-1$
			response.add(msg);
		}
		if (BUILD_COST<0 || BUILD_COST>65535){
			msg = Language.getString("Ship.22"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(BUILD_COST)); //$NON-NLS-1$
			response.add(msg);
		}
		if (MAINTENANCE<0 || MAINTENANCE>65535){
			msg = Language.getString("Ship.23"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(MAINTENANCE)); //$NON-NLS-1$
			response.add(msg);
		}
		if (TORP_MIN_RANGE<0 || TORP_MAX_RANGE<0){
			msg = Language.getString("Ship.24"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", "(" + TORP_MIN_RANGE + "," + TORP_MAX_RANGE + ")"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			response.add(msg);
		}
		if (BEAM_MIN_RANGE<0 || BEAM_MAX_RANGE<0){
			msg = Language.getString("Ship.25"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", "(" + BEAM_MIN_RANGE + "," + BEAM_MAX_RANGE + ")"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			response.add(msg);
		}
		if (AGILITY<0){
			msg = Language.getString("Ship.26"); //$NON-NLS-1$
			msg = msg.replace("%1", name); //$NON-NLS-1$
			msg = msg.replace("%2", NAME); //$NON-NLS-1$
			msg = msg.replace("%3", Double.toString(AGILITY)); //$NON-NLS-1$
			response.add(msg);
		}
		return response;
	}
	@Override
	public boolean equals(Object o){
		if (!(o instanceof Ship)) {
			return false;
		}
		Ship gu = (Ship)o;
		return hashCode()==gu.hashCode();
	}
	/**Returns the file's hashcode.*/
	@Override
	public int hashCode(){
		return ((RACE*6000)+ID);
	}
    @Override
	public int compareTo(Ship obj){
		return (hashCode() - obj.hashCode());
	}

    /* Creates a copy of the provided ship */
	public Ship(Ship ship) throws Exception{
		NAME = new String(ship.NAME);
		DESCRIPTION = ship.DESCRIPTION;
		GRAPHICS = new String(ship.GRAPHICS);
        CLASS = new String(ship.CLASS);
		ID = -1;
		SHIP_TYPE = ship.SHIP_TYPE;
		SHIPNAME_GROUP = ship.SHIPNAME_GROUP;
		BEAM_ACCURACY = ship.BEAM_ACCURACY;
		BEAM_NUMBER = ship.BEAM_NUMBER;
		BEAM_MULTIPLIER = ship.BEAM_MULTIPLIER;
		BEAM_DAMAGE = ship.BEAM_DAMAGE;
		SHIELD_PENETRATION = ship.SHIELD_PENETRATION;
		TORP_ACCURACY = ship.TORP_ACCURACY;
		TORP_NUMBER = ship.TORP_NUMBER;
		TORP_MULTIPLIER = ship.TORP_MULTIPLIER;
		TORP_DAMAGE = ship.TORP_DAMAGE;
		SHIELD_LEVEL = ship.SHIELD_LEVEL;
		SHIELD_STRENGTH = ship.SHIELD_STRENGTH;
		SHIELD_RECHARGE = ship.SHIELD_RECHARGE;
		UNKNOWN_1 = ship.UNKNOWN_1; // <- this isn't going to be changed anyway
		HULL_STRENGTH = ship.HULL_STRENGTH;
		DEFENSE = ship.DEFENSE;
		CLOAK_LVL = ship.CLOAK_LVL;
		UNKNOWN_2 = ship.UNKNOWN_2; // <- this isn't going to be changed anyway
		UNKNOWN_3 = ship.UNKNOWN_3; // <- this isn't going to be changed anyway
		UNKNOWN_4 = ship.UNKNOWN_4; // <- this isn't going to be changed anyway
		UNKNOWN_5 = ship.UNKNOWN_5; // <- this isn't going to be changed anyway
		UNKNOWN_6 = ship.UNKNOWN_6; // <- this isn't going to be changed anyway
		UNKNOWN_7 = ship.UNKNOWN_7; // <- this isn't going to be changed anyway
		UNKNOWN_8 = ship.UNKNOWN_8; // <- this isn't going to be changed anyway
		AGILITY = ship.AGILITY;
		BEAM_MIN_RANGE = ship.BEAM_MIN_RANGE;
		BEAM_MAX_RANGE = ship.BEAM_MAX_RANGE;
		TORP_MIN_RANGE = ship.TORP_MIN_RANGE;
		TORP_MAX_RANGE = ship.TORP_MAX_RANGE;
		UNKNOWN_14 = ship.UNKNOWN_14; // <- this isn't going to be changed anyway
		MAP_RANGE = ship.MAP_RANGE;
		MAP_SPEED = ship.MAP_SPEED;
		SCAN_RANGE = ship.SCAN_RANGE;
		PRODUCTION = ship.PRODUCTION;
		RACE = ship.RACE;
		PHASER_PREFIX = ship.PHASER_PREFIX;
		TORPEDO_PREFIX = ship.TORPEDO_PREFIX;
		BUILD_COST = ship.BUILD_COST;
		MAINTENANCE = ship.MAINTENANCE;
		RACE_OVERRIDE = ship.RACE_OVERRIDE;
	}
}