/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: ShipRace.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.edit.res.stbof.sst;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;

import ue.edit.InternalFile;
import ue.util.Tools;

/**Represents shiprace.sst. It was previously thought the file contains the first id of a ship of each race. But it seems they aren't id's at all, but offsets in shiplist.sst. */
public class ShipRace extends InternalFile{
	private int[] SHIP_START = null;
	
	public ShipRace(InputStream in) throws Exception{
		byte[] b = new byte[4];
		SHIP_START = new int[in.available()/4];
		int i=0;
		while (in.available()>0){
			in.read(b);
			SHIP_START[i++] = Tools.toInt(b, true);
		}
	}
	
	/**Saves changes.
	@return true if save has been successful.
	@throws Exception the function may throw an exception if an error occures.*/
	@Override
	public void save(OutputStream out) throws Exception{
		for (int i=0; i<SHIP_START.length; i++){
			out.write(Tools.toByte(SHIP_START[i], true));
		}
	}
	/**This function checks the file for known problems/errors that may occur while editing the file.
	@return a Vector object containing results of the check as Strings.*/
	@Override
	public Vector<String> check(){
		Vector<String> response = new Vector<String>();
		return response;
	}
	/**Used to get the uncompressed size of the file.**/
	@Override
	public long getSize(){
		long size = SHIP_START.length*4;
		return size;
	}
	/**Set ships starting id's*/
	public void setShipStarts(int[] sh){
		if (sh.length!=SHIP_START.length){
			SHIP_START = sh;
                        this.markChanged();
		}else{
			for (int i=0; i<sh.length; i++){
				if (sh[i]!=SHIP_START[i]){
					SHIP_START[i]=sh[i];
                                        this.markChanged();
				}
			}
		}
	}
}
