/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: TdbEntry.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.edit.res.stbof.tdb;

import java.io.IOException;
import java.io.OutputStream;

import ue.util.Tools;

/**This class reprisents entry map data of a *.tdb file.*/
public class TdbEntry implements Comparable<TdbEntry>{
	private byte[] UNKNOWN_1 = new byte[4];
	/**The length of the string.*/
	public int LENGTH;
	private byte[] UNKNOWN_2 = new byte[4];
	/**The starting position of the string.*/
	public int START_POS;
	public String STR;
	
	/**Constructor.*/
	public TdbEntry(byte[] b){
		//unknown
		for (int i=0; i<4; i++) {
			UNKNOWN_1[i]=b[i];
		}
		//length
		byte[] g = new byte[4];
		for (int i=0; i<4; i++) {
			g[i]=b[i+4];
		}
		LENGTH = Tools.toInt(g, true);
		//unknown
		for (int i=0; i<4; i++) {
			UNKNOWN_2[i]=b[i+8];
		}
		//start pos
		for (int i=0; i<4; i++) {
			g[i]=b[i+12];
		}
		START_POS = Tools.toInt(g, true);
	}
	/**Dumps data to the OutputStream.*/
	public void dump(OutputStream out) throws IOException{
		out.write(UNKNOWN_1);
		out.write(Tools.toByte(LENGTH, true));
		out.write(UNKNOWN_2);
		out.write(Tools.toByte(START_POS, true));
	}
	@Override
	public boolean equals(Object o){
		if (!(o instanceof TdbEntry)) {
			return false;
		}
		return (hashCode()==o.hashCode());
	}
	/**Returns the file's hashcode.*/
	@Override
	public int hashCode(){
		return START_POS;
	}
	public int compareTo(TdbEntry obj){
		return (hashCode() - obj.hashCode());
	}
}
