/**
 * Ultimate Editor for Birth Of The Federation 1.02
 * Copyright (C) 2005-2011  Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: WDFPictureBox.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 31.8.2011
 */

package ue.edit.res.stbof.wdf;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import ue.util.Tools;

/**
 *
 */
public class WDFPictureBox extends WDFWidget
{
    protected int unknown1;

    public WDFPictureBox(InputStream in) throws IOException
    {
        super(WDFWidget.TYPE_PICTUREBOX, in);

        byte[] b4 = new byte[4];

        in.read(b4);
        unknown1 = Tools.toInt(b4, true);
    }

    @Override
    public void save(OutputStream out) throws IOException
    {
        super.save(out);

        out.write(Tools.toByte(unknown1, true)); // 4
    }

    @Override
    public long getSize()
    {
        return super.getSize() + 4;
    }

    @Override
    public String toString()
    {
        return "Widget: Type: " + typeID + " Size: " + getSize() + " Files: "
                + this.backgroundImage;
    }

    public int getUnknown1() {
        return unknown1;
    }

    public boolean setUnknown1(int unknown1) {
        if (this.unknown1 != unknown1)
        {
            this.unknown1 = unknown1;
            return true;
        }
        return false;
    }
}
