/**
 * Ultimate Editor for Birth Of The Federation 1.02
 * Copyright (C) 2005-2011  Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: WindowDefinitionFile.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 30.7.2011
 */

package ue.edit.res.stbof.wdf;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import ue.UE;
import ue.edit.InternalFile;
import ue.util.Tools;

/**
 *
 */
public class WindowDefinitionFile extends InternalFile
{
    private int type;
    protected WDFWindow window;

    public WindowDefinitionFile(InputStream in) throws IOException
    {
        byte[] b4 = new byte[4];
        in.read(b4);
        type = Tools.toInt(b4, true);

        int widgetType;
        
        in.read(b4);
        widgetType = Tools.toInt(b4, true);

        window = new WDFWindow(in);

        if (UE.DEBUG_MODE)
        {
            System.out.println("Read root: " + window);
        }
    }

    @Override
    public void save(OutputStream out) throws Exception
    {
        out.write(Tools.toByte(type, true));

        window.save(out);
    }

    @Override
    public Vector<String> check()
    {
        // TODO: add integrity checking
        return null;
    }

    @Override
    public long getSize()
    {
        return 4 + window.getSize();
    }

    public WDFWindow getWindow()
    {
        return window;
    }
}
