/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: SavOutputStream.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.edit.sav;

import java.io.IOException;
import java.io.OutputStream;

import ue.exception.SavException;

/** This OutputStream encapsulates OutputStream.
 *  Used to count size of written data. */
public class SavOutputStream extends OutputStream{
	private OutputStream RAN;
	private int ende = 0;
	private int subentries = 1;
	/**Constructor.*/
	public SavOutputStream(OutputStream raf, int entries) throws IOException{
		RAN = raf;
		subentries = entries;
	}
	
	@Override
	public void close() throws IOException{
		RAN.flush();
	}
	@Override
	public void flush() throws IOException{
		if (RAN!=null) {
			RAN.flush();
		}
	}
	
	@Override
	public void write(byte[] b) throws IOException{
		ende += b.length;
		RAN.write(b);
	}
	@Override
	public void write(byte[] b, int off, int len) throws IOException{
		ende += len;
		RAN.write(b, off, len);
	}
	@Override
	public void write(int b) throws IOException{
		ende++;
		RAN.write(b);
	}
	public int getLength() throws SavException{
		return ende;
	}

	public int getSubEntries() {
		return subentries;
	}
	
	public void setSubEntries(int num) {
		subentries = num;
	}

}
