/*
 * Ultimate Editor for Birth Of The Federation 1.02
 * Copyright (C) 2005-2007  Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *
 * File: Result.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Last modified: 15.5.2010
 */

package ue.edit.sav.lst;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Vector;
import ue.edit.InternalFile;
import ue.edit.sav.SavSubEntry;

/**
 *
 * @author Alan Podlesek
 */
public class Result extends InternalFile
{
    private ArrayList<SavSubEntry> entries = new ArrayList<SavSubEntry>();

    public Result(InputStream in) throws IOException
    {
        /*
        File work_dir = new File(UE.SETTINGS.getProperty(SettingsManager.WORK_PATH));

        while (!work_dir.isDirectory())
        {
            work_dir = work_dir.getParentFile();
        }

        File out;
        FileOutputStream fos;*/
        SavSubEntry sse;
//        int i = 0;

        while (in.available() > 0)
        {
            sse = new SavSubEntry(in, false);
            entries.add(sse);
/*
            out = new File(work_dir, i + ".sse");
            fos = new FileOutputStream(out);
            sse.store(fos);
            fos.close();
            i++;*/
        }


    }

    @Override
    public void save(OutputStream out) throws Exception
    {
        for (SavSubEntry s : entries)
        {
            s.store(out);
        }
    }

    @Override
    public Vector<String> check()
    {
        return new Vector<String>();
    }

    @Override
    public long getSize()
    {
        long size = 0;
        for (SavSubEntry s : entries)
        {
            size += s.getSize();
        }
        return size;
    }
}
