/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: SndEntry.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.edit.snd;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import ue.Language;
import ue.util.Tools;

public class SndEntry{
	public int ADDRESS;
	public int SIZE;
	public int FRAMES;
	public int UNKNOWN;
	public SndEntry(){
		ADDRESS=0;
		SIZE=0;
		FRAMES=0;
		UNKNOWN=0;
	}
	public SndEntry(InputStream in) throws IOException{
		byte[] b = new byte[4];
		in.read(b);
		ADDRESS = Tools.toInt(b, true);
		in.read(b);
		SIZE = Tools.toInt(b, true);
		in.read(b);
		FRAMES = Tools.toInt(b, true);
		in.read(b);
		UNKNOWN = Tools.toInt(b, true);
		if (ADDRESS<0 || SIZE<0 || FRAMES<0){
			String msg = Language.getString("SndEntry.0"); //$NON-NLS-1$
			msg = msg.replace("%1", Integer.toString(ADDRESS)); //$NON-NLS-1$
			msg = msg.replace("%2", Integer.toString(SIZE)); //$NON-NLS-1$
			msg = msg.replace("%3", Integer.toString(FRAMES)); //$NON-NLS-1$
			throw new IOException(msg);
		}
	}
	public void save(OutputStream out) throws IOException{
		out.write(Tools.toByte(ADDRESS, true));
		out.write(Tools.toByte(SIZE, true));
		out.write(Tools.toByte(FRAMES, true));
		out.write(Tools.toByte(UNKNOWN, true));
	}
}
