/**
 * Ultimate Editor
 * Copyright (C) 2008 Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: StackTracePrinter.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 9.5.2010
 */

package ue.exception;

import java.io.PrintStream;

/**
 *
 * @author Alan
 */
public abstract class StackTracePrinter
{
    public static void printStackTrace(Throwable e, PrintStream dest, boolean filter)
    {
        if(filter)
        {
            StackTraceElement[] trace = e.getStackTrace();

            int i;
            for (i = trace.length - 1; i >= 0; i--)
            {
                if (trace[i].getClassName().startsWith("ue"))
                {
                    break;
                }
            }

            StackTraceElement[] newtrace = new StackTraceElement[i + 1];
            System.arraycopy(trace, 0, newtrace, 0, i + 1);

            e.setStackTrace(newtrace);
            e.printStackTrace(dest);
        }
        else
        {
            e.printStackTrace(dest);
        }
    }
}
