/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: HtmlReportGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.util.Vector;

import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.ScrollPaneConstants;

import ue.Language;
import ue.UE;
import ue.util.SettingsManager;

/**This MainPanel is used to display results of the check() query.
Check() is specified by the CanBeEdited interface.*/
@SuppressWarnings("serial")  
public class CheckGUI extends MainPanel
{
	//displays results
	private JTextArea res;
	
	/**Constructor.
	@param results contains entries to be displayed.*/
	public CheckGUI(Vector<String> results){
		//ready
		this.res = new JTextArea();
		this.res.setText(Language.getString("CheckGUI.0") + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
		
		for (int i = 0; i < results.size(); i++){
			this.res.append("\n" + results.get(i)); //$NON-NLS-1$
		}
		
		this.res.setEditable(false);
		this.res.setLineWrap(true);
                this.res.setWrapStyleWord(true);
		
		Font def = UE.SETTINGS.getDefaultFont();

        this.res.setFont(def);
		JScrollPane scrollPane = new JScrollPane(this.res);
		scrollPane.setPreferredSize(new Dimension(560, 420));
                scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		scrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		//set
		this.setLayout(new BorderLayout());
                this.add(scrollPane, BorderLayout.CENTER);
		this.setVisible(true);
	}
	
	@Override
	public void finalWarning() throws Exception {}
}
