/**
 * Ultimate Editor for Birth Of The Federation 1.02
 * Copyright (C) 2005-2011  Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: InvisibleScrollBarUI.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 9.2.2011
 */

package ue.gui;

import java.awt.Color;
import java.awt.Graphics;
import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.metal.MetalScrollBarUI;


public class InvisibleScrollBarUI extends MetalScrollBarUI
{
    public InvisibleScrollBarUI()
    {
        super();
    }

    @Override
    public void paint(Graphics g, JComponent c)
    {
        c.removeAll();
        c.setOpaque(false);
        c.setBorder(BorderFactory.createMatteBorder(0, 1, 0, 0, Color.GRAY));
    }

    public static ComponentUI createUI(JComponent c)
    {
        return new InvisibleScrollBarUI();
    }

    @Override
    public void update(Graphics g, JComponent c)
    {
        c.removeAll();
        c.setOpaque(false);
        c.setBorder(BorderFactory.createMatteBorder(0, 1, 0, 0, Color.GRAY));
    }
}
