/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: MainPanel.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui;

import java.awt.Font;

import javax.swing.JLabel;
import javax.swing.JPanel;

/**This is the abstract class MainPanel. All panels to be displayed in main window
must be subclasses of this class.*/
@SuppressWarnings("serial")
public abstract class MainPanel extends JPanel{
	/**Right before the panel is removed by the MainWindow, this method is called
	to let the panel do any unfinished tasks it has before it becomes gc() fodder.*/
	public abstract void finalWarning() throws Exception;
	/**
	 * Returns instructions/help for this panel. Returns null if no help is available.
	 */
	public String getHelpFileName(){
		return null;
	}
	
	public void createAndSetupLabels(JLabel[] lbl, Font font, String[] text, int horizontal_Align)
	{
	    for (int i = 0; i < lbl.length; i++)
	    {
	        lbl[i] = new JLabel();
	        lbl[i].setFont(font);
	        lbl[i].setHorizontalAlignment(horizontal_Align);
	        
	        if (text != null && text.length > 0)
	        {
	            lbl[i].setText(text[i % text.length]);
	        }
	    }
	}
}