/**
 * Ultimate Editor for Birth Of The Federation 1.02
 * Copyright (C) 2005-2011  Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: UEComboBoxUI.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 9.2.2011
 */

package ue.gui;

import java.awt.Rectangle;
import javax.swing.plaf.basic.BasicComboPopup;
import javax.swing.plaf.basic.ComboPopup;
import javax.swing.plaf.metal.MetalComboBoxUI;

public class UEComboBoxUI extends MetalComboBoxUI
{
    int width;

    public UEComboBoxUI(int width)
    {
        super();
        this.width = width;
    }

    @Override
    protected ComboPopup createPopup()
    {
        BasicComboPopup pop = new BasicComboPopup(comboBox)
        {
            @Override
            protected Rectangle computePopupBounds(int px,int py,int pw,int ph)
            {
                int w = Math.max(width, pw);
                px = px - (w - pw);

                return super.computePopupBounds(px, py, w, ph);
            }
        };
        pop.getAccessibleContext().setAccessibleParent(comboBox);
        return pop;
    }
}
