/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: AboutGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui.help;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Toolkit;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;

import ue.Language;
import ue.UE;
import ue.gui.CreditsPanel;

/**This class is used to display the about window.*/
@SuppressWarnings("serial")  //$NON-NLS-1$
public class AboutGUI extends JFrame{
	/**Costructor*/
	public AboutGUI(){
		/*CREATE ITEMS*/
		JLabel lblTITLE = new JLabel(UE.APP_NAME);
		JLabel lblDESCa = new JLabel(Language.getString("AboutGUI.0")); //$NON-NLS-1$
		JLabel lblDESCb = new JLabel(Language.getString("AboutGUI.1")); //$NON-NLS-1$
		JLabel lblDESCc = new JLabel(Language.getString("AboutGUI.2")); //$NON-NLS-1$
		JTextArea txtCREA = new JTextArea(""); //$NON-NLS-1$
		JLabel lblVERS = new JLabel(UE.APP_VER);
		/*SETUP ITEMS*/
		lblTITLE.setFont(UE.SETTINGS.getDefaultBigFont()); //the title is bold and bigger
		lblTITLE.setHorizontalAlignment(SwingConstants.CENTER);
		Font def = UE.SETTINGS.getDefaultFont();
		lblDESCa.setFont(def);
		lblDESCb.setFont(def);
		lblDESCc.setFont(def);
		txtCREA.setFont(def);
		lblVERS.setFont(def);
		txtCREA.setEnabled(false);
		txtCREA.setBackground(getBackground());
		txtCREA.setBorder(BorderFactory.createEmptyBorder());
		txtCREA.setForeground(Color.GRAY);
		txtCREA.setDisabledTextColor(Color.GRAY);
		lblVERS.setForeground(Color.GRAY);
		lblDESCa.setForeground(Color.DARK_GRAY);
		lblDESCb.setForeground(Color.DARK_GRAY);
		lblDESCc.setForeground(Color.DARK_GRAY);
		lblTITLE.setForeground(Color.DARK_GRAY);
		//credits & authors
		CreditsPanel pnlCRED = new CreditsPanel(UE.APP_HELPERS, def, Color.GRAY, 2, new Dimension(100, 100));
		for (String name: UE.APP_AUTHORS){
			if (txtCREA.getText().length() > 0) txtCREA.append("\n"); //$NON-NLS-1$
			txtCREA.append(name);
		}
		/*ADD ITEMS TO FRAME*/
		//general layout settings
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.insets=new Insets(5, 5, 5, 5);
		c.anchor=GridBagConstraints.NORTH;
		c.fill=GridBagConstraints.BOTH;
		//adding items
		c.gridheight=1;
		c.gridwidth=2;
		c.gridx=0;
		c.gridy=0;
		add(lblTITLE, c);
		c.gridwidth=1;
		c.gridy=1;
		add(lblDESCa, c);
		c.gridx=1;
		c.gridheight=2;
		add(txtCREA, c);
		c.gridx=0;
		c.gridy=3;
		c.gridheight=1;
		add(lblDESCb, c);
		c.gridx=1;
		add(lblVERS, c);
		c.gridx=0;
		c.gridy=4;
		add(lblDESCc, c);
		c.gridheight=2;
		c.gridx=1;
		c.gridy=4;
		c.insets=new Insets(10, 5, 5, 5);
		add(pnlCRED, c);
		/*FRAME SETUP*/
		//icon is the same as main
		setIconImage(UE.ICON);
		setTitle(Language.getString("AboutGUI.3")); //$NON-NLS-1$
		pack();
		setResizable(false);	//this frame is not resisable
		setAlwaysOnTop(true);
		//place at the center of screen
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation(new Point((int)(screenSize.getWidth()/2-125), (int)(screenSize.getHeight()/2-125)));
		setVisible(true);
	}
}
