/*
 * Ultimate Editor for Birth Of The Federation 1.02
 * Copyright (C) 2005-2010 Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * EmpireInfoGUI.java
 *
 * Created on 13.12.2010, 16:16:52
 */

package ue.gui.sav;

import java.awt.Font;
import javax.swing.AbstractListModel;
import javax.swing.ImageIcon;
import javax.swing.table.AbstractTableModel;
import ue.UE;
import ue.edit.res.Stbof;
import ue.edit.res.stbof.rst.Race;
import ue.edit.sav.EmpsInfo;
import ue.edit.sav.SavGame;
import ue.exception.InvalidArgumentsException;
import ue.gui.CheckListRenderer;
import ue.gui.CheckItem;
import ue.gui.MainPanel;

/**
 *
 * @author Alan
 */
public class EmpireInfoGUI extends MainPanel
{
    private int empire = 0;
    private Stbof STBOF;
    private EmpsInfo EMPSINFO;
    private Race RACE;
    private String[] treaty;
    private String[] morale;

    /** Creates new form EmpireInfoGUI */
    public EmpireInfoGUI(Stbof st, SavGame game) throws Exception
    {
        STBOF = st;
        RACE = (Race)STBOF.getInternalFile(Stbof.fileRACE_RST, true);
        EMPSINFO = (EmpsInfo)game.getInternalFile(SavGame.fileEMPSINFO, true);
        
        treaty = new String[]{
            "Neutral",
            "War",
            "Alliance",
            "Peace"
        };

        morale = new String[]{
            "Rebellious",
            "Defiant",
            "Disgruntled",
            "Apathetic",
            "Content",
            "Pleased",
            "Loyal",
            "Fanatic"
        };
        
        initComponents();

        Font def = UE.SETTINGS.getDefaultFont();
        btnNext.setFont(def);
        btnPrev.setFont(def);
        jLabel1.setFont(def);
        jLabel11.setFont(def);
        jLabel2.setFont(def);
        jLabel3.setFont(def);
        jLabel4.setFont(def);
        jLabel5.setFont(def);
        jLabel6.setFont(def);
        jLabel7.setFont(def);
        jLabel8.setFont(def);
        jLabel9.setFont(def);
        lblIncome.setFont(def);
        lblMoraleLabel.setFont(def);
        lblRacePic.setFont(def);
        lblShipPopSup.setFont(def);
        lblShipsUnderConst.setFont(def);
        lstKnownMinors.setFont(def);
        tblOtherEmpireStatus.setFont(def);
        txtCredits.setFont(def);
        txtDilSources.setFont(def);
        txtEmperor.setFont(def);
        txtEmpireName.setFont(def);
        tblOtherEmpireStatus.setRowHeight(UE.WINDOW.getGraphics().getFontMetrics(def).getHeight());

        refreshData();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jLabel9 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tblOtherEmpireStatus = new javax.swing.JTable();
        lblRacePic = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        txtCredits = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        txtEmperor = new javax.swing.JTextField();
        lblIncome = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        lblMoraleLabel = new javax.swing.JLabel();
        lblShipsUnderConst = new javax.swing.JLabel();
        txtDilSources = new javax.swing.JLabel();
        txtEmpireName = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        lblShipPopSup = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        lstKnownMinors = new javax.swing.JList();
        btnNext = new javax.swing.JButton();
        btnPrev = new javax.swing.JButton();

        jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel9.setText("Status with other empires:");

        jScrollPane1.setFocusable(false);
        jScrollPane1.setMinimumSize(new java.awt.Dimension(0, 0));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(0, 0));

        tblOtherEmpireStatus.setAutoCreateRowSorter(true);
        tblOtherEmpireStatus.setModel(new EmRelStatusTableModel());
        tblOtherEmpireStatus.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        tblOtherEmpireStatus.setFillsViewportHeight(true);
        tblOtherEmpireStatus.setFocusable(false);
        tblOtherEmpireStatus.setRequestFocusEnabled(false);
        tblOtherEmpireStatus.setRowSelectionAllowed(false);
        jScrollPane1.setViewportView(tblOtherEmpireStatus);

        lblRacePic.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblRacePic.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        lblRacePic.setIconTextGap(0);

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel5.setText("Working dilithium sources:");

        lblIncome.setText("jLabel10");

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel7.setText("Ships under construction:");

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("Emperor title:");

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText("Empire name:");

        lblMoraleLabel.setText("jLabel10");

        lblShipsUnderConst.setText("jLabel10");

        txtDilSources.setText("jLabel10");

        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel8.setText("Empire morale:");

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel3.setText("Credits:");

        lblShipPopSup.setText("jLabel10");

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel4.setText("Income:");

        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel6.setText("Ship pop. support:");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(lblMoraleLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(lblShipsUnderConst, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(lblShipPopSup, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(txtDilSources, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(lblIncome, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(txtCredits, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(txtEmperor, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(txtEmpireName, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 334, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtEmpireName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(txtEmperor))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(txtCredits, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(lblIncome))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(txtDilSources))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(lblShipPopSup))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(lblShipsUnderConst))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(lblMoraleLabel))
                .addContainerGap())
        );

        jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel11.setText("Known races:");
        jLabel11.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        lstKnownMinors.setModel(new MinorRaceListModel());
        lstKnownMinors.setCellRenderer(new CheckListRenderer());
        lstKnownMinors.setLayoutOrientation(javax.swing.JList.HORIZONTAL_WRAP);
        lstKnownMinors.setSelectionBackground(new java.awt.Color(255, 255, 255));
        lstKnownMinors.setSelectionForeground(new java.awt.Color(0, 0, 0));
        jScrollPane2.setViewportView(lstKnownMinors);

        btnNext.setText(">>>");
        btnNext.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnNextActionPerformed(evt);
            }
        });

        btnPrev.setText("<<<");
        btnPrev.setEnabled(false);
        btnPrev.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPrevActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblRacePic, javax.swing.GroupLayout.PREFERRED_SIZE, 155, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel11, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel9, javax.swing.GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 506, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(btnPrev)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 392, Short.MAX_VALUE)
                                .addComponent(btnNext))
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 506, Short.MAX_VALUE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(11, 11, 11)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblRacePic, javax.swing.GroupLayout.PREFERRED_SIZE, 194, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel9)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 81, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel11)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnNext)
                    .addComponent(btnPrev))
                .addGap(11, 11, 11))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnNextActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnNextActionPerformed
        // save
        try
        {
            finalWarning();
        }
        catch (Exception ex)
        {
            // really bad stuff happening - bail
            UE.displayError(ex);
            return;
        }

        if (empire < 4)
        {
            empire++;
        }

        btnNext.setEnabled(empire < 4);
        btnPrev.setEnabled(empire > 0);

        // load new
        refreshData();
    }//GEN-LAST:event_btnNextActionPerformed

    private void btnPrevActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPrevActionPerformed
        // save
        try
        {
            finalWarning();
        }
        catch (Exception ex)
        {
            // really bad stuff happening - bail
            UE.displayError(ex);
            return;
        }

        if (empire > 0)
        {
            empire--;
        }

        btnNext.setEnabled(empire < 4);
        btnPrev.setEnabled(empire > 0);

        // load new
        refreshData();
    }//GEN-LAST:event_btnPrevActionPerformed

    @Override
    public void finalWarning() throws Exception {
        EMPSINFO.setCredits(empire, Integer.parseInt(txtCredits.getText()));
        EMPSINFO.setEmperor(empire, txtEmperor.getText());
        EMPSINFO.setEmpireTitle(empire, this.txtEmpireName.getText());
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnNext;
    private javax.swing.JButton btnPrev;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel lblIncome;
    private javax.swing.JLabel lblMoraleLabel;
    private javax.swing.JLabel lblRacePic;
    private javax.swing.JLabel lblShipPopSup;
    private javax.swing.JLabel lblShipsUnderConst;
    private javax.swing.JList lstKnownMinors;
    private javax.swing.JTable tblOtherEmpireStatus;
    private javax.swing.JTextField txtCredits;
    private javax.swing.JLabel txtDilSources;
    private javax.swing.JTextField txtEmperor;
    private javax.swing.JTextField txtEmpireName;
    // End of variables declaration//GEN-END:variables

    private void refreshData()
    {
        try
        {
            this.txtEmpireName.setText(EMPSINFO.getEmpireTitle(empire));
            this.lblIncome.setText(Integer.toString(EMPSINFO.getIncome(empire)));
            this.lblRacePic.setIcon(new ImageIcon(STBOF.getTargaImage(RACE.getPic(empire), false).getImage(false)));
            this.lblMoraleLabel.setText(morale[EMPSINFO.getEmpireMorale(empire) + 4]);
            this.lblShipPopSup.setText(Integer.toString(EMPSINFO.getShipPopSupport(empire)));
            this.lblShipsUnderConst.setText(Integer.toString(EMPSINFO.getNumberOfShipsUnderConstruction(empire)));
            this.txtCredits.setText(Integer.toString(EMPSINFO.getCredits(empire)));
            this.txtDilSources.setText(Integer.toString(EMPSINFO.getDilithiumIncome(empire)));
            this.txtEmperor.setText(EMPSINFO.getEmperor(empire));
        }
        catch (Exception e)
        {
            UE.displayError(e);
        }
        this.tblOtherEmpireStatus.tableChanged(null);
        this.lstKnownMinors.updateUI();
    }

    private class EmRelStatusTableModel extends AbstractTableModel
    {
        @Override
        public int getRowCount() {
            return 4;
        }

        @Override
        public int getColumnCount()
        {
            return 4;
        }

        @Override
        public String getColumnName(int column) {
            switch (column)
            {
                case 0:
                    return "Empire";
                case 1:
                    return "Treaty";
                case 2:
                    return "Open border";
                default:
                    return "Allows trade";
            }
        }

        @Override
        public boolean isCellEditable(int arg0, int arg1) {
            return false;
        }

        @Override
        public Object getValueAt(int rowIndex, int columnIndex)
        {
            rowIndex = (empire <= rowIndex) ? rowIndex + 1 : rowIndex;
            
            try {
                switch (columnIndex) {
                    case 0:
                        return RACE.getName(rowIndex);
                    case 1:
                        int ti = EMPSINFO.getTreatyLabel(empire, rowIndex);
                        return (ti >= 0 && ti <= 3) ? treaty[ti] : ti;
                    case 2:
                        return (EMPSINFO.getTerritoryAccess(empire, rowIndex) == 0) ? "No" : "Yes";
                    default:
                        return (EMPSINFO.getTradeAccess(empire, rowIndex) == 0) ? "No" : "Yes";
                }
            } catch (InvalidArgumentsException ex) {
                UE.displayError(ex);
            }
            return "";
        }
    }

    private class MinorRaceListModel extends AbstractListModel
    {
        @Override
        public int getSize() {
            return RACE.getNumberOfEntries();
        }

        @Override
        public Object getElementAt(int index)
        {
            try {
                return new CheckItem(RACE.getName(index), EMPSINFO.isRaceKnown(empire, index), false);
            } catch (InvalidArgumentsException ex) {
                UE.displayError(ex);
            }
            return "";
        }
    }
}
