/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MapGUIv2.java
 *
 * Created on 23.7.2010, 13:04:15
 */
package ue.gui.sav;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.HashMap;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JEditorPane;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JToggleButton;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIDefaults;
import javax.swing.UIManager;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import ue.Language;
import ue.edit.exe.Trek;
import ue.edit.res.Stbof;
import ue.edit.sav.SavGame;
import ue.exception.InvalidArgumentsException;
import ue.UE;
import ue.edit.exe.trek.PlanetBonusTypes;
import ue.edit.res.stbof.bst.Edifice;
import ue.edit.sav.TaskForceList;
import ue.gui.InfoList;
import ue.gui.InfoPanel.Orientation;
import ue.gui.MainPanel;
import ue.gui.SelectionEvent;
import ue.gui.SelectionListener;
import ue.util.AniOrCur;
import ue.util.TargaImage;
import ue.util.Tools;

/**
 *
 * @author Alan
 */
public class MapGUIv2 extends MainPanel
{
    private static final int outpost = 0;
    private static final int taskforce = 1;
    private static final int stellar_object = 2;
    private static final int system = 3;
    private static final int planet = 4;
    private static final int ship = 5;
 
    private MapPanel map;
    private InfoList lstMilitary;
    private JScrollPane jspMilitary;
    private InfoList lstDetails;
    private JScrollPane jspDetails;
    private JEditorPane txtDetailsDesc;
    private JScrollPane jspDetailsText;
    private Font def;
    private Point prev_sector = null;

    private HashMap<String, AniOrCur> aniCache = new HashMap<String, AniOrCur>();

    private static final int detailsImgSize = 50;

    public MapGUIv2(Stbof stbof, SavGame game, Trek exe) throws Exception
    {
        map = new MapPanel(game, stbof, exe);

        initComponents();
        setupComponents();
    }

    private void setupComponents() throws Exception
    {
        def = UE.SETTINGS.getDefaultFont();

        pnlTop.setLayout(new javax.swing.BoxLayout(pnlTop, javax.swing.BoxLayout.Y_AXIS));

        this.lblView.setText(Language.getString("MapGUI.9")); //$NON-NLS-1$
        this.lblView.setFont(def);

        ButtonGroup grp = new ButtonGroup();

        JToggleButton[] btnView = new JToggleButton[6];

        btnView[0] = new JToggleButton(Language.getString("MapGUI.10")); //$NON-NLS-1$
        btnView[0].setFont(def);
        btnView[0].addActionListener(new ViewListener(0));
        grp.add(btnView[0]);
        pnlView.add(btnView[0]);

        for (int r = 0; r < 5; r++) {
            btnView[r + 1] = new JToggleButton(map.races.getName(r));
            btnView[r + 1].setFont(def);
            btnView[r + 1].addActionListener(new ViewListener(r + 1));
            grp.add(btnView[r + 1]);
            pnlView.add(btnView[r + 1]);
        }

        JPanel pnlMilitary = new JPanel(new BorderLayout());

            pnlMilitary.setBackground(Color.BLACK);

            lstMilitary = new InfoList(new ImageIcon(new BufferedImage(30, 30, BufferedImage.TYPE_INT_RGB)),
                    false, 0, 1);
            lstMilitary.setFont(def);
            lstMilitary.setBackground(Color.BLACK);
            lstMilitary.setForeground(Color.WHITE);
            lstMilitary.setSelectionBackground(Color.darkGray);
            lstMilitary.addListSelectionListener(new MilitarySelectionListener());

            pnlMilitary.add(lstMilitary, BorderLayout.NORTH);

            jspMilitary = new JScrollPane(pnlMilitary);
            JScrollBar jsp = jspMilitary.getVerticalScrollBar();
            jsp.setUnitIncrement(30);
            jspMilitary.setPreferredSize(new Dimension(200, 250));

        pnlLeft.add(jspMilitary);
        pnlLeft.setLayout(new javax.swing.BoxLayout(pnlLeft, javax.swing.BoxLayout.Y_AXIS));

        JPanel pnlDetailedView = new JPanel(new BorderLayout());

            pnlDetailedView.setBackground(Color.BLACK);

            JPanel pnlItems = new JPanel(new BorderLayout());
            pnlItems.setOpaque(false);

            lstDetails = new InfoList(
                    new ImageIcon(new BufferedImage(detailsImgSize, detailsImgSize, BufferedImage.TYPE_INT_RGB)),
                    false, 1, 0);
            lstDetails.setItemOrientation(Orientation.Vertical);
            lstDetails.setFont(def);
            lstDetails.setBackground(Color.BLACK);
            lstDetails.setForeground(Color.WHITE);
            lstDetails.setSelectionBackground(Color.BLACK);
            lstDetails.setSelectionActivator(InfoList.MOUSE_MOVEMENT);
            lstDetails.addListSelectionListener(new DetailsSelectionListener());

            pnlItems.add(lstDetails, BorderLayout.CENTER);

            jspDetails = new JScrollPane(pnlItems);
            jspDetails.setOpaque(false);
            jsp = jspDetails.getHorizontalScrollBar();
            jsp.setUnitIncrement(50);
            jspDetails.setPreferredSize(new Dimension(100, 100));

            JPanel pnlDetails = new JPanel();
            pnlDetails.setLayout(new BoxLayout(pnlDetails, BoxLayout.Y_AXIS));
            txtDetailsDesc = new JEditorPane("text/html", "");
            txtDetailsDesc.setBorder(null);
            txtDetailsDesc.setOpaque(false);
            txtDetailsDesc.setEditable(false);
            txtDetailsDesc.setFocusable(false);
            txtDetailsDesc.setFont(def);

            pnlDetails.add(Box.createRigidArea(new Dimension(10, 10)));
            pnlDetails.add(txtDetailsDesc);
            pnlDetails.add(Box.createRigidArea(new Dimension(10, 10)));
            pnlDetails.setBackground(Color.BLACK);
//            pnlDetails.setPreferredSize(new Dimension(150, 100));

            UIDefaults defaults = UIManager.getDefaults( );
            Color color = defaults.getColor("InternalFrame.borderColor");
            if (color == null)
            {
                color = this.getBackground();
            }

            int width = defaults.getInt("InternalFrame.borderWidth");
            if (width <= 0)
            {
                width = 1;
            }

            jspDetailsText = new JScrollPane(pnlDetails);
            jspDetailsText.setOpaque(false);
            jsp = jspDetailsText.getHorizontalScrollBar();
            jsp.setUnitIncrement(50);
            jspDetailsText.setPreferredSize(new Dimension(200, 130));

            jspDetails.setBorder(BorderFactory.createMatteBorder(
                    width, 0, width, width, color));
            jspDetailsText.setBorder(BorderFactory.createMatteBorder(
                    width, width, width, 0, color));
            jspDetailsText.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
            jspDetailsText.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);

            pnlDetailedView.add(jspDetails, BorderLayout.CENTER);
            pnlDetailedView.add(jspDetailsText, BorderLayout.WEST);


        pnlBottom.setLayout(new BorderLayout());
        pnlBottom.add(pnlDetailedView, BorderLayout.CENTER);
        pnlBottom.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 8));

        int scr = Math.max(1, map.map[0][0].getPreferredSize().height / 2);
        scrMap.getVerticalScrollBar().setUnitIncrement(scr);
        scrMap.getVerticalScrollBar().setBlockIncrement(scr);
        scrMap.setPreferredSize(new Dimension(500, 380));

        // more listeners
        RightClickSelectionListener rightClickListener = new RightClickSelectionListener();

        map.addActionListener(new SectorSelectionListener());
        map.addRightClickListener(rightClickListener);
        lstMilitary.addRightClickListener(rightClickListener);
        lstDetails.addRightClickListener(rightClickListener);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pnlTop = new javax.swing.JPanel();
        pnlTopLine1 = new javax.swing.JPanel();
        pnlView = new javax.swing.JPanel();
        lblView = new javax.swing.JLabel();
        pnlZoom = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        btnZoomIn = new javax.swing.JButton();
        btnZoomOut = new javax.swing.JButton();
        pnlTopLine2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        chkSectorOwnership = new javax.swing.JCheckBox();
        chkObjects = new javax.swing.JCheckBox();
        chkOutposts = new javax.swing.JCheckBox();
        chkShips = new javax.swing.JCheckBox();
        chkShipPaths = new javax.swing.JCheckBox();
        jPanel2 = new javax.swing.JPanel();
        pnlLeft = new javax.swing.JPanel();
        pnlBottom = new javax.swing.JPanel();
        pnlCenter = new javax.swing.JPanel();
        scrMap = new JScrollPane(map);

        setLayout(new java.awt.BorderLayout());

        lblView.setText("Views:");
        pnlView.add(lblView);

        pnlTopLine1.add(pnlView);

        jLabel2.setText("Zoom:");
        pnlZoom.add(jLabel2);

        btnZoomIn.setText("+");
        btnZoomIn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnZoomInActionPerformed(evt);
            }
        });
        pnlZoom.add(btnZoomIn);

        btnZoomOut.setText("-");
        btnZoomOut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnZoomOutActionPerformed(evt);
            }
        });
        pnlZoom.add(btnZoomOut);

        pnlTopLine1.add(pnlZoom);

        pnlTop.add(pnlTopLine1);

        jLabel1.setText("Draw:");
        pnlTopLine2.add(jLabel1);

        chkSectorOwnership.setSelected(true);
        chkSectorOwnership.setText("Sector ownership");
        chkSectorOwnership.setFocusable(false);
        chkSectorOwnership.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkSectorOwnershipActionPerformed(evt);
            }
        });
        pnlTopLine2.add(chkSectorOwnership);

        chkObjects.setSelected(true);
        chkObjects.setText("Objects");
        chkObjects.setFocusable(false);
        chkObjects.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkObjectsActionPerformed(evt);
            }
        });
        pnlTopLine2.add(chkObjects);

        chkOutposts.setSelected(true);
        chkOutposts.setText("Outposts");
        chkOutposts.setFocusable(false);
        chkOutposts.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkOutpostsActionPerformed(evt);
            }
        });
        pnlTopLine2.add(chkOutposts);

        chkShips.setSelected(true);
        chkShips.setText("Ships");
        chkShips.setFocusable(false);
        chkShips.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkShipsActionPerformed(evt);
            }
        });
        pnlTopLine2.add(chkShips);

        chkShipPaths.setSelected(true);
        chkShipPaths.setText("Ship paths");
        chkShipPaths.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkShipPathsActionPerformed(evt);
            }
        });
        pnlTopLine2.add(chkShipPaths);

        pnlTop.add(pnlTopLine2);

        add(pnlTop, java.awt.BorderLayout.PAGE_START);
        add(jPanel2, java.awt.BorderLayout.LINE_END);

        pnlLeft.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1), "Military:"));
        add(pnlLeft, java.awt.BorderLayout.LINE_START);
        add(pnlBottom, java.awt.BorderLayout.PAGE_END);

        pnlCenter.setLayout(new javax.swing.BoxLayout(pnlCenter, javax.swing.BoxLayout.LINE_AXIS));

        scrMap.setDoubleBuffered(true);
        scrMap.setFocusable(false);
        pnlCenter.add(scrMap);

        add(pnlCenter, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void btnZoomInActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnZoomInActionPerformed
        final Dimension dim = new Dimension(scrMap.getVerticalScrollBar().getMaximum(),
                scrMap.getHorizontalScrollBar().getMaximum());

        map.zoomIn();

        SwingUtilities.invokeLater(new Runnable() {

            @Override
            public void run() {
                int window = scrMap.getHeight();

                Dimension dim2 = new Dimension(scrMap.getVerticalScrollBar().getMaximum(),
                        scrMap.getHorizontalScrollBar().getMaximum());

                dim.height = window - (int) Math.round((dim.height / (double) dim2.height) * window) + scrMap.getVerticalScrollBar().getValue();

                window = scrMap.getWidth();

                dim.width = window - (int) Math.round((dim.width / (double) dim2.width) * window) + scrMap.getHorizontalScrollBar().getValue();

                scrMap.getVerticalScrollBar().setValue(dim.height);
                scrMap.getHorizontalScrollBar().setValue(dim.width);

                int scr = Math.max(1, map.map[0][0].getPreferredSize().height / 2);
                scrMap.getVerticalScrollBar().setUnitIncrement(scr);
                scrMap.getVerticalScrollBar().setBlockIncrement(scr);
            }
        });
}//GEN-LAST:event_btnZoomInActionPerformed

    private void btnZoomOutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnZoomOutActionPerformed
        double valV = scrMap.getVerticalScrollBar().getValue() /
                (scrMap.getVerticalScrollBar().getMaximum() - scrMap.getVerticalScrollBar().getMinimum());
        double valH = scrMap.getHorizontalScrollBar().getValue() /
                (scrMap.getHorizontalScrollBar().getMaximum() - scrMap.getHorizontalScrollBar().getMinimum());

        map.zoomOut();

        scrMap.getVerticalScrollBar().setValue((int) valV *
                (scrMap.getVerticalScrollBar().getMaximum() - scrMap.getVerticalScrollBar().getMinimum()));
        scrMap.getVerticalScrollBar().setValue((int) valH *
                (scrMap.getHorizontalScrollBar().getMaximum() - scrMap.getHorizontalScrollBar().getMinimum()));

        int scr = Math.max(1, 2 * map.getHeight() / map.sectors.getHSectors());
        scrMap.getVerticalScrollBar().setUnitIncrement(scr);
}//GEN-LAST:event_btnZoomOutActionPerformed

    private void chkSectorOwnershipActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkSectorOwnershipActionPerformed
        map.drawOwnership = chkSectorOwnership.isSelected();
        map.setVisible(false);
        map.setVisible(true);
    }//GEN-LAST:event_chkSectorOwnershipActionPerformed

    private void chkObjectsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkObjectsActionPerformed
        map.drawObjects = chkObjects.isSelected();
        map.setVisible(false);
        map.setVisible(true);
    }//GEN-LAST:event_chkObjectsActionPerformed

    private void chkOutpostsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkOutpostsActionPerformed
        map.drawOutposts = chkOutposts.isSelected();
        map.setVisible(false);
        map.setVisible(true);
    }//GEN-LAST:event_chkOutpostsActionPerformed

    private void chkShipsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkShipsActionPerformed
        map.drawShips = chkShips.isSelected();
        map.setVisible(false);
        map.setVisible(true);
    }//GEN-LAST:event_chkShipsActionPerformed

    private void chkShipPathsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkShipPathsActionPerformed
        map.drawPaths = chkShipPaths.isSelected();
        map.setVisible(false);
        map.setVisible(true);
    }//GEN-LAST:event_chkShipPathsActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnZoomIn;
    private javax.swing.JButton btnZoomOut;
    private javax.swing.JCheckBox chkObjects;
    private javax.swing.JCheckBox chkOutposts;
    private javax.swing.JCheckBox chkSectorOwnership;
    private javax.swing.JCheckBox chkShipPaths;
    private javax.swing.JCheckBox chkShips;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel lblView;
    private javax.swing.JPanel pnlBottom;
    private javax.swing.JPanel pnlCenter;
    private javax.swing.JPanel pnlLeft;
    private javax.swing.JPanel pnlTop;
    private javax.swing.JPanel pnlTopLine1;
    private javax.swing.JPanel pnlTopLine2;
    private javax.swing.JPanel pnlView;
    private javax.swing.JPanel pnlZoom;
    private javax.swing.JScrollPane scrMap;
    // End of variables declaration//GEN-END:variables

    @Override
    public void finalWarning() throws Exception
    {
        // nothing to do
    }
    // End of variables declaration

    private String getShipTypeString(int type) throws InvalidArgumentsException
    {
        int[] id = new int[]{1103, 232, 204, 1183, 173, 166, 895, 57,
        -1, 1366};

        if (type < id.length && type >= 0)
        {
            if (id[type] < 0)
            {
                return Language.getString("ShipGUI.1");
            }

            return map.lexicon.getEntry(id[type]);
        }
        else
        {
            return Integer.toString(type);
        }
    }

    private String getPlanetTypeString(int type) throws InvalidArgumentsException
    {
        int[] id = new int[]{37, 55, 229, 410, 558, 878, 1258, 1414};

        if (type < id.length && type >= 0)
        {
            return map.lexicon.getEntry(id[type]);
        }
        else
        {
            String name = map.environ.getName(type);
            return name.substring(0, 1).toUpperCase() + name.substring(1);
        }
    }

    private String getAtmoTypeString(int type) throws InvalidArgumentsException
    {
        int[] id = new int[]{641, 872, 898, 1189, 1352, 878, 1258};

        if (type - 8 < id.length && type - 8 >= 0)
        {
            return map.lexicon.getEntry(id[type - 8]);
        }
        else
        {
            String name = map.environ.getName(type);
            return name.substring(0, 1).toUpperCase() + name.substring(1);
        }
    }

    private String getAnomalyTypeString(int type) throws InvalidArgumentsException
    {
        int[] id = new int[]{94, 1450, 802, 810, 987, 889, 1452, 1446,
                420, 96, 1447, 968};

        if (type < id.length && type >= 0)
        {
            return map.lexicon.getEntry(id[type]);
        }
        else
        {
            return map.lexicon.getEntry(798);
        }
    }

    private String getAnomalyDescString(int type) throws InvalidArgumentsException
    {
        int[] id = new int[]{95, 1451, 803, 811, 987, 889, 1452, 1446,
                420, 96, 1448, 969};

        if (type < id.length && type >= 0)
        {
            return map.lexicon.getEntry(id[type]);
        }
        else
        {
            return map.lexicon.getEntry(798);
        }
    }

    private String getShipTitleString(int race, int[] shipIDs) throws InvalidArgumentsException
    {
        if (shipIDs.length == 0)
        {
            return "Error: No ships in this task force";
        }
        else if (shipIDs.length == 1)
        {
            return "1 %1".replace("%1", map.ships.getName(map.gShipList.getShipTypeID((short)shipIDs[0])));
        }
        else
        {
            boolean support = false;
            boolean military = false;
            boolean mixed = false;
            boolean sameType = true;
            int f1, f2, shID1, shID2;

            shID1 = map.gShipList.getShipTypeID((short)shipIDs[0]);
            f1 = map.ships.getFunction(shID1);

            if (f1 == 5 || f1 == 9)
            {
                support = true;
            }
            else
            {
                military = true;
            }

            for (int i = 1; i < shipIDs.length; i++)
            {
                shID2 = map.gShipList.getShipTypeID((short)shipIDs[i]);
                f2 = map.ships.getFunction(shID2);

                if (f1 != f2)
                {
                    mixed = true;
                    sameType = false;
                }
                else if (shID1 != shID2)
                {
                    sameType = false;
                }

                if (f2 == 5 || f2 == 9)
                {
                    support = true;
                }
                else
                {
                    military = true;
                }
            }

            if (sameType)
            {
                return "%1 %2s".replace("%1", Integer.toString(shipIDs.length))
                        .replace("%2", map.ships.getName(shID1));
            }
            else if (mixed)
            {
                if (support)
                {
                    if (military)
                    {
                        return "%1 ships".replace("%1", Integer.toString(shipIDs.length));
                    }
                    else
                    {
                        return "%1 support ships".replace("%1", Integer.toString(shipIDs.length));
                    }
                }
                else
                {
                    if (race == 1)
                    {
                        return "%1 starships".replace("%1", Integer.toString(shipIDs.length));
                    }
                    else
                    {
                        return "%1 warships".replace("%1", Integer.toString(shipIDs.length));
                    }
                }
            }
            else
            {
                String func;

                switch (f1)
                {
                    case 0:
                        func = map.lexicon.getEntry(1103);
                        break;
                    case 1:
                        func = map.lexicon.getEntry(232);
                        break;
                    case 2:
                        func = map.lexicon.getEntry(204);
                        break;
                    case 3:
                        func = map.lexicon.getEntry(1183);
                        break;
                    case 4:
                        func = map.lexicon.getEntry(173);
                        break;
                    case 5:
                        func = map.lexicon.getEntry(166);
                        break;
                    case 6:
                        func = map.lexicon.getEntry(895);
                        break;
                    case 7:
                        func = map.lexicon.getEntry(57);
                        break;
                    case 9:
                        func = map.lexicon.getEntry(1366);
                        break;
                    default:
                        func = Language.getString("ShipGUI.1");
                        break;
                }

                return "%1 %2s".replace("%1", Integer.toString(shipIDs.length))
                        .replace("%2", func);
            }
        }
    }

    private synchronized void updateMilitaryList(Point sector)
    {
        final int[] selected = lstMilitary.getSelectedItemID();

        final boolean reselect = prev_sector != null
                && sector != null && sector.equals(prev_sector);

        lstMilitary.removeAllItems();

        if (sector != null)
        {
            int h = map.sectors.getHSectors();
            int index = sector.y * h + sector.x;
            String pic;
            TargaImage tga;
            ImageIcon icon;
            String str, line3;
            int race, num, f1, f2;
            int[] id, shipIDs;

            // update military list
                // base
                try
                {
                    int item_index = map.sectors.getOutpost(index);

                    if (item_index >= 0)
                    {
                        item_index = map.outposts.getIndex((short)item_index);

                        int shipID = map.outposts.getShipID(item_index);

                        pic = map.ships.getImageName(shipID);

                        if (map.res.hasInternalFile("i_" + pic + "30.tga"))
                        {
                            tga = map.res.getTargaImage("i_" + pic + "30.tga", true);
                            icon = new ImageIcon(tga.getImage(true));
                        }
                        else
                        {
                            icon = null;
                        }

                        id = new int[]{outpost, item_index};

                        if (map.outposts.getType(item_index) == 6)
                        {
                            line3 = map.lexicon.getEntry(895);
                        }
                        else
                        {
                            line3 = map.lexicon.getEntry(57);
                        }

                        str = map.races.getName(map.outposts.getOwner(item_index));

                        if (str.endsWith("s"))
                        {
                            str = str.substring(0, str.length() - 1);
                        }

                        str = str + " " + line3;

                        double cost = map.outposts.getProductionCost(item_index);
                        double invested = map.outposts.getProductionInvested(item_index);

                        if (cost <= invested)
                        {
                            line3 = map.lexicon.getEntry(58).toUpperCase();
                        }
                        else
                        {
                            int percent = (int)Math.floor(invested / cost * 100);
                            line3 = map.lexicon.getEntry(905).toUpperCase()
                                    .replace("%D", Integer.toString(percent))
                                    .replace("%%", "%");
                        }

                        lstMilitary.addItem(icon, map.outposts.getName(item_index), str, line3, id);

                    }
                }
                catch (Exception e)
                {
                    UE.displayError(e);
                }

                //  taskforces
                int[] indexes = map.gWTForce.getSectorTaskForces(sector.y, sector.x);

                num = map.races.getNumberOfEntries();

                for (int tf_index : indexes)
                {
                    try
                    {
                        race = map.gWTForce.getOwner(tf_index);

                        // icon
                        if (race < 5)
                        {
                            pic = "i_" + map.empImgPrefixes.getEmpirePrefix(race) + "26.tga";
                            tga = map.res.getTargaImage(pic, true);
                            icon = new ImageIcon(tga.getImage(true));
                        }
                        else if (race < num)
                        {
                            // minor race
                            pic = "i_m26.tga";
                            tga = map.res.getTargaImage(pic, true);
                            icon = new ImageIcon(tga.getImage(true));
                        }
                        else
                        {
                            // alien
                            pic = "i_t26.tga";
                            tga = map.res.getTargaImage(pic, true);
                            icon = new ImageIcon(tga.getImage(true));
                        }

                        race = map.gWTForce.getTaskForceCommand(tf_index);

                        switch (race)
                        {
                            case TaskForceList.COMMAND_TERRAFORM:
                                str = map.lexicon.getEntry(663).toUpperCase();
                                break;
                            case TaskForceList.COMMAND_COLONIZE:
                                str = map.lexicon.getEntry(656).toUpperCase();
                                break;
                            case TaskForceList.COMMAND_RAID:
                                str = map.lexicon.getEntry(661).toUpperCase();
                                break;
                            case TaskForceList.COMMAND_INTERCEPT:
                                str = map.lexicon.getEntry(659).toUpperCase();

                                int i = str.indexOf("%");

                                if (i >= 0)
                                {
                                    str = str.substring(0, i);
                                }
                                break;
                            case TaskForceList.COMMAND_EVADE:
                                str = map.lexicon.getEntry(652).toUpperCase();
                                break;
                            case TaskForceList.COMMAND_ENGAGE:
                                str = map.lexicon.getEntry(658).toUpperCase();
                                break;
                            case TaskForceList.COMMAND_BUILD_OUTPOST:
                                str = map.lexicon.getEntry(653).toUpperCase();
                                break;
                            case TaskForceList.COMMAND_BUILD_STARBASE:
                                str = map.lexicon.getEntry(654).toUpperCase();
                                break;
                            case TaskForceList.COMMAND_TRAIN_CREW:
                                str = map.lexicon.getEntry(664).toUpperCase();
                                break;
                            case TaskForceList.COMMAND_SCRAP:
                                str = map.lexicon.getEntry(662).toUpperCase();
                                break;
                            case TaskForceList.COMMAND_ENTER_WORMHOLE:
                                str = map.lexicon.getEntry(657).toUpperCase();
                                break;
                            case TaskForceList.COMMAND_ATTACK_SYSTEM:
                                str = map.lexicon.getEntry(651).toUpperCase();
                                break;
                            default:
                                str = map.lexicon.getEntry(660).toUpperCase();
                        }

                        // eta
                        race = map.ordInfo.findFleetOrder(tf_index);

                        if (race >= 0)
                        {
                            race = map.gWTForce.getDistanceFrom(tf_index,
                                    map.ordInfo.getTargetSectorRow(race),
                                    map.ordInfo.getTargetSectorColumn(race));

                            if (race > 0)
                            {
                                race = (int)Math.max(1, race / map.gWTForce.getSpeed(tf_index));

                                str = str + " " + map.lexicon.getEntry(293);
                                str = str + " "
                                        + map.lexicon.getEntry(624).replace("%d", Integer.toString(race))
                                        .toUpperCase();
                            }
                        }

                        shipIDs = map.gWTForce.getShipIDs(tf_index);

                        id = new int[]{taskforce, tf_index};

//                            test = Integer.toString(map.gWTForce.getUnknown(tf_index));

                        lstMilitary.addItem(icon, str,
                                getShipTitleString(map.gWTForce.getOwner(tf_index), shipIDs),
                                null, id);
                    }
                    catch (Exception e)
                    {
                        UE.displayError(e);
                    }
                }
        }

        lstMilitary.setSelectedItemID(selected);
        lstMilitary.setVisible(false);
        lstMilitary.setVisible(true);
    }

    private synchronized void updateDetailsList(Point sector, Integer taskforce, Integer outpost)
    {
        lstDetails.removeAllItems();
        lstDetails.setRowsAndColumnsNumber(1, 0);
        lstDetails.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);

        if (sector != null)
        {
            int h = map.sectors.getHSectors();
            int index = sector.y * h + sector.x; 
            String pic, name, type, tip;
            int item = -1;
            double ratio;
            TargaImage tga, background;
            AniOrCur ani;

            // sector details
                try
                {
                    item = map.sectors.getStellarObject(index);

                    if (item >= 0)
                    {
                        // anomaly
                        name = map.objects.getName(item);
                        type = getAnomalyTypeString(map.objects.getType(item));
                        
                        pic = map.objects.getAni(item);

                        if (map.res.hasInternalFile(pic + ".ani"))
                        {
                            ani = map.res.getAnimation(pic + ".ani", true);

                            int scale = detailsImgSize;

                            Dimension size = ani.getFrameDim();

                            if (scale < size.height)
                            {
                                ratio = scale / (double) size.height;

                                int hor = (int)(ratio * size.width);

                                if (hor > scale) {
                                    scale = hor;
                                }

                                ani.setReturnedFrameMaxSize(scale);
                            }

                            lstDetails.addItem(ani, name, type, null,
                                    new int[]{stellar_object, item});
                        }
                        else if (map.res.hasInternalFile(pic + ".tga"))
                        {
                            tga = map.res.getTargaImage(pic + ".tga", true);

                            int scale = detailsImgSize;

                            Dimension size = tga.getImageSize();

                            if (scale < size.height)
                            {
                                ratio = scale / (double) size.height;

                                int hor = (int)(ratio * size.width);

                                if (hor > scale) {
                                    scale = hor;
                                }

                                lstDetails.addItem(
                                        new ImageIcon(tga.getThumbnail(scale, false, true)),
                                        name, type, null,
                                        new int[]{stellar_object, item});
                            }
                            else
                            {
                                lstDetails.addItem(new ImageIcon(tga.getImage(true)),
                                        name, type, null,
                                        new int[]{stellar_object, item});
                            }
                        }
                        else
                        {
                            lstDetails.addItem((ImageIcon)null,
                                        name, type, null,
                                        new int[]{stellar_object, item});
                        }
                    }
                    else
                    {
                        item = map.sectors.getSystem(index);

                        if (item >= 0)
                        {
                            // star
                            pic = map.systems.getAni(item);
                            name = map.systems.getName(item);
                            type = getAnomalyTypeString(map.systems.getType(item));

                            if (map.systems.hasDilithium(item))
                            {
                                tip = map.lexicon.getEntry(240);
                            }
                            else
                            {
                                tip = null;
                            }

                            ratio = 1;

                            if (map.res.hasInternalFile(pic))
                            {
                                if (pic.toLowerCase().endsWith(".ani"))
                                {
                                    ani = map.res.getAnimation(pic, false);

                                    int scale = detailsImgSize;

                                    Dimension size = ani.getFrameDim();

                                    if (scale < size.height)
                                    {
                                        ratio = scale / (double) size.height;

                                        int hor = (int)(ratio * size.width);

                                        if (hor > scale)
                                        {
                                            scale = hor;
                                        }

                                        ani.setReturnedFrameMaxSize(scale);
                                    }

                                    // add dilithium sign
                                    if (map.systems.hasDilithium(item))
                                    {
                                        TargaImage bid = map.res.getTargaImage("bid.tga", true);

                                        ani.setOverlayImg(
                                                0,
                                                0, bid);
                                    }
                                    else
                                    {
                                        ani.setOverlayImg(
                                                0,
                                                0, null);
                                    }

                                    lstDetails.addItem(ani,
                                            name, type, null,
                                            new int[]{system, item});
                                }
                                else
                                {
                                    lstDetails.addItem((ImageIcon)null,
                                            name, type, null,
                                            new int[]{system, item});
                                }
                            }
                            else
                            {
                                lstDetails.addItem((ImageIcon)null,
                                        name, type, null,
                                        new int[]{system, item});
                            }

                            lstDetails.setTooltip(0, tip);

                            int boni, btype;
                            String cachestr;

                            // planets
                            for (int planetIndex = 0; planetIndex < map.systems.planets(item); planetIndex++)
                            {
                                cachestr = pic = map.systems.getAnimation(item, planetIndex);
                                name = map.systems.getName(item, planetIndex);

                                type = map.environ.getName(map.systems.getType(item, planetIndex));

                                type = Character.toString(type.charAt(0)).toUpperCase() + type.substring(1);

                                // get bonus
                                boni = map.planboni.get(
                                        map.systems.getType(item, planetIndex),
                                        (byte)map.systems.getSize(item, planetIndex),
                                        map.systems.getPltBoni(item, planetIndex),
                                        map.systems.getUniBoni(item, planetIndex));

                                if (boni != 0)
                                {
                                    btype = map.planBoniTypes.getBonusType(map.systems.getType(item, planetIndex));

                                    tip = "+%1% %2";

                                    tip = tip.replace("%1", Integer.toString(boni * 5));

                                    if (btype == PlanetBonusTypes.energy)
                                    {
                                        btype = 279;
                                        boni = 0;
                                        cachestr = cachestr + "bie.tga";
                                    }
                                    else
                                    {
                                        btype = 365;
                                        boni = 1;
                                        cachestr = cachestr + "bif1.tga";
                                    }

                                    tip = tip.replace("%2", map.lexicon.getEntry(btype));
                                }
                                else
                                {
                                    tip = null;
                                }

                                if (aniCache.containsKey(cachestr))
                                {
                                    ani = aniCache.get(cachestr);

                                    lstDetails.addItem(ani,
                                                name, type, null,
                                                new int[]{planet, item, planetIndex});
                                }
                                else if (map.res.hasInternalFile(pic))
                                {
                                    if (pic.toLowerCase().endsWith(".ani"))
                                    {
                                        ani = map.res.getAnimation(pic, false);

                                        ani.setReturnedFrameMaxSize(detailsImgSize);

                                        int bksize = (int)(detailsImgSize / ratio);

                                        background = new TargaImage(new int[bksize * bksize],
                                            bksize, bksize);

                                        ani.setBackgroundImg(background);

                                        if (tip != null)
                                        {
                                            if (boni == 0)
                                            {
                                                pic = "bie.tga";
                                            }
                                            else
                                            {
                                                pic = "bif1.tga";
                                            }

                                            TargaImage pbi = map.res.getTargaImage(pic, true);

                                            ani.setOverlayImg(
                                                    0,
                                                    0, pbi);

                                            aniCache.put(ani.getName() + pic, ani);
                                        }
                                        else
                                        {
                                            aniCache.put(pic, ani);
                                        }

                                        lstDetails.addItem(ani,
                                                name, type, null,
                                                new int[]{planet, item, planetIndex});
                                    }
                                    else
                                    {
                                        lstDetails.addItem((ImageIcon)null,
                                                name, type, null,
                                                new int[]{planet, item, planetIndex});
                                    }
                                }
                                else
                                {
                                    lstDetails.addItem((ImageIcon)null,
                                            name, type, null,
                                            new int[]{planet, item, planetIndex});
                                }

                                lstDetails.setTooltip(planetIndex + 1, tip);

                                boni = map.systems.getTerraPoints(item, planetIndex);
                                btype = map.planspac.get(
                                        map.systems.getType(item, planetIndex),
                                        (byte)map.systems.getSize(item, planetIndex),
                                        map.systems.getUniBoni(item, planetIndex),
                                        map.systems.getPopBoni(item, planetIndex));

                                if (btype == 0)
                                {
                                    lstDetails.setItemLine2Foreground(planetIndex + 1, Color.BLUE);
                                }
                                else if (boni == 0)
                                {
                                    lstDetails.setItemLine2Foreground(planetIndex + 1, Color.GREEN);
                                }
                                else if (map.systems.getTerraformed(item, planetIndex) == 0)
                                {
                                    lstDetails.setItemLine2Foreground(planetIndex + 1, Color.RED);
                                }
                                else
                                {
                                    lstDetails.setItemLine2Foreground(planetIndex + 1, Color.YELLOW);
                                }
                            }
                        }
                    }
                }
                catch (Exception e)
                {
                    UE.displayError(e);
                }

            if (item >= 0)
            {
                txtDetailsDesc.setText("<html><br><center><font size=\"4\" face=\""
                        + def.getFamily() + "\" color=\"white\">" +
                        "Hover the cursor<br>" +
                        "over an item for details<br>" +
                        "and right click on it to edit.</center></font></html>");
            }
            else
            {
                txtDetailsDesc.setText("");
            }
        }
        else if (outpost != null)
        {
            txtDetailsDesc.setText("<html><br><center><font size=\"4\" face=\""
                    + def.getFamily() + "\" color=\"white\">" +
                    "Hover the cursor<br>" +
                    "over an item for details<br>" +
                    "and right click on it to edit.</center></font></html>");

            try
            {
                short item = map.outposts.getShipID(outpost);
                String name = map.outposts.getName(outpost);

                if (item >= 0)
                {
                    String pic = map.ships.getImageName(item);
                    double cost = map.outposts.getProductionCost(outpost);
                    double invested = map.outposts.getProductionInvested(outpost);

                    if (cost <= invested)
                    {
                        pic = "i_" + pic + "120.tga";
                    }
                    else
                    {
                        pic = "i_" + pic + "w.tga";
                    }

                    if (map.res.hasInternalFile(pic))
                    {
                        TargaImage tga = map.res.getTargaImage(pic, true);

                        int scale = detailsImgSize;

                        Dimension size = tga.getImageSize();

                        if (scale < size.height)
                        {
                            double ratio = scale / (double) size.height;

                            int hor = (int)(ratio * size.width);

                            if (hor > scale) scale = hor;

                            lstDetails.addItem(
                                    new ImageIcon(tga.getThumbnail(scale, false, true)),
                                    name, null, null,
                                    new int[]{MapGUIv2.outpost, outpost});
                        }
                        else
                        {
                            lstDetails.addItem(new ImageIcon(tga.getImage(true)),
                                    name, null, null,
                                    new int[]{MapGUIv2.outpost, outpost});
                        }
                    }
                    else
                    {
                        lstDetails.addItem((ImageIcon)null,
                                    name, null, null,
                                    new int[]{MapGUIv2.outpost, outpost});
                    }
                }
            }
            catch (Exception ex)
            {
                UE.displayError(ex);
            }
        }
        else if (taskforce != null)
        {
            // details
            try
            {
                int columns = jspDetails.getWidth() / (detailsImgSize + 30);
                int rows = (int)Math.ceil((1.0 * map.gWTForce.getNumberOfShips(taskforce)) / columns);

                lstDetails.setRowsAndColumnsNumber(rows, columns);
                lstDetails.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);

                String strSpeed = Integer.toString((int)map.gWTForce.getSpeed(taskforce));
                int range = (int)map.gWTForce.getGalRange(taskforce);

                String strRange = null;

                switch (range)
                {
                    case 0:
                    {
                        strRange = map.lexicon.getEntry(1147);
                        break;
                    }
                    case 1:
                    {
                        strRange = map.lexicon.getEntry(1156);
                        break;
                    }
                    default:
                    {
                        strRange = map.lexicon.getEntry(611);
                    }
                }

                String scanRange = Integer.toString(map.gWTForce.getScanRange(taskforce));

                int maintenance = 0, beams = 0, torp = 0;
                int typeID;

                int[] ids = map.gWTForce.getShipIDs(taskforce);

                for (int i = 0; i < ids.length; i++)
                {
                    typeID = map.gShipList.getShipTypeID((short)ids[i]);
                    maintenance += map.ships.getMaintenance(typeID);
                    beams += map.ships.getBeamNum(typeID) *
                            map.ships.getBeamDamage(typeID);
                    torp += map.ships.getTorpNum(typeID) *
                            map.ships.getTorpDamage(typeID);
                }


                txtDetailsDesc.setText("<html><center><table cellpadding=0><font size=\"4\" face=\""
                + def.getFamily() + "\" color=\"white\">"
                + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(405).toUpperCase() + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + strSpeed + "</pre></td></tr>"
                + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(404).toUpperCase() + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + strRange + "</pre></td></tr>"
                + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(1097).toUpperCase() + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + scanRange + "</td></tr>"
                + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(615).toUpperCase() + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + maintenance + "</td></tr>"
                + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">BEAM FIREPOWER</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + beams + "</td></tr>"
                + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">TORPEDO FIREPOWER</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + torp + "</td></tr>"
                + "</font></table></center></html>");
            } catch (InvalidArgumentsException ex) {
                UE.displayError(ex);
            }

            try
            {
                for (int shipID : map.gWTForce.getShipIDs(taskforce))
                {
                    String pic = map.ships.getImageName(map.gShipList.getShipTypeID((short)shipID));
                    pic = "i_" + pic + "120.tga";

                    if (map.res.hasInternalFile(pic))
                    {
                        TargaImage tga = map.res.getTargaImage(pic, true);

                        int scale = detailsImgSize;

                        Dimension size = tga.getImageSize();

                        if (scale < size.height)
                        {
                            double ratio = scale / (double) size.height;

                            int hor = (int)(ratio * size.width);

                            if (hor > scale) scale = hor;

                            lstDetails.addItem(
                                    new ImageIcon(tga.getThumbnail(scale, false, true)),
                                    null, null, null,
                                    new int[]{MapGUIv2.ship, taskforce, shipID});
                        }
                        else
                        {
                            lstDetails.addItem(new ImageIcon(tga.getImage(true)),
                                    null, null, null,
                                    new int[]{MapGUIv2.ship, taskforce, shipID});
                        }
                    }
                    else
                    {
                        lstDetails.addItem((ImageIcon)null,
                                    null, null, null,
                                    new int[]{MapGUIv2.ship, taskforce, shipID});
                    }
                }
            }
            catch (Exception ex)
            {
                UE.displayError(ex);
            }
        }
        else
        {
            txtDetailsDesc.setText("");
        }

        lstDetails.setVisible(false);
        lstDetails.setVisible(true);
    }

    private class ViewListener implements ActionListener {

        int index;

        public ViewListener(int index) {
            this.index = index;
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
            map.setView(index);
        }
    }

    private class SectorSelectionListener implements ActionListener
    {
        @Override
        public void actionPerformed(ActionEvent evt)
        {
            // check selection
            Point sector = map.selection1;

            updateMilitaryList(sector);

            if (prev_sector == null || sector == null || !sector.equals(prev_sector))
            {
                updateDetailsList(sector, null, null);
            }

            SwingUtilities.invokeLater(new Runnable()
            {
                @Override
                public void run()
                {
                    if (lstMilitary.getWidth() >= jspMilitary.getWidth())
                    {
                        Dimension dim = jspMilitary.getPreferredSize();
                        dim.width = lstMilitary.getWidth() + 5;
                        jspMilitary.setPreferredSize(dim);
                        setVisible(false);
                        setVisible(true);
                    }
                    if (jspDetails.getVerticalScrollBar().isShowing())
                    {
                        Dimension dim = jspDetails.getPreferredSize();
                        dim.height = lstDetails.getHeight() + 5 + jspDetails.getHorizontalScrollBar().getHeight();
                        jspDetails.setPreferredSize(dim);
                        setVisible(false);
                        setVisible(true);
                    }
                }
            });

            prev_sector = sector;
        }
    }

    private class RightClickSelectionListener implements SelectionListener
    {
        @Override
        public void selected(SelectionEvent event)
        {
            int[] index = event.getSelectedIndex();
            ArrayList<JMenuItem> items = null;
            String title = null;

            try
            {
                switch (index[0])
                {
                    case outpost:
                    {
                        items = MapGUIv2RightClickMenus.getOutpostMenu(map, index[1]);
                        title = map.outposts.getName(index[1]);
                        break;
                    }
                    case taskforce:
                    {
                        // TODO:
                        items = new ArrayList<JMenuItem>();
                        JMenuItem item = new JMenuItem("No options for this item implemented yet");
                        item.setEnabled(false);
                        items.add(item);
                        break;
                    }
                    case stellar_object:
                    {
                        items = MapGUIv2RightClickMenus.getStellarObjectMenu(map, index[1]);
                        title = map.objects.getName(index[1]);
                        break;
                    }
                    case system:
                    {
                        items = MapGUIv2RightClickMenus.getSystemMenu(map, index[1]);
                        title = map.systems.getName(index[1]);
                        break;
                    }
                    case planet:
                    {
                        // TODO:
                        items = new ArrayList<JMenuItem>();
                        JMenuItem item = new JMenuItem("No options for this item implemented yet");
                        item.setEnabled(false);
                        items.add(item);
                        break;
                    }
                    case ship:
                    {
                        // TODO:
                        items = new ArrayList<JMenuItem>();
                        JMenuItem item = new JMenuItem("No options for this item implemented yet");
                        item.setEnabled(false);
                        items.add(item);
                        break;
                    }
                    default:
                    {
                        items = MapGUIv2RightClickMenus.getSectorMenu(map,
                                map.view - 1, index[1]);
                        title = map.sectors.getDescription(index[1], false);
                    }
                }
            }
            catch (Exception ex)
            {
                items = null;
                UE.displayError(ex);
            }
            
            if (items != null)
            {
                JPopupMenu menu = new JPopupMenu(title);

                JMenuItem mnuItem;

                for (int i = 0; i < items.size(); i++)
                {
                    mnuItem = items.get(i);
                    mnuItem.setFont(UE.SETTINGS.getDefaultFont());
                    menu.add(mnuItem);
                }

                menu.pack();

                Point loc = event.getLocation();
                
                loc.x = loc.x - UE.WINDOW.getX() - menu.getPreferredSize().width;
                loc.y = loc.y - UE.WINDOW.getY();

                menu.show(UE.WINDOW, loc.x, loc.y);
            }
        }
    }

    private class MilitarySelectionListener implements ListSelectionListener
     {
        private int[] militaryID = null;

        @Override
        public void valueChanged(ListSelectionEvent e)
        {
            if (lstMilitary.getSelectedItemIndex() >= 0)
            {
                militaryID = lstMilitary.getSelectedItemID();

                // draw path
                if (militaryID[0] == taskforce)
                {   // taskforce
                    map.selectTaskForcePath(militaryID[1], true);
                    updateDetailsList(null, militaryID[1], null);
                }
                else
                {   // outpost
                    map.selectTaskForcePath(-1, false);
                    updateDetailsList(null, null, militaryID[1]);
                }
            }
            else
            {
                map.selectTaskForcePath(-1, false);
                updateDetailsList(map.selection1, null, null);
            }

            SwingUtilities.invokeLater(new Runnable()
            {
                @Override
                public void run()
                {
                    if (jspDetails.getVerticalScrollBar().isShowing())
                    {
                        Dimension dim = jspDetails.getPreferredSize();
                        dim.height = lstDetails.getHeight() + 5 + jspDetails.getHorizontalScrollBar().getHeight();
                        jspDetails.setPreferredSize(dim);
                        setVisible(false);
                        setVisible(true);
                    }
                }
            });
        }
     }

     private class DetailsSelectionListener implements ListSelectionListener
     {
        private int[] itemID = null;

        @Override
        public void valueChanged(ListSelectionEvent e)
        {
            if (lstDetails.getSelectedItemIndex() >= 0)
            {
                itemID = lstDetails.getSelectedItemID();

                if (itemID[0] == stellar_object)
                {
                    try
                    {
                        int type = map.objects.getType(itemID[1]);

                        txtDetailsDesc.setText(
                                "<html><div width: 100px word-wrap: break-word><center><font size=\"3\" face=\""
                                + def.getFamily() + "\" color=\"white\"><br>"
                                + getAnomalyDescString(type) + "</center></div></html>");
                    }
                    catch (InvalidArgumentsException ex)
                    {
                        UE.displayError(ex);
                    }
                }
                else if (itemID[0] == system)
                {
                    try {
                        // name, star type, race, population, max pop, orbitals, ground combat
                        int fsize = 3;

                        //(int)Math.floor((txtDetailsDesc.getHeight() / 9.0) / 4.0);

//                        System.out.println("Font size: " + fsize);
                        
                        String type = getAnomalyTypeString(map.systems.getType(itemID[1]));
                        
                        int pop = map.systems.getPopulation(itemID[1]);
                        String popStr = "";

                        String race = "";

                        if (pop > 0)
                        {
                            popStr = Integer.toString(pop);
                            race = map.races.getName(map.systems.getResident(itemID[1]));
                        }

                        pop = 0;
                        int mPop = 0;
                        int val;

                        for (int p = 0; p < map.systems.planets(itemID[1]); p++)
                        {
                            val = map.planspac.get(
                                    (byte)map.systems.getType(itemID[1], p),
                                    (byte)map.systems.getSize(itemID[1], p),
                                    map.systems.getUniBoni(itemID[1], p),
                                    map.systems.getPopBoni(itemID[1], p));

                            if (val > 0)
                            {
                                if (map.systems.getTerraPoints(itemID[1], p) <= map.systems.getTerraformed(itemID[1], p))
                                {
                                    pop = pop + val;
                                }

                                mPop += val;
                            }
                        }

                        String maxPop = pop + " / " + mPop;

                        String groundCombat = "";

                        int r = map.systems.getResident(itemID[1]);

                        if (r >= 0 && r < map.races.getNumberOfEntries())
                        {
                            double techMulti = Tools.toDouble(map.groundCombatTechMulti.getData(), true);

                            techMulti = techMulti * map.techInfo.getTechLevel((short)r, 6);

                            double defense = pop * map.races.getCombatMulti(r) * (1.0 + techMulti);
                            r = map.systems.getControling(itemID[1]);

                            if (r >= 0 && r < 5)
                            {
                                defense = defense *
                                    (1.0 + map.empireInfo.getGroundCombatBonus(r)/100.0);
                            }

                            int num;

                            if (r < 0 || r > 4)
                            {
                                r = 5;
                            }

                            for (short bid : map.strcInfo.getBuildings((short)itemID[1]))
                            {
                                num = map.strcInfo.getPoweredOnCount((short)itemID[1], bid);

                                if (num > 0 && map.edifice.getBoniType(bid) == 37)
                                {
                                    defense = defense * (1.0 + num * map.edifice.getBoni(bid, r)/100.0);
                                }
                            }

                            groundCombat = Integer.toString((int)Math.floor(defense));
                        }

                        int orbid = map.edifice.getTrekExeID(Edifice.ORBITAL_BATTERY_ID);
                        String orbs = "";

                        if (orbid >= 0 && popStr.length() > 0)
                        {
                            orbs = map.strcInfo.getPoweredOnCount((short)itemID[1], (short)orbid) +
                                    " / " + map.strcInfo.getCount((short)itemID[1], (short)orbid);
                        }

                        String desc =
                          "<html><center><table cellpadding=0><tr><td>"
                        + "<font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"yellow\">" + map.systems.getName(itemID[1])
                        + "</td></tr><tr><td><table cellpadding=0><font size=\"" + fsize + "\" face=\""
                        + def.getFamily() + "\" color=\"white\">"
                        + "<tr><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(1374) + "</td><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + type + "</pre></td></tr>";

                        if (race.length() > 0)
                        {
                            desc = desc + "<tr><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(965) + "</td><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + race + "</td></tr>"
                                        + "<tr><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(919) + "</td><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + popStr + "</td></tr>";
                        }

                        desc = desc + "<tr><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(626) + "</td><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + maxPop + "</td></tr>";

                        if (groundCombat.length() > 0)
                        {
                            desc = desc + "<tr><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(422) + "</td><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + groundCombat + "</td></tr>";
                        }

                        if (orbs.length() > 0)
                        {
                            desc = desc + "<tr><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(891) + "</td><td><font size=\"" + fsize + "\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + orbs + "</td></tr>";
                        }

                        desc = desc + "</font></table></td></tr></table></center></html>";

                        txtDetailsDesc.setText(desc);
                    }
                    catch (Exception ex)
                    {
                        UE.displayError(ex);
                    }
                }
                else if (itemID[0] == outpost)
                {
                    try {
                        // type, hull (hit points), shield strength, maintenance, weapons
                        String type;
                        int tmp = map.outposts.getType(itemID[1]);

                        if (tmp == 6)
                        {
                            type = map.lexicon.getEntry(895);
                        }
                        else if (tmp == 7)
                        {
                            type = map.lexicon.getEntry(57);
                        }
                        else
                        {
                            type = map.lexicon.getEntry(1393);
                        }

                        int shipID = map.outposts.getShipID(itemID[1]);

                        String hitpoints = "%1 / %2";
                        int val = map.outposts.getHull(itemID[1]);
                        hitpoints = hitpoints.replace("%1", Integer.toString(val));
                        val = map.ships.getHullStr(shipID);
                        hitpoints = hitpoints.replace("%2", Integer.toString(val));

                        String shieldStr = Integer.toString(map.ships.getShieldStr(shipID));
                        String maintenance = Integer.toString(map.ships.getMaintenance(shipID));
                        
                        String beams = "%1 x %2";
                        beams = beams.replace("%1", Integer.toString(map.ships.getBeamNum(shipID)));
                        beams = beams.replace("%2", Integer.toString(map.ships.getBeamDamage(shipID)));
                        
                        String torp = "%1 x %2";
                        torp = torp.replace("%1", Integer.toString(map.ships.getTorpNum(shipID)));
                        torp = torp.replace("%2", Integer.toString(map.ships.getTorpDamage(shipID)));

                        txtDetailsDesc.setText(
                              "<html><center><table cellpadding=0><tr><td>"
                            + "<font size=\"3\" face=\"" + def.getFamily() + "\" color=\"yellow\">" + map.outposts.getName(itemID[1])
                            + "</td></tr><tr><td><table cellpadding=0><font size=\"3\" face=\""
                            + def.getFamily() + "\" color=\"white\">"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(1374) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + type + "</pre></td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(434) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + hitpoints + "</td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(1115) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + shieldStr + "</td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(615) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + maintenance + "</td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">Beam Weapons</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + beams + "</td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">Torpedo Weapons</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + torp + "</td></tr>"
                            + "</font></table></td></tr></table></center></html>");
                        
                    } catch (InvalidArgumentsException ex) {
                        UE.displayError(ex);
                    }
                }
                else if (itemID[0] == planet)
                {
                    try {
                        // type, atmo, uninhabitable / (maxpop, race/terraform)
                        String type = getPlanetTypeString(map.systems.getType(itemID[1], itemID[2]));

                        String atmo = getAtmoTypeString(map.systems.getAtmosphere(itemID[1], itemID[2]));

                        int pop = map.planspac.get(
                                (byte)map.systems.getType(itemID[1], itemID[2]),
                                (byte)map.systems.getSize(itemID[1], itemID[2]),
                                map.systems.getUniBoni(itemID[1], itemID[2]),
                                map.systems.getPopBoni(itemID[1], itemID[2]));

                        String maxPop = Integer.toString(pop);

                        String race = "";
                        if (pop > 0)
                        {
                            int r = map.systems.getResident(itemID[1]);

                            if (r >= 0 && r < map.races.getNumberOfEntries())
                            {
                                race = map.races.getName(r);
                            }
                        }

                        String terra = "";

                        if (map.systems.getTerraPoints(itemID[1], itemID[2]) >
                                map.systems.getTerraformed(itemID[1], itemID[2]))
                        {
                            if (map.systems.getTerraformed(itemID[1], itemID[2]) > 0)
                            {
                                terra = ((100 * map.systems.getTerraformed(itemID[1], itemID[2]))
                                    / map.systems.getTerraPoints(itemID[1], itemID[2])) + "%";
                            }
                            else
                            {
                                terra = "0 / " + map.systems.getTerraPoints(itemID[1], itemID[2]);
                            }
                        }

                        String sizeStr = "";

                        switch (map.systems.getSize(itemID[1], itemID[2]))
                        {
                            case 0:
                            {
                                sizeStr = map.lexicon.getEntry(1158);
                                break;
                            }
                            case 1:
                            {
                                sizeStr = map.lexicon.getEntry(627);
                                break;
                            }
                            default:
                            {
                                sizeStr = map.lexicon.getEntry(596);
                            }
                        }

                        String desc = 
                          "<html><center><table cellpadding=0><tr><td>"
                        + "<font size=\"3\" face=\"" + def.getFamily() + "\" color=\"yellow\">" + map.systems.getName(itemID[1], itemID[2])
                        + "</td></tr><tr><td><table cellpadding=0><font size=\"3\" face=\""
                        + def.getFamily() + "\" color=\"white\">"
                        + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(1374) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + type + "</pre></td></tr>"
                        + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + "Size" + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + sizeStr + "</pre></td></tr>"
                        + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + "Atmosphere" + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + atmo + "</pre></td></tr>";

                        if (pop > 0)
                        {
                            desc = desc + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(626) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + maxPop + "</td></tr>";

                            if (terra.length() > 0)
                            {
                                desc = desc + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(1256) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + terra + "</td></tr>";
                            }
                            else
                            {
                                desc = desc + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\"></td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + race + "</td></tr>";
                            }
                        }
                        else
                        {
                            desc = desc + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\"></td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + map.lexicon.getEntry(1387) + "</td></tr>";
                        }
                        
                        desc = desc + "</font></table></td></tr></table></center></html>";

                        txtDetailsDesc.setText(desc);
                    }
                    catch (InvalidArgumentsException ex)
                    {
                        UE.displayError(ex);
                    }
                }
                else if (itemID[0] == ship)
                {
                    try
                    {
                        // name, class, type, hull (hit points), shield strength, maintenance, weapons
                        short shipID = (short)itemID[2];
                        int typeID = map.gShipList.getShipTypeID(shipID);

                        String name = map.gShipList.getShipName(shipID);

                        String strClass = map.ships.getClass(typeID);

                        String strFunc = getShipTypeString(map.ships.getFunction(typeID));

                        String hitpoints = "%1 / %2";
                        int val = map.gShipList.getHullStr(shipID);
                        hitpoints = hitpoints.replace("%1", Integer.toString(val));
                        val = map.ships.getHullStr(typeID);
                        hitpoints = hitpoints.replace("%2", Integer.toString(val));

                        String shieldStr = Integer.toString(map.ships.getShieldStr(typeID));

                        String maintenance = Integer.toString(map.ships.getMaintenance(typeID));

                        String beams = "%1 x %2";
                        beams = beams.replace("%1", Integer.toString(map.ships.getBeamNum(typeID)));
                        beams = beams.replace("%2", Integer.toString(map.ships.getBeamDamage(typeID)));

                        String torp = "%1 x %2";
                        torp = torp.replace("%1", Integer.toString(map.ships.getTorpNum(typeID)));
                        torp = torp.replace("%2", Integer.toString(map.ships.getTorpDamage(typeID)));

                        txtDetailsDesc.setText(
                            "<html><center><table cellpadding=0><tr><td>"
                            + "<font size=\"3\" face=\"" + def.getFamily() + "\" color=\"yellow\">" + name
                            + "</td></tr><tr><td><table cellpadding=0><font size=\"3\" face=\""
                            + def.getFamily() + "\" color=\"white\">"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(1374) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + strFunc + "</pre></td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + Tools.capitalizeWords(map.lexicon.getEntry(1121)) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + strClass + "</pre></td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(434) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + hitpoints + "</td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(1115) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + shieldStr + "</td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(615) + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + maintenance + "</td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">Beam Weapons</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + beams + "</td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">Torpedo Weapons</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + torp + "</td></tr>"
                            + "</font></table></td></tr></table></center></html>");

                    } catch (InvalidArgumentsException ex) {
                        UE.displayError(ex);
                    }
                }
                else
                {
                    txtDetailsDesc.setText("<html><br><br><br><center><font size=\"4\" face=\""
                            + def.getFamily() + "\" color=\"white\">" +
                            "TODO: List details for item type " + itemID[0]);
                }
            }
            else
            {
                if (lstDetails.getNumberOfItems() > 0)
                {
                    int[] milItemID = lstMilitary.getSelectedItemID();

                    if (milItemID != null && milItemID[0] == taskforce)
                    {
                        try
                        {
                            String strSpeed = Integer.toString((int)map.gWTForce.getSpeed(milItemID[1]));
                            int range = (int)map.gWTForce.getGalRange(milItemID[1]);

                            String strRange = null;

                            switch (range)
                            {
                                case 0:
                                {
                                    strRange = map.lexicon.getEntry(1147);
                                    break;
                                }
                                case 1:
                                {
                                    strRange = map.lexicon.getEntry(1156);
                                    break;
                                }
                                default:
                                {
                                    strRange = map.lexicon.getEntry(611);
                                }
                            }

                            String scanRange = Integer.toString(map.gWTForce.getScanRange(milItemID[1]));

                            int maintenance = 0;
                            int beams = 0;
                            int torp = 0;
                            int typeID;

                            int[] ids = map.gWTForce.getShipIDs(itemID[1]);

                            for (int i = 0; i < ids.length; i++)
                            {
                                typeID = map.gShipList.getShipTypeID((short)ids[i]);
                                maintenance += map.ships.getMaintenance(typeID);
                                beams += map.ships.getBeamNum(typeID) *
                                        map.ships.getBeamDamage(typeID);
                                torp += map.ships.getTorpNum(typeID) *
                                        map.ships.getTorpDamage(typeID);
                            }


                            txtDetailsDesc.setText("<html><center><table cellpadding=0><font size=\"4\" face=\""
                            + def.getFamily() + "\" color=\"white\">"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(405).toUpperCase() + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + strSpeed + "</pre></td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(404).toUpperCase() + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + strRange + "</pre></td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(1097).toUpperCase() + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + scanRange + "</td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">" + map.lexicon.getEntry(615).toUpperCase() + "</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + maintenance + "</td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">BEAM FIREPOWER</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + beams + "</td></tr>"
                            + "<tr><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"teal\">TORPEDO FIREPOWER</td><td><font size=\"3\" face=\"" + def.getFamily() + "\" color=\"white\"> &nbsp;&nbsp;&nbsp;" + torp + "</td></tr>"
                            + "</font></table></center></html>");
                        } catch (InvalidArgumentsException ex) {
                            UE.displayError(ex);
                        }
                    }
                    else
                    {
                        txtDetailsDesc.setText("<html><br><center><font size=\"4\" face=\""
                                + def.getFamily() + "\" color=\"white\">" +
                                "Hover the cursor<br>" +
                                "over an item for details<br>" +
                                "and right click on it to edit.</center></font></html>");
                    }
                }
                else
                {
                    txtDetailsDesc.setText("");
                }
            }
        }
     }
}
