/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SelectSectorDialog.java
 *
 * Created on 6.3.2011, 15:38:17
 */

package ue.gui.sav;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import ue.UE;
import ue.edit.exe.Trek;
import ue.edit.res.Stbof;
import ue.edit.sav.SavGame;

/**
 *
 * @author Alan
 */
public class SelectSectorDialog extends javax.swing.JDialog
{
    private MapPanel map;
    private JButton btnOK;
    private JButton btnCancel;
    private Point sector;

    /** Creates new form SelectSectorDialog */
    public SelectSectorDialog(java.awt.Frame parent, boolean modal,
            SavGame game, Stbof res, Trek exe)
    {
        super(parent, modal);
        initComponents();
        setupComponents(game, res, exe);
        setTitle(UE.APP_NAME + " - " + "Select sector");

        if (parent != null)
        {
            this.setSize(parent.getSize());
            setLocation(parent.getLocationOnScreen());
        }
        else
        {
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            Dimension size = getSize();
            setLocation(new Point(
                    (int)(screenSize.getWidth() - size.getWidth()) / 2,
                    (int)(screenSize.getHeight() - size.getHeight()) / 2));
        }
    }

    private void setupComponents(SavGame game, Stbof res, Trek exe)
    {
        map = new MapPanel(game, res, exe);
        map.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent e)
            {
                sector = map.selection1;
                btnOK.setEnabled(sector != null);
            }
        });

        map.setView(0);

        JScrollPane scrMap = new JScrollPane(map);
        JPanel pnlMap = new JPanel(new BorderLayout());
        pnlMap.setBorder(BorderFactory.createEmptyBorder(10, 10, 5, 10));
        pnlMap.add(scrMap, BorderLayout.CENTER);

        JPanel pnlActions = new JPanel();
        pnlActions.setLayout(new GridLayout(1, 1, 10, 10));

        btnOK = new JButton("OK");
        btnOK.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent e)
            {
                setVisible(false);
            }
        });
        btnOK.setEnabled(false);

        btnCancel = new JButton("Cancel");
        btnCancel.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent e)
            {
                sector = null;
                setVisible(false);
            }
        });

        pnlActions.add(btnOK);
        pnlActions.add(btnCancel);

        Dimension dim = pnlActions.getPreferredSize();
        dim.width = Math.max(btnOK.getPreferredSize().width,
                btnCancel.getPreferredSize().width) * 2 + 10;
        pnlActions.setPreferredSize(dim);
        pnlActions.setMaximumSize(dim);

        JPanel pnlBottom = new JPanel();
        pnlBottom.setLayout(new BoxLayout(pnlBottom, BoxLayout.X_AXIS));
        pnlBottom.setBorder(BorderFactory.createEmptyBorder(10, 5, 10, 10));
        pnlBottom.add(Box.createHorizontalGlue());
        pnlBottom.add(pnlActions);

        setLayout(new BorderLayout());
        add(pnlMap, BorderLayout.CENTER);
        add(pnlBottom, BorderLayout.SOUTH);
    }

    public Point getSelectedSector()
    {
        return sector;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
