/*
Ultimate Editor for Birth Of The Federation 1.02
Copyright (C) 2005-2007  Alan Podlesek

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


File: SoundGUI.java

Written by: Alan Podlesek <seqdcer@yahoo.com>

Last modified: 6.9.2007
 */
package ue.gui.snd;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import ue.Language;
import ue.UE;
import ue.edit.res.Stbof;
import ue.edit.res.stbof.rst.Race;
import ue.edit.snd.SndFile;
import ue.gui.MainPanel;
import ue.util.ID;
import ue.util.SettingsManager;

@SuppressWarnings("serial")  //$NON-NLS-1$
public class SoundGUI extends MainPanel {

    private SndFile SND;
    private Race RACE;
    private JList lstSND;
    private JTextArea txtDESC;
    private JComboBox cmbRACE;
    private JComboBox cmbTYPE;
    private JComboBox cmbSRACE;
    private JComboBox cmbSTYPE;
    private JTextField txtSEARCH;
    private JLabel lblINDEX;
    private int SELECTED = -1;
    private boolean IGNORE = false;
    private int[] SEARCH = null;
    private int CURSEA = 0;
    // strings
    private static String strSTARTING_TASK = Language.getString("SoundGUI.0"); //$NON-NLS-1$
    private static String strCANCEL = Language.getString("SoundGUI.1"); //$NON-NLS-1$
    private static String strEXTRACT = Language.getString("SoundGUI.2"); //$NON-NLS-1$
    private static String strSAVE_AS = Language.getString("SoundGUI.3"); //$NON-NLS-1$
    private static String strSELECT_DESTINATION = Language.getString("SoundGUI.4"); //$NON-NLS-1$

    public SoundGUI(SndFile snd, Stbof st) {
        if (snd == null || st == null) {
            return;
        }

        try {
            RACE = (Race) st.getInternalFile(Stbof.fileRACE_RST, true);
        } catch (Exception et) {
            return;
        }
        if (RACE == null) {
            return;
        }
        SND = snd;
        /*CREATE*/
        JButton btnEXTRACT = new JButton(strEXTRACT);
        JButton btnEXTRACT_ALL = new JButton(Language.getString("SoundGUI.5")); //$NON-NLS-1$
        JButton btnREPLACE = new JButton(Language.getString("SoundGUI.6")); //$NON-NLS-1$
        JButton btnCREATE = new JButton(Language.getString("SoundGUI.7")); //$NON-NLS-1$
        JButton btnPLAY = new JButton(Language.getString("SoundGUI.8")); //$NON-NLS-1$
        JButton btnDESC = new JButton(Language.getString("SoundGUI.9")); //$NON-NLS-1$
        JButton btnFIND = new JButton(Language.getString("SoundGUI.10")); //$NON-NLS-1$
        JButton btnFIND_NEXT = new JButton(Language.getString("SoundGUI.11")); //$NON-NLS-1$
        lstSND = new JList();
        txtDESC = new JTextArea();
        cmbTYPE = new JComboBox();
        cmbRACE = new JComboBox();
        cmbSTYPE = new JComboBox();
        cmbSRACE = new JComboBox();
        txtSEARCH = new JTextField();
        JLabel lblSEARCH = new JLabel(Language.getString("SoundGUI.12")); //$NON-NLS-1$
        lblINDEX = new JLabel();
        /*SETUP*/
        Font def = UE.SETTINGS.getDefaultFont();
        btnEXTRACT.setFont(def);
        btnEXTRACT_ALL.setFont(def);
        btnREPLACE.setFont(def);
        btnCREATE.setFont(def);
        btnPLAY.setFont(def);
        btnDESC.setFont(def);
        btnFIND.setFont(def);
        btnFIND_NEXT.setFont(def);
        lstSND.setFont(def);
        txtDESC.setFont(def);
        cmbTYPE.setFont(def);
        cmbRACE.setFont(def);
        cmbSTYPE.setFont(def);
        cmbSRACE.setFont(def);
        txtSEARCH.setFont(def);
        lblSEARCH.setFont(def);
        lblINDEX.setFont(def);
        JScrollPane scrSND = new JScrollPane(lstSND);
        scrSND.setPreferredSize(new Dimension(80, 240));
        txtDESC.setLineWrap(true);
        txtDESC.setWrapStyleWord(true);
        JScrollPane scrDESC = new JScrollPane(txtDESC);
        scrDESC.setPreferredSize(new Dimension(160, 200));
        btnPLAY.setEnabled(SND.isPlayable());
        /*ACTION*/
        lstSND.addListSelectionListener(new ListSelectionListener() {

            @Override
            public void valueChanged(ListSelectionEvent e) {
                if (IGNORE) {
                    return;
                }
                if (lstSND.getSelectedIndex() < 0) {
                    return;
                }
                //save
                try
                {
                    finalWarning();
                }
                catch (Exception ex)
                {
                    // really bad stuff happening - bail
                    UE.displayError(ex);
                    return;
                }

                SELECTED = lstSND.getSelectedIndex();
                String msg = Language.getString("SoundGUI.13"); //$NON-NLS-1$
                msg = msg.replace("%1", Integer.toString(SELECTED)); //$NON-NLS-1$
                lblINDEX.setText(msg);
                int z = SND.getRaceDescriptor(SELECTED);
                cmbRACE.setSelectedIndex(z);
                z = SND.getTypeDescriptor(SELECTED);
                cmbTYPE.setSelectedIndex(z);
                String str = SND.getDescription(SELECTED);
                txtDESC.setText(str);
            }
        });
        cmbTYPE.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent ae) {
                if (IGNORE) {
                    return;
                }
                if (lstSND.getSelectedIndex() < 0 || cmbTYPE.getSelectedIndex() < 0) {
                    return;
                }
                SND.setTypeDescriptor(lstSND.getSelectedIndex(), (short) cmbTYPE.getSelectedIndex());
            }
        });
        cmbRACE.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                if (IGNORE) {
                    return;
                }
                if (lstSND.getSelectedIndex() < 0 || cmbRACE.getSelectedIndex() < 0) {
                    return;
                }
                SND.setRaceDescriptor(lstSND.getSelectedIndex(), (short) cmbRACE.getSelectedIndex());
            }
        });
        btnFIND.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                SEARCH = null;
                String str = (txtSEARCH.getText()).toLowerCase();
                int rac = cmbSRACE.getSelectedIndex();
                int typ = cmbSTYPE.getSelectedIndex();
                int h = SND.getNumberOfSounds();
                ArrayList<Integer> into = new ArrayList<Integer>();
                for (int i = 0; i < h; i++) {
                    //race
                    if (SND.getRaceDescriptor(i) == rac || rac == 0) {
                        if (SND.getTypeDescriptor(i) == typ || typ == 0) {
                            if ((SND.getDescription(i)).toLowerCase().contains(str)) {
                                into.add(i);
                            }
                        }
                    }
                }
                if (into.size() > 0) {
                    SEARCH = new int[into.size()];
                }
                for (int i = 0; i < into.size(); i++) {
                    SEARCH[i] = into.get(i);
                }
                if (SEARCH != null) {
                    lstSND.setSelectedIndex(SEARCH[0]);
                    lstSND.ensureIndexIsVisible(SEARCH[0]);
                }
            }
        });
        btnFIND_NEXT.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                if (SEARCH == null) {
                    return;
                }
                CURSEA++;
                if (CURSEA >= SEARCH.length) {
                    CURSEA = 0;
                }
                lstSND.setSelectedIndex(SEARCH[CURSEA]);
                lstSND.ensureIndexIsVisible(SEARCH[CURSEA]);
            }
        });
        btnEXTRACT.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                JFileChooser fc = new JFileChooser();
                fc.setCurrentDirectory(new File(UE.SETTINGS.getProperty(SettingsManager.WORK_PATH)));
                fc.setDialogTitle(UE.APP_NAME + " - " //$NON-NLS-1$
                        + strSELECT_DESTINATION);
                fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                fc.setMultiSelectionEnabled(false);
                int returnVal = fc.showDialog(UE.WINDOW, strEXTRACT);
                if (returnVal != JFileChooser.APPROVE_OPTION) {
                    return;
                }
                File fil = fc.getSelectedFile();
                UE.SETTINGS.setProperty(SettingsManager.WORK_PATH, fil.getPath());

                JOptionPane opti = new JOptionPane(strSTARTING_TASK,
                        JOptionPane.PLAIN_MESSAGE);
                opti.setOptions(new String[]{strCANCEL});

                ExtractThread ext = new ExtractThread(opti, lstSND.getSelectedIndices(), fil);
                ext.setPriority(Thread.MIN_PRIORITY);
                ext.setDaemon(true);
                ext.start();

                JDialog dia = opti.createDialog(UE.WINDOW, UE.APP_NAME);
                dia.setVisible(true);

                if ((opti.getValue()).equals(strCANCEL)) {
                    ext.endNow();
                    ext = null;
                    System.gc();
                }
            }
        });
        btnDESC.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                JFileChooser fc = new JFileChooser();
                fc.setCurrentDirectory(new File(UE.SETTINGS.getProperty(SettingsManager.WORK_PATH)));
                fc.setDialogTitle(UE.APP_NAME + " - " //$NON-NLS-1$
                        + strSAVE_AS);
                fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
                fc.setMultiSelectionEnabled(false);
                int returnVal = fc.showDialog(UE.WINDOW, Language.getString("SoundGUI.14")); //$NON-NLS-1$
                if (returnVal != JFileChooser.APPROVE_OPTION) {
                    return;
                }
                File fil = fc.getSelectedFile();
                UE.SETTINGS.setProperty(SettingsManager.WORK_PATH, fil.getParentFile().getPath());
                try {
                    FileOutputStream out = new FileOutputStream(fil);
                    SND.exportDescriptions(out, SND.getNumberOfSounds(), RACE);
                    out.close();
                } catch (Exception z) {
                    UE.displayError(z);
                }
            }
        });
        btnEXTRACT_ALL.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                JFileChooser fc = new JFileChooser();
                fc.setApproveButtonText(Language.getString("SoundGUI.2")); //$NON-NLS-1$
                fc.setCurrentDirectory(new File(UE.SETTINGS.getProperty(SettingsManager.WORK_PATH)));
                fc.setDialogTitle(UE.APP_NAME +
                        " - " + strSELECT_DESTINATION); //$NON-NLS-1$
                fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                fc.setMultiSelectionEnabled(false);
                int returnVal = fc.showDialog(UE.WINDOW, strEXTRACT);
                if (returnVal != JFileChooser.APPROVE_OPTION) {
                    return;
                }
                File fil = fc.getSelectedFile();
                UE.SETTINGS.setProperty(SettingsManager.WORK_PATH, fil.getPath());

                JOptionPane opti = new JOptionPane(strSTARTING_TASK,
                        JOptionPane.PLAIN_MESSAGE);
                opti.setOptions(new String[]{strCANCEL});

                int[] ij = new int[SND.getNumberOfSounds()];
                for (int i = 0; i < ij.length; i++) {
                    ij[i] = i;
                }
                ExtractThread ext = new ExtractThread(opti, ij, fil);
                ext.setPriority(Thread.MIN_PRIORITY);
                ext.setDaemon(true);
                ext.start();

                JDialog dia = opti.createDialog(UE.WINDOW, UE.APP_NAME);
                dia.setVisible(true);

                if ((opti.getValue()).equals(strCANCEL)) {
                    ext.endNow();
                    ext = null;
                    System.gc();
                }
            }
        });
        btnCREATE.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                JFileChooser fc = new JFileChooser();
                fc.setCurrentDirectory(new File(UE.SETTINGS.getProperty(SettingsManager.WORK_PATH)));
                fc.setDialogTitle(UE.APP_NAME +
                        " - " + strSAVE_AS); //$NON-NLS-1$
                fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
                fc.setMultiSelectionEnabled(false);
                javax.swing.filechooser.FileFilter filter = new javax.swing.filechooser.FileFilter() {

                    @Override
                    public boolean accept(File f) {
                        if (f.isDirectory()) {
                            return true;
                        }
                        String name = f.getName();
                        name = name.toLowerCase();
                        if (name.endsWith(".wav")) { //$NON-NLS-1$
                            return true; //$NON-NLS-1$
                        } else {
                            return false;
                        }
                    }

                    @Override
                    public String getDescription() {
                        return Language.getString("SoundGUI.15"); //$NON-NLS-1$
                    }
                };
                fc.setFileFilter(filter);
                int returnVal = fc.showDialog(UE.WINDOW, Language.getString("SoundGUI.16")); //$NON-NLS-1$
                if (returnVal != JFileChooser.APPROVE_OPTION) {
                    return;
                }
                File fil = fc.getSelectedFile();
                UE.SETTINGS.setProperty(SettingsManager.WORK_PATH, fil.getParentFile().getPath());
                try {
                    SND.thinkBig(fil);
                } catch (Exception zu) {
                    UE.displayError(zu);
                }
            }
        });
        btnREPLACE.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                if (lstSND.getSelectedIndex() < 0) {
                    return;
                }
                JFileChooser fc = new JFileChooser();
                fc.setApproveButtonText(Language.getString("SoundGUI.6")); //$NON-NLS-1$
                fc.setCurrentDirectory(new File(UE.SETTINGS.getProperty(SettingsManager.WORK_PATH)));
                fc.setDialogTitle(UE.APP_NAME + " - " //$NON-NLS-1$
                        + Language.getString("SoundGUI.17")); //$NON-NLS-1$
                fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
                fc.setMultiSelectionEnabled(false);
                javax.swing.filechooser.FileFilter filter = new javax.swing.filechooser.FileFilter() {

                    @Override
                    public boolean accept(File f) {
                        if (f.isDirectory()) {
                            return true;
                        }
                        String name = f.getName();
                        name = name.toLowerCase();
                        if (name.endsWith(".wav")) { //$NON-NLS-1$
                            return true; //$NON-NLS-1$
                        } else {
                            return false;
                        }
                    }

                    @Override
                    public String getDescription() {
                        return Language.getString("SoundGUI.15"); //$NON-NLS-1$
                    }
                };
                fc.setFileFilter(filter);
                int returnVal = fc.showDialog(UE.WINDOW, Language.getString("SoundGUI.6")); //$NON-NLS-1$
                if (returnVal != JFileChooser.APPROVE_OPTION) {
                    return;
                }
                File fil = fc.getSelectedFile();

                UE.SETTINGS.setProperty(SettingsManager.WORK_PATH, fil.getParentFile().getPath());
                try {
                    SND.replace(SELECTED, fil);
                } catch (Exception zu) {
                    UE.displayError(zu);
                }
            }
        });
        btnPLAY.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                if (lstSND.getSelectedIndex() < 0) {
                    return;
                }
                try {
                    SND.play(lstSND.getSelectedIndex());
                } catch (Exception e) {
                    UE.displayError(e);
                }
            }
        });
        /*ADD*/
        setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
        c.insets = new Insets(5, 5, 5, 5);
        c.fill = GridBagConstraints.BOTH;
        //line 1
        c.gridx = 0;
        c.gridy = 0;
        c.gridwidth = 1;
        c.gridheight = 1;
        add(cmbRACE, c);
        c.gridx = 1;
        add(cmbTYPE, c);
        c.gridx = 2;
        c.gridwidth = 2;
        c.gridheight = 7;
        add(scrSND, c);
        c.gridx = 4;
        c.gridwidth = 1;
        c.gridheight = 1;
        add(btnEXTRACT, c);
        //line 2
        c.gridx = 0;
        c.gridy = 1;
        c.gridwidth = 2;
        c.gridheight = 6;
        add(scrDESC, c);
        c.gridx = 4;
        c.gridwidth = 1;
        c.gridheight = 1;
        add(btnREPLACE, c);
        //line 3
        c.gridx = 4;
        c.gridy = 2;
        c.gridwidth = 1;
        c.gridheight = 1;
        add(btnEXTRACT_ALL, c);
        //line 4
        c.gridx = 4;
        c.gridy = 3;
        c.gridwidth = 1;
        c.gridheight = 1;
        add(btnCREATE, c);
        //line 5
        c.gridx = 4;
        c.gridy = 4;
        c.gridwidth = 1;
        c.gridheight = 1;
        add(btnPLAY, c);
        //line 6
        c.gridx = 4;
        c.gridy = 5;
        c.gridwidth = 1;
        c.gridheight = 1;
        add(btnDESC, c);
        //line 6
        c.gridx = 4;
        c.gridy = 6;
        c.gridwidth = 1;
        c.gridheight = 1;
        add(lblINDEX, c);
        //line 8
        c.gridx = 0;
        c.gridy = 7;
        c.gridwidth = 1;
        c.gridheight = 1;
        add(lblSEARCH, c);
        //line 9
        c.gridx = 0;
        c.gridy = 8;
        c.gridwidth = 1;
        c.gridheight = 1;
        add(txtSEARCH, c);
        c.gridx = 1;
        add(cmbSRACE, c);
        c.gridx = 2;
        add(cmbSTYPE, c);
        c.gridx = 3;
        add(btnFIND, c);
        c.gridx = 4;
        add(btnFIND_NEXT, c);
        /*FILL*/
        try {
            //races
            String strUN = Language.getString("SoundGUI.18"); //$NON-NLS-1$
            String strN = Language.getString("SoundGUI.19"); //$NON-NLS-1$
            cmbSRACE.addItem(new ID(strUN, 0));
            cmbSRACE.addItem(new ID(strN, 1));
            cmbRACE.addItem(new ID(strUN, 0));
            cmbRACE.addItem(new ID(strN, 1));
            for (int i = 0; i < 5; i++) {
                cmbSRACE.addItem(new ID(RACE.getName(i), i + 2));
                cmbRACE.addItem(new ID(RACE.getName(i), i + 2));
            }
            cmbRACE.addItem(new ID(Language.getString("SoundGUI.31"), 7)); //$NON-NLS-1$
            cmbSRACE.addItem(new ID(Language.getString("SoundGUI.31"), 7)); //$NON-NLS-1$

            //type
            cmbSTYPE.addItem(new ID(strUN, 0));
            cmbSTYPE.addItem(new ID(Language.getString("SoundGUI.20"), 1)); //$NON-NLS-1$
            cmbSTYPE.addItem(new ID(Language.getString("SoundGUI.21"), 2)); //$NON-NLS-1$
            cmbSTYPE.addItem(new ID(Language.getString("SoundGUI.22"), 3)); //$NON-NLS-1$
            cmbSTYPE.addItem(new ID(Language.getString("SoundGUI.23"), 4)); //$NON-NLS-1$
            cmbSTYPE.addItem(new ID(Language.getString("SoundGUI.24"), 5)); //$NON-NLS-1$
            cmbSTYPE.addItem(new ID(Language.getString("SoundGUI.25"), 6)); //$NON-NLS-1$
            cmbSTYPE.addItem(new ID(Language.getString("SoundGUI.26"), 7)); //$NON-NLS-1$
            cmbSTYPE.addItem(new ID(Language.getString("SoundGUI.27"), 8)); //$NON-NLS-1$
            cmbTYPE.addItem(new ID(strUN, 0));
            cmbTYPE.addItem(new ID(Language.getString("SoundGUI.20"), 1)); //$NON-NLS-1$
            cmbTYPE.addItem(new ID(Language.getString("SoundGUI.21"), 2)); //$NON-NLS-1$
            cmbTYPE.addItem(new ID(Language.getString("SoundGUI.22"), 3)); //$NON-NLS-1$
            cmbTYPE.addItem(new ID(Language.getString("SoundGUI.23"), 4)); //$NON-NLS-1$
            cmbTYPE.addItem(new ID(Language.getString("SoundGUI.24"), 5)); //$NON-NLS-1$
            cmbTYPE.addItem(new ID(Language.getString("SoundGUI.25"), 6)); //$NON-NLS-1$
            cmbTYPE.addItem(new ID(Language.getString("SoundGUI.26"), 7)); //$NON-NLS-1$
            cmbTYPE.addItem(new ID(Language.getString("SoundGUI.27"), 8)); //$NON-NLS-1$
            //list
            fillList();
            lstSND.setSelectedIndex(0);
        } catch (Exception tut) {
            UE.displayError(tut);
        }
    }

    private void fillList() {
        int h = SND.getNumberOfSounds();
        ID[] str = new ID[h];
        for (int i = 0; i < h; i++) {
            String tut = SND.getDescription(i);
            if (tut.length() > 25) {
                tut = tut.substring(0, 22) + "..."; //$NON-NLS-1$
            }
            str[i] = new ID(tut, i);
        }
        lstSND.setListData(str);
    }

    @Override
    public void finalWarning() throws Exception {
        if (SELECTED < 0) {
            return;
        }
        IGNORE = true;
        String str = txtDESC.getText();
        SND.setDescription(SELECTED, str);
        int j = lstSND.getSelectedIndex();
        fillList();
        lstSND.setSelectedIndex(j);
        IGNORE = false;
    }

    private class ExtractThread extends Thread {

        private JOptionPane dialog;
        private boolean endNow = false;
        private int[] gug;
        private File path;

        public ExtractThread(JOptionPane dialog, int[] lol, File fil) {
            this.dialog = dialog;
            gug = lol;
            path = fil;
        }

        public void endNow() {
            endNow = true;
        }

        @Override
        public void run() {
            String msg;
            try {
                for (int i = 0; i < gug.length; i++) {
                    File dest = new File(path, gug[i] + ".wav"); //$NON-NLS-1$
                    if (dest.exists()) {
                        msg = Language.getString("SoundGUI.28"); //$NON-NLS-1$
                        msg = msg.replace("%1", gug[i] + ".wav"); //$NON-NLS-1$ //$NON-NLS-2$
                        int response = JOptionPane.showConfirmDialog(UE.WINDOW,
                                msg, UE.APP_NAME, JOptionPane.YES_NO_OPTION);
                        if (response == JOptionPane.NO_OPTION) {
                            continue;
                        }
                    }
                    msg = Language.getString("SoundGUI.29"); //$NON-NLS-1$
                    msg = msg.replace("%1", gug[i] + ".wav"); //$NON-NLS-1$ //$NON-NLS-2$
                    dialog.setMessage(msg);
                    if (endNow) {
                        return;
                    }
                    SND.extract(gug[i], dest);
                }
            } catch (Exception e) {
                UE.displayError(e);
            }
            dialog.setValue(Language.getString("SoundGUI.30")); //$NON-NLS-1$
        }
    }
}
