/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: Tga2AniGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui.special;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import ue.Language;
import ue.UE;
import ue.gui.AniLabel;
import ue.gui.MainPanel;
import ue.util.AniOrCur;
import ue.util.SettingsManager;
import ue.util.Tga2Ani;

/**This class is an interface used for creating botf animations.*/
@SuppressWarnings("serial")  //$NON-NLS-1$
public class Tga2AniGUI extends MainPanel implements ActionListener
{
    //items
    private AniOrCur AOC;
    private Tga2Ani T2A;
    //gui items
    private JButton[] BTN = new JButton[7];
    private AniLabel ANI = new AniLabel();
    private JList LIST = new JList();
    private JLabel[] LABELS = new JLabel[15];
    private JSpinner SPEED;
    //strings
    private static String strADD = Language.getString("Tga2AniGUI.0"); //$NON-NLS-1$
    private static String strREMOVE = Language.getString("Tga2AniGUI.1"); //$NON-NLS-1$
    private static String strCLEAR = Language.getString("Tga2AniGUI.2"); //$NON-NLS-1$
    private static String strUP = Language.getString("Tga2AniGUI.3"); //$NON-NLS-1$
    private static String strDOWN = Language.getString("Tga2AniGUI.4"); //$NON-NLS-1$
    private static String strGENERATE = Language.getString("Tga2AniGUI.5"); //$NON-NLS-1$
    private static String strSAVE_AS = Language.getString("Tga2AniGUI.6"); //$NON-NLS-1$
    
	/*Constructor.*/
	public Tga2AniGUI()
        {
		/*CREATE*/
		T2A = new Tga2Ani();
		BTN[0] = new JButton(strADD);
		BTN[1] = new JButton(strREMOVE);
		BTN[2] = new JButton(strCLEAR);
		BTN[3] = new JButton(strUP);
		BTN[4] = new JButton(strDOWN);
		BTN[5] = new JButton(strGENERATE);
		BTN[6] = new JButton(strSAVE_AS);
		LABELS[0] = new JLabel(Language.getString("Tga2AniGUI.7")); //$NON-NLS-1$
		LABELS[1] = new JLabel(Language.getString("Tga2AniGUI.8")); //$NON-NLS-1$
		LABELS[2] = new JLabel(Language.getString("Tga2AniGUI.9")); //$NON-NLS-1$
		LABELS[3] = new JLabel(Language.getString("Tga2AniGUI.10")); //$NON-NLS-1$
		LABELS[4] = new JLabel(Language.getString("Tga2AniGUI.7")); //$NON-NLS-1$
		LABELS[5] = new JLabel(Language.getString("Tga2AniGUI.11")); //$NON-NLS-1$
		LABELS[6] = new JLabel(Language.getString("Tga2AniGUI.12")); //$NON-NLS-1$
		LABELS[7] = new JLabel(Language.getString("Tga2AniGUI.13")); //$NON-NLS-1$
		LABELS[8] = new JLabel(Language.getString("Tga2AniGUI.14")); //$NON-NLS-1$
		for (int i = 9; i <= 14; i++){
			LABELS[i] = new JLabel("0"); //$NON-NLS-1$
		}
		SPEED = new JSpinner();
		/*SETUP*/
		Font def = UE.SETTINGS.getDefaultFont();
		for (int i = 0; i <= 14; i++){
			LABELS[i].setFont(def);
			if (i>8) {
				LABELS[i].setHorizontalAlignment(SwingConstants.RIGHT);
			}
		}
		for (int i = 0; i <= 6; i++) {
			BTN[i].setFont(def);
		}
		LIST.setFont(def);
		ANI.setFont(def);
		SPEED.setFont(def);
		LIST.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		ANI.setHorizontalAlignment(SwingConstants.CENTER);
		SPEED.setEnabled(false);
		BTN[1].setEnabled(false);
		BTN[2].setEnabled(false);
		BTN[3].setEnabled(false);
		BTN[4].setEnabled(false);
		BTN[5].setEnabled(false);
		BTN[6].setEnabled(false);
		/*ACTION*/
		SPEED.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e){
				if (AOC != null){
					short shr;
					int a = ((Integer)SPEED.getValue()).intValue();
					if (a > Short.MAX_VALUE) {
						shr = Short.MAX_VALUE;
					} else
					if (a < 1) {
						shr = 1;
					} else {
						shr = (short) a;
					}
					AOC.setDelay(shr);
					ANI.setAnimation(AOC, false);
				}
			}
		});
		for (int i = 0; i <= 6; i++) {
			BTN[i].addActionListener(this);
		}
		/*LAYOUT*/
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.insets=new Insets(5, 5, 5, 5);
		c.fill=GridBagConstraints.BOTH;
		/*ADD*/
		c.gridx=0;
		c.gridy=0;
		c.gridwidth=1;
		c.gridheight=1;
		add(LABELS[0], c); //files
		c.gridx=2;
		c.gridwidth=1;

		c.gridy=0;
		for (int i = 1; i < 9; i++){
			add(LABELS[i], c); //info
			c.gridy++;
		}

		c.gridx=3;
		c.gridy=1;
		for (int i = 9; i < 15; i++){
			if (c.gridy == 4) {
				c.gridy++;
			}
			add(LABELS[i], c); //info
			c.gridy++;
		}
		
		//jspinner
		c.gridy=4;
		add(SPEED, c);
		//list
		c.gridheight=7;
		c.gridx=0;
		c.gridy=1;
		JScrollPane scrolly = new JScrollPane(LIST);
		scrolly.setPreferredSize(new Dimension(160, 160));
		add(scrolly, c);
		//animation
		c.gridheight=1;
		c.gridwidth=4;
		c.gridx=0;
		c.gridy=8;
		add(ANI, c);
		//buttons
		c.gridheight=1;
		c.gridwidth=1;
		c.gridx=1;
		c.gridy=1;
		for (int i = 0; i <= 6; i++){
			add(BTN[i], c);
			c.gridy+=1;
		}
	}
	
	@Override
	public void finalWarning() throws Exception {
		if (AOC != null){
			short shr;
			int a = ((Integer)SPEED.getValue()).intValue();
			if (a > Short.MAX_VALUE) {
				shr = Short.MAX_VALUE;
			} else
			if (a < 1) {
				shr = 1;
			} else {
				shr = (short) a;
			}
			AOC.setDelay(shr);
		}
	}
	
	public void actionPerformed(ActionEvent ae){
		if ((ae.getActionCommand()).equals(strADD)){
			JFileChooser jfc = new JFileChooser(new File(UE.SETTINGS.getProperty(SettingsManager.WORK_PATH)));
			javax.swing.filechooser.FileFilter filter = new javax.swing.filechooser.FileFilter(){
				@Override
				public boolean accept(File f){
					if (f.isDirectory()) {
						return true;
					}
					String name = f.getName();
					name = name.toLowerCase();
					if (name.endsWith(".tga")) { //$NON-NLS-1$
						return true; //$NON-NLS-1$
					} else {
						return false;
					}
				}
				@Override
				public String getDescription(){
					return Language.getString("Tga2AniGUI.15"); //$NON-NLS-1$
				}
			};
			jfc.setFileFilter(filter);
			jfc.setMultiSelectionEnabled(true);
			jfc.setDialogTitle(Language.getString("Tga2AniGUI.16")); //$NON-NLS-1$
			int returnVal = jfc.showDialog(this, strADD);
			    if(returnVal == JFileChooser.APPROVE_OPTION) {
				    ANI.setAnimation(null, false);
				    //open and get options
				    File[] fil = jfc.getSelectedFiles();

                    UE.SETTINGS.setProperty(SettingsManager.WORK_PATH, fil[0].getParentFile().getPath());

				    for (int i = 0; i < fil.length; i++){
					    FileInputStream fis;
					    try{
						    fis = new FileInputStream(fil[i]);
					    }catch(Exception iae){
						    UE.displayError(iae);
						    continue;
					    }
					    byte[] b;
					    try{
						    b = new byte[fis.available()];
						    int len;
						    int index = 0;
						    while (fis.available()>0){
							    len = fis.read(b, index, fis.available());
							    index += len;
						    }
					    }catch(Exception iae){
						    UE.displayError(iae);
						    continue;
					    }
					    try{
						    T2A.addFrame(fil[i].getName(), b);
					    }catch(Exception iae){
						    UE.displayError(iae);
						    continue;
					    }
				    }
				    String[] a = T2A.getFrameList();
				    if (a == null){
					    BTN[1].setEnabled(false);
					    BTN[2].setEnabled(false);
					    BTN[3].setEnabled(false);
					    BTN[4].setEnabled(false);
					    BTN[5].setEnabled(false);
					    LIST.setModel(new DefaultListModel());
				    }else{
					    BTN[1].setEnabled(true);
					    BTN[2].setEnabled(true);
					    BTN[3].setEnabled(true);
					    BTN[4].setEnabled(true);
					    BTN[5].setEnabled(true);					    
					    LIST.setListData(a);
				    }
				    BTN[6].setEnabled(false);
				    SPEED.setEnabled(false);
			    }
		}
		if ((ae.getActionCommand()).equals(strGENERATE)){
			try{
                            String[] options = new String[]{"Cursor", "Animation"};

                            String response = JOptionPane.showInputDialog(this,
                                    "Select type to generate:",
                                    UE.APP_NAME,
                                    JOptionPane.PLAIN_MESSAGE,
                                    null,
                                    options, options[0]).toString();

                            if (response == null) return;

                            AOC = T2A.getAniOrCur(response.equals(options[0]));
			}catch (Exception ef){
				ANI.setAnimation(null, false);
				UE.displayError(ef);
				return;
			}
			Dimension dim = AOC.getFrameDim();
			LABELS[9].setText(Double.toString(dim.getWidth()));
			LABELS[10].setText(Double.toString(dim.getHeight()));
			LABELS[11].setText(Short.toString(AOC.getNumFrames()));
			SPEED.setValue(new Integer(Short.toString(AOC.getDelay())));
			dim = AOC.getTgaDim();
			LABELS[12].setText(Double.toString(dim.getWidth()));
			LABELS[13].setText(Double.toString(dim.getHeight()));
			LABELS[14].setText(Integer.toString(AOC.getTgaSize()));
			//if cursor or not
			SPEED.setEnabled(true);
			BTN[6].setEnabled(true);
			ANI.setAnimation(AOC, false);
		}
		if ((ae.getActionCommand()).equals(strREMOVE)){
			if (LIST.getSelectedIndex()>=0){
				ANI.setAnimation(null, false);
				T2A.remove(LIST.getSelectedIndex());
				String[] a = T2A.getFrameList();
				if (a == null){
					BTN[1].setEnabled(false);
					BTN[2].setEnabled(false);
					BTN[3].setEnabled(false);
					BTN[4].setEnabled(false);
					BTN[5].setEnabled(false);
					LIST.setModel(new DefaultListModel());
				}else{
					BTN[1].setEnabled(true);
					BTN[2].setEnabled(true);
					BTN[3].setEnabled(true);
					BTN[4].setEnabled(true);
					BTN[5].setEnabled(true);					    
					LIST.setListData(a);
				}
				BTN[6].setEnabled(false);
				SPEED.setEnabled(false);
			}
		}
		if ((ae.getActionCommand()).equals(strCLEAR)){
			ANI.setAnimation(null, false);
			T2A.clear();
			BTN[1].setEnabled(false);
			BTN[2].setEnabled(false);
			BTN[3].setEnabled(false);
			BTN[4].setEnabled(false);
			BTN[5].setEnabled(false);
			BTN[6].setEnabled(false);
			LIST.setModel(new DefaultListModel());
			SPEED.setEnabled(false);
		}
		if ((ae.getActionCommand()).equals(strUP)){
			if (LIST.getSelectedIndex()>=0){
				ANI.setAnimation(null, false);
				T2A.moveUp((String)LIST.getSelectedValue());
				String[] a = T2A.getFrameList();
				if (a == null){
					BTN[1].setEnabled(false);
					BTN[2].setEnabled(false);
					BTN[3].setEnabled(false);
					BTN[4].setEnabled(false);
					BTN[5].setEnabled(false);
					LIST.setModel(new DefaultListModel());
				}else{
					BTN[1].setEnabled(true);
					BTN[2].setEnabled(true);
					BTN[3].setEnabled(true);
					BTN[4].setEnabled(true);
					BTN[5].setEnabled(true);					    
					LIST.setListData(a);
				}
				BTN[6].setEnabled(false);
				SPEED.setEnabled(false);
			}
		}
		if ((ae.getActionCommand()).equals(strDOWN)){
			if (LIST.getSelectedIndex()>=0){
				ANI.setAnimation(null, false);
				T2A.moveDown((String)LIST.getSelectedValue());
				String[] a = T2A.getFrameList();
				if (a == null){
					BTN[1].setEnabled(false);
					BTN[2].setEnabled(false);
					BTN[3].setEnabled(false);
					BTN[4].setEnabled(false);
					BTN[5].setEnabled(false);
					LIST.setModel(new DefaultListModel());
				}else{
					BTN[1].setEnabled(true);
					BTN[2].setEnabled(true);
					BTN[3].setEnabled(true);
					BTN[4].setEnabled(true);
					BTN[5].setEnabled(true);					    
					LIST.setListData(a);
				}
				BTN[6].setEnabled(false);
				SPEED.setEnabled(false);
			}
		}
		if ((ae.getActionCommand()).equals(strSAVE_AS)){
			if (AOC != null){
				JFileChooser jfc = new JFileChooser(new File(UE.SETTINGS.getProperty(SettingsManager.WORK_PATH)));
				int returnVal = jfc.showSaveDialog(this);
				if(returnVal == JFileChooser.APPROVE_OPTION) {
					File filo = jfc.getSelectedFile();

                                        UE.SETTINGS.setProperty(SettingsManager.WORK_PATH, filo.getParentFile().getPath());

                                        if (filo.exists()){
						String msg = Language.getString("Tga2AniGUI.17"); //$NON-NLS-1$
						msg = msg.replace("%1", filo.getName()); //$NON-NLS-1$
						int respon = JOptionPane.showConfirmDialog(UE.WINDOW, 
								msg, UE.APP_NAME, JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
						if (respon==JOptionPane.YES_OPTION){
							try{
								FileOutputStream fos = new FileOutputStream(jfc.getSelectedFile());
								AOC.save(fos);
								fos.close();
							}catch (Exception ef){
								UE.displayError(ef);
							}
						}
					}else{
						try{
							FileOutputStream fos = new FileOutputStream(jfc.getSelectedFile());
                                                        AOC.save(fos);
							fos.close();
						}catch (Exception ef){
							UE.displayError(ef);
						}
					}
				}
			}
		}
	}
}
