/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2006  DCER
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: AiminorGUI.java
	
	Written by: DCER <seqdcer@yahoo.com>
	
	Last modified: 9.5.2006
*/

package ue.gui.stbof;

import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.SwingConstants;

import ue.Language;
import ue.UE;
import ue.edit.FileManager;
import ue.edit.exe.Trek;
import ue.edit.exe.trek.RaceList;
import ue.edit.res.stbof.dic.Lexicon;
import ue.edit.res.stbof.rst.Race;
import ue.edit.res.stbof.wtf.Aiminor;
import ue.gui.MainPanel;
import ue.util.ID;
import ue.util.SettingsManager;

@SuppressWarnings("serial")  //$NON-NLS-1$
public class AiminorGUI extends MainPanel{
	//files
        RaceList RL = null;
	Race RACES;
	Aiminor AIMINOR;
	//components
	JComboBox MINORS;
	MyTextBox[] SETTINGS;
	JLabel[] lbl_Set;
	JButton btn_Edit;
	JButton btn_Add;
	JButton btn_Remove;
	
	/**constructor*/
	public AiminorGUI(Aiminor ai, Race ra, Lexicon dic)
        {
		try{
                    if (UE.FILES.getFile(FileManager.P_TREK) != null)
                    {
                        RL = (RaceList)UE.FILES.getFile(FileManager.P_TREK).getInternalFile(Trek.fileRACE_LIST, true);
                    }
			RACES = ra;
			AIMINOR = ai;
			MINORS = new JComboBox();
			setLayout(new GridBagLayout());
			//settings
			SETTINGS = new MyTextBox[7];
			for (int i=0; i<7; i++){
				SETTINGS[i] = new MyTextBox(i);
			}
			SETTINGS[0].addItem(new ID(Language.getString("AiminorGUI.0"), 0)); //$NON-NLS-1$
			SETTINGS[0].addItem(new ID(Language.getString("AiminorGUI.1"), 1)); //$NON-NLS-1$
			SETTINGS[0].addItem(new ID(Language.getString("AiminorGUI.2"), 2)); //$NON-NLS-1$
			SETTINGS[0].addItem(new ID(Language.getString("AiminorGUI.3"), 3)); //$NON-NLS-1$
			SETTINGS[0].addItem(new ID(Language.getString("AiminorGUI.4"), 4)); //$NON-NLS-1$
			SETTINGS[1].addItem(new ID(Language.getString("AiminorGUI.5"), 5)); //$NON-NLS-1$
			SETTINGS[1].addItem(new ID(Language.getString("AiminorGUI.6"), 6)); //$NON-NLS-1$
			for (int j=2; j<7; j++){
				SETTINGS[j].addItem(new ID(dic.getEntry(288), 0)); //"Enraged"
				SETTINGS[j].addItem(new ID(dic.getEntry(442), 1)); //"Hostile"
				SETTINGS[j].addItem(new ID(dic.getEntry(476), 2)); //"Icy"));
				SETTINGS[j].addItem(new ID(dic.getEntry(1383), 3)); //"Uncooperative"));
				SETTINGS[j].addItem(new ID(dic.getEntry(809), 4)); //"Neutral"));
				SETTINGS[j].addItem(new ID(dic.getEntry(986), 5)); //"Receptive"));
				SETTINGS[j].addItem(new ID(dic.getEntry(190), 6)); //"Cordial"));
				SETTINGS[j].addItem(new ID(dic.getEntry(289), 7)); //"Enthusiastic"));
				SETTINGS[j].addItem(new ID(dic.getEntry(1449), 8)); //"Worshipful"));
			}
			//labels
			lbl_Set = new JLabel[7];
			lbl_Set[0] = new JLabel(Language.getString("AiminorGUI.7"), SwingConstants.RIGHT); //$NON-NLS-1$
			lbl_Set[1] = new JLabel(Language.getString("AiminorGUI.8"), SwingConstants.RIGHT); //$NON-NLS-1$
			for (int j=2; j<7; j++){
				String msg = Language.getString("AiminorGUI.9"); //$NON-NLS-1$
				msg = msg.replace("%1", RACES.getName(j-2)); //$NON-NLS-1$
				lbl_Set[j] = new JLabel(msg, SwingConstants.RIGHT);
			}
			//buttons
			btn_Edit = new JButton(Language.getString("AiminorGUI.10")); //$NON-NLS-1$
			btn_Edit.addActionListener(new ActionListener()
                        {
			    public void actionPerformed(ActionEvent ae)
                            {
			        try
                                {
			            String nName = JOptionPane.showInputDialog(Language.getString("AiminorGUI.11"), ((ID)MINORS.getSelectedItem()).toString()); //$NON-NLS-1$
			            
			            if (nName != null && nName.length() > 0 && !AIMINOR.containsRace(nName))
			            {
			                int numi = MINORS.getSelectedIndex();
			                
			                if (RL != null && RL.getRaceIndex(nName) < 0)
			                {
			                    int k;
			                    if ( (k = RL.getRaceIndex(AIMINOR.getName(numi))) >= 0)
			                    {
			                        RL.setRaceString(k, nName);
			                    }
			                }
			                
			                AIMINOR.setName(numi, nName);
			                fillRaces();
			                MINORS.setSelectedIndex(numi);
			            }
                                }
                                catch (Exception e)
                                {
                                    UE.displayError(e);
                                }
                            }
			});
			btn_Add = new JButton(Language.getString("AiminorGUI.12")); //$NON-NLS-1$
			btn_Add.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent ae){
					try{
						String[] pos = AIMINOR.getNames();
						ID[] possibleValues = new ID[pos.length];
						for (int i=0; i<pos.length; i++){ possibleValues[i] = new ID(pos[i], i);}
						
						ID selectedValue = (ID)JOptionPane.showInputDialog(UE.WINDOW, 
						Language.getString("AiminorGUI.13"), UE.APP_NAME, //$NON-NLS-1$
						JOptionPane.INFORMATION_MESSAGE, null,
						possibleValues, possibleValues[0]);
						
						if (selectedValue!=null){
							AIMINOR.add(selectedValue.hashCode());
							fillRaces();
						}
					}catch (Exception e){
						UE.displayError(e);
					}
				}
			});
			btn_Remove = new JButton(Language.getString("AiminorGUI.14")); //$NON-NLS-1$
			btn_Remove.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent ae){
					try{
						if (MINORS.getSelectedIndex()!=-1){
							AIMINOR.remove(MINORS.getSelectedIndex());
							fillRaces();
						}
					}catch (Exception e){
						UE.displayError(e);
					}
				}
			});
			//minors
			MINORS.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent ae){
					try{
						if (MINORS.getSelectedIndex()!=-1){
							for (int g=0; g<7; g++){
								SETTINGS[g].setSelectedIndex((int)AIMINOR.getValue(MINORS.getSelectedIndex(), g));
							}
						}
					}catch (Exception e){
						UE.displayError(e);
					}
				}
			});
			fillRaces();
			//set font
			Font def = UE.SETTINGS.getDefaultFont();
			MINORS.setFont(def);
			btn_Edit.setFont(def);
			btn_Add.setFont(def);
			btn_Remove.setFont(def);
			for (int h=0; h<7; h++){
				lbl_Set[h].setFont(def);
				SETTINGS[h].setFont(def);
			}
			//add all
			GridBagConstraints c = new GridBagConstraints();
			//minors
			c.gridx=1;
			c.gridy=1;
			c.gridwidth=1;
                        c.gridheight=1;
                        c.fill=GridBagConstraints.BOTH;
                        c.anchor=GridBagConstraints.EAST;
			c.insets=new Insets(5, 5, 5, 5);
			add(MINORS, c);
			//buttons
			c.fill=GridBagConstraints.NONE;
			c.gridy=1;
			c.gridx=0;
//			add(btn_Add, c);
//			c.gridy=2;
//			c.gridx=0;
			add(btn_Edit, c);
			//settings			
			c.fill=GridBagConstraints.BOTH;
			for (int h=0; h<7; h++){
				c.gridx=0;
				c.gridy++;
				add(lbl_Set[h], c);
				c.gridx=1;
				add(SETTINGS[h], c);
			}
			
			setVisible(true);
		}catch (Exception e){
			UE.displayError(e);
		}
	}
        
	private void fillRaces(){
		try{
			MINORS.removeAllItems();
			for (int i=0; i<AIMINOR.getNumber(); i++){
				MINORS.addItem(new ID(AIMINOR.getName(i), i));
			}
			validate();
		}catch (Exception e){
			UE.displayError(e);
		}
	}
	
	@Override
	public void finalWarning() throws Exception {}

	private class MyTextBox extends JComboBox{
		int INDEX=0;
		
		public MyTextBox(int index){
			INDEX = index;
			addActionListener(new ActionListener(){
                @Override
				public void actionPerformed(ActionEvent ae){
					try{
						if (MINORS.getSelectedIndex()!=-1){
							AIMINOR.setValue(MINORS.getSelectedIndex(), INDEX, getSelectedIndex());
						}
					}catch (Exception e){
						UE.displayError(e);
					}
				}
			});
		}
	}
}
