/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2010  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: BuildingsGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
*/

package ue.gui.stbof;

import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Enumeration;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;
import javax.swing.border.LineBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import ue.Language;
import ue.UE;
import ue.edit.exe.Trek;
import ue.edit.exe.trek.Jump;
import ue.edit.exe.trek.SpecialShips;
import ue.edit.res.Stbof;
import ue.edit.res.stbof.StringFile;
import ue.edit.res.stbof.bin.AIBldReq;
import ue.edit.res.stbof.bin.BldSet;
import ue.edit.res.stbof.bst.Edifbnft;
import ue.edit.res.stbof.bst.Edifice;
import ue.edit.res.stbof.dic.Lexicon;
import ue.edit.res.stbof.rst.Race;
import ue.edit.res.stbof.tec.RaceTech;
import ue.edit.res.stbof.tec.TecField;
import ue.edit.res.stbof.tec.TechTree;
import ue.exception.InvalidArgumentsException;
import ue.gui.MainPanel;
import ue.util.ID;
import ue.util.SettingsManager;
import ue.util.TargaImage;

/**This class is used to display the about window.*/
@SuppressWarnings("serial")  
public class BuildingsGUI extends MainPanel
{
    //edited
    private Edifice BUILDING = null;
    private Edifbnft BONUS = null;
    private StringFile DESCRIPTION = null;
    private TecField TECH = null;
    private TechTree TECH_TREE = null;
    private Race RACE = null;
    private Stbof STBOF = null;
    private Lexicon LEX = null;
    private Trek TREK = null;
    private RaceTech RACETECH = null;
    private AIBldReq AIBLDREQ = null;
    private BldSet[] BLDSET = new BldSet[5];
    //gui
    private JList lstBUILD;
    private JPanel pnlMAIN;
    private JPanel pnlCARD;
    private JPanel pnlSWITCH;
    private CardLayout layCARD;
    private JPanel pnlONE;
    private JPanel pnlTWO;
    private JPanel pnlTHR;
    private JPanel pnlFOR;
    private JPanel pnlFIV;
    private JPanel pnlSIX;
    private JTextField txtNAME;
    private JTextField txtNAMES;
    private JTextArea txtDESC;
    private JComboBox cmbTGA;
    private JLabel lblPIC;
    private JComboBox cmbTECH;
    private JComboBox cmbTECH_LVL;
    private JTextField txtIND_COST;
    private JTextField txtEN_COST;
    private JComboBox cmbSYS_REQ;
    private JComboBox cmbCATEGORY;
    private JComboBox cmbPOLITIC;
    private JComboBox cmbFREQ;
    private JTextField txtMORALE_BONI;
    private JComboBox cmbBONI_TYPE;
    private JTextField[] txtBONI = new JTextField[6];
    private JList lstCAN_BUILD;
    private JList lstNEEDED_RACE;
    private JComboBox cmbMASK;
    private JComboBox cmbPOP_COST;
    private JComboBox cmbUPGRADE;
    private JTextField[] txtBONI_2 = new JTextField[6];
    private JLabel lblINDEX;
    private JCheckBox chkBUILDS_SPECIAL;
    private JComboBox cmbGROUP;
    private JButton btnMoveUp;
    private JButton btnMoveDown;
    private JButton btnEDIT_BONI;
    private JButton btnADD;
    private JButton btnREMOVE;
    private JCheckBox[] chkTREK_ID_BASIC = new JCheckBox[7];
    private JCheckBox[] chkTREK_ID_MARTIAL_LAW = new JCheckBox[5];
    private JCheckBox[] chkTREK_ID_SHIPYARD = new JCheckBox[5];
    private JCheckBox[] chkTREK_ID_MINOR_SP;

    //other
    private int SELECTED = -1;
    private boolean PAUSE = false;


    private ListSelectionListener LISTEN = new ListSelectionListener()
    {
        @Override
        public void valueChanged(ListSelectionEvent e)
        {
            if (PAUSE)
            {
                return;
            }
            try
            {
                finalWarning();
            }
            catch (Exception ex)
            {
                // really bad stuff happening - bail
                UE.displayError(ex);
                return;
            }

            //go
            Object my = lstBUILD.getSelectedValue();
            if (my == null)
            {
                return;
            }

            SELECTED = my.hashCode();

            if (SELECTED < 0)
            {
                return;
            }
            try
            {
                txtNAME.setText(BUILDING.getName(SELECTED));
                txtNAMES.setText(BUILDING.getPluralName(SELECTED));
                txtDESC.setText(DESCRIPTION.getDesc((short)SELECTED));
                cmbTGA.setSelectedItem(BUILDING.getPicture(SELECTED) + "_b.tga"); //$NON-NLS-1$
                cmbTECH.setSelectedIndex(BUILDING.getTechReq(SELECTED));
                cmbTECH_LVL.setSelectedIndex(BUILDING.getTechLvl(SELECTED));
                txtIND_COST.setText(Integer.toString(BUILDING.getIndCost(SELECTED)));
                txtEN_COST.setText(Short.toString(BUILDING.getEnCost(SELECTED)));
                cmbSYS_REQ.setSelectedIndex(BUILDING.getSysReq(SELECTED));
                cmbCATEGORY.setSelectedIndex(BUILDING.getCategory(SELECTED));
                int t = BUILDING.getPoliticReq(SELECTED);
                if (t < 7)
                {
                    cmbPOLITIC.setSelectedIndex(t);
                }
                else
                {
                    cmbPOLITIC.setSelectedIndex(t-2);
                }
                cmbFREQ.setSelectedIndex(BUILDING.getFreq(SELECTED));
                txtMORALE_BONI.setText(Short.toString(BUILDING.getMoraleBoni(SELECTED)));
                cmbBONI_TYPE.setSelectedIndex(BUILDING.getBoniType(SELECTED));

                cmbUPGRADE.setSelectedIndex(BUILDING.getUpgradedFrom(SELECTED));

                String msg = Language.getString("BuildingsGUI.0"); //$NON-NLS-1$
                msg = msg.replace("%1", Integer.toString(SELECTED)); //$NON-NLS-1$
                lblINDEX.setText("    " + msg + "    "); //$NON-NLS-1$ //$NON-NLS-2$

                //pop cost
                if (BUILDING.getPopCost(SELECTED) == 0)
                {
                    cmbPOP_COST.setSelectedIndex(0);
                }
                else
                {
                    cmbPOP_COST.setSelectedIndex(1);
                }

                for (int i=0; i<6; i++)
                {
                    txtBONI[i].setText(Short.toString(BUILDING.getBoni(SELECTED, i)));
                    txtBONI_2[i].setText(Short.toString(BUILDING.getBoni2(SELECTED, i)));
                }
		
                try
                {
                    TargaImage tar = STBOF.getTargaImage(BUILDING.getPicture(SELECTED) + ".tga", false); //$NON-NLS-1$
                    
                    Dimension dim = tar.getImageSize();
                    if ((dim.height>120) || (dim.width>100))
                    {
                        lblPIC.setIcon(new ImageIcon(tar.getThumbnail(120, false, false)));
                    }
                    else
                    {
                        lblPIC.setIcon(new ImageIcon(tar.getImage(false)));
                    }
                    lblPIC.setText(null);
                }
                catch (Exception fnf)
                {
                    UE.displayError(fnf);
                    lblPIC.setIcon(null);
                    lblPIC.setText(Language.getString("BuildingsGUI.49")); //$NON-NLS-1$
                }

                //who can build
                byte masked = BUILDING.getExEmpire(SELECTED);
                SELECTED = -1;
                lstCAN_BUILD.clearSelection();
                ArrayList<Integer> tmpa = new ArrayList<Integer>();
                for (int n = 0; n<5; n++)
                {
                    byte z = (byte)Math.pow(2, n);
                    if ((masked&z)!=z)
                    {
                        tmpa.add(n);
                    }
                }
                if (!tmpa.isEmpty())
                {
                    int[] quest = new int[tmpa.size()];
                    for (int n=0; n<tmpa.size(); n++){
                        quest[n] = tmpa.get(n);
                    }
                    lstCAN_BUILD.setSelectedIndices(quest);
                }
                //needed race
                lstNEEDED_RACE.clearSelection();
                long msk = BUILDING.getReqRace(my.hashCode());
                tmpa = new ArrayList<Integer>();
                for (int n = 0; n<RACE.getNumberOfEntries(); n++){
                    long z = (long)Math.pow(2, n);
                    if ((msk&z)==z){
                        tmpa.add(n);
                    }
                }
                if (!tmpa.isEmpty()){
                    int[] quest = new int[tmpa.size()];
                    for (int n=0; n<tmpa.size(); n++){
                        quest[n] = tmpa.get(n);
                    }
                    lstNEEDED_RACE.setSelectedIndices(quest);
                }
                
                btnMoveUp.setEnabled(true);
                btnMoveDown.setEnabled(true);
                btnREMOVE.setEnabled(true);
                // builds special ships?
                if ((TREK != null) && (my.hashCode() <= 256)){
                    try{
                        boolean enabled = false;
                        Jump bjmp = (Jump)TREK.getInternalFile(Trek.fileSPECIAL_STRUCT_JUMP, true);
                        SpecialShips bub = (SpecialShips)TREK.getInternalFile(Trek.fileSPECIAL_SHIPS, true);
                        switch (bjmp.get())
                        {
                            case Jump.JMP:
                            {
                                // all
                                bjmp.set(Jump.JLE);
                                bub.setSPBuilding(255);
                            }
                            case Jump.JLE:
                            {
                                // lower or equal than
                                enabled = (my.hashCode() != 0) && ((my.hashCode() == bub.getSPBuilding()) || ((my.hashCode() == bub.getSPBuilding() + 1) && (my.hashCode() < 256))); 
                                chkBUILDS_SPECIAL.setEnabled(enabled);
                                chkBUILDS_SPECIAL.setSelected(my.hashCode() <= bub.getSPBuilding());
                                
                                btnMoveUp.setEnabled(true);
                                btnMoveDown.setEnabled(my.hashCode() != bub.getSPBuilding());

                                break;
                            }
                            case Jump.JZ:
                            {
                                // one
                                enabled = (my.hashCode() != bub.getSPBuilding()) && (my.hashCode() < 256);
                                chkBUILDS_SPECIAL.setSelected(my.hashCode() == bub.getSPBuilding());
                                chkBUILDS_SPECIAL.setEnabled(enabled);

                                btnMoveUp.setEnabled((my.hashCode() < 256) || (bub.getSPBuilding() != 255));

                                btnMoveDown.setEnabled((my.hashCode() != bub.getSPBuilding())
                                        || (my.hashCode() != 255));

                                break;
                            }
                            default:{
                                // none of the above
                                // fix
                                bjmp.set(Jump.JLE);
                                enabled = (my.hashCode() != 0) && ((my.hashCode() == bub.getSPBuilding()) || ((my.hashCode() == bub.getSPBuilding() + 1) && (my.hashCode() < 256))); 
                                chkBUILDS_SPECIAL.setEnabled(enabled);
                                chkBUILDS_SPECIAL.setSelected(my.hashCode() <= bub.getSPBuilding());
                                
                                btnMoveUp.setEnabled(true);
                                btnMoveDown.setEnabled(my.hashCode() != bub.getSPBuilding());

                                break;
                            }
                        }
                    }
                    catch (Exception k)
                    {
                        UE.displayError(k);
                    }
                }else{
                    chkBUILDS_SPECIAL.setEnabled(false);
                    chkBUILDS_SPECIAL.setSelected(false);
                }
                
                // group
                cmbGROUP.setSelectedIndex(BUILDING.getGroup(my.hashCode()));

                // trek.exe ids
                for (int i = 0; i < chkTREK_ID_BASIC.length; i++)
                {
                    if (TREK == null)
                    {
                        chkTREK_ID_BASIC[i].setEnabled(false);
                        chkTREK_ID_BASIC[i].setSelected(false);
                    }
                    else
                    {
                        chkTREK_ID_BASIC[i].setSelected(BUILDING.getTrekExeID(i) == my.hashCode());
                    }
                }

                // trek.exe id me groups
                for (int i = 0; i < chkTREK_ID_MARTIAL_LAW.length; i++)
                {
                    if (TREK == null)
                    {
                        chkTREK_ID_MARTIAL_LAW[i].setEnabled(false);
                        chkTREK_ID_MARTIAL_LAW[i].setSelected(false);
                        chkTREK_ID_SHIPYARD[i].setEnabled(false);
                        chkTREK_ID_SHIPYARD[i].setSelected(false);
                    }
                    else
                    {
                        chkTREK_ID_MARTIAL_LAW[i].setSelected(
                                BUILDING.getTrekExeID(Edifice.MARTIAL_LAW_ID_SET, i) == my.hashCode());
                        chkTREK_ID_SHIPYARD[i].setSelected(
                                BUILDING.getTrekExeID(Edifice.SHIPYARD_ID_SET, i) == my.hashCode());
                    }
                }

                for (int i = 0; i < chkTREK_ID_MINOR_SP.length; i++)
                {
                    if (TREK == null)
                    {
                        chkTREK_ID_MINOR_SP[i].setEnabled(false);
                        chkTREK_ID_MINOR_SP[i].setSelected(false);
                    }
                    else
                    {
                        chkTREK_ID_MINOR_SP[i].setSelected(
                                BUILDING.getTrekExeID(Edifice.MINOR_SP_BLD_ID_SET, i + 5) == my.hashCode());
                    }
                }

                BuildingsGUI.this.fillList();

                SELECTED = my.hashCode();
            }
            catch (Exception er)
            {
                UE.displayError(er);
            }
        }
    };
    
    /**
     * Costructor
     */
    public BuildingsGUI(Stbof st, Trek trek)
    {
        /*PRE*/
        if (st == null)
        {
            return;
        }
        else
        {
            STBOF = st;
        }
        TREK = trek;
        
        try
        {
            BUILDING = (Edifice)STBOF.getInternalFile(Stbof.fileEDIFICE_BST, true);
            BONUS = (Edifbnft)STBOF.getInternalFile(Stbof.fileEDIFBNFT_BST, true);
            DESCRIPTION = (StringFile)STBOF.getInternalFile(Stbof.fileEDIFDESC_BST, true);
            TECH = (TecField)STBOF.getInternalFile(Stbof.fileTECFIELD_TEC, true);
            LEX = (Lexicon)STBOF.getInternalFile(Stbof.fileLEXICON_DIC, true);
            RACE = (Race)STBOF.getInternalFile(Stbof.fileRACE_RST, true);
            RACETECH = (RaceTech)STBOF.getInternalFile(Stbof.fileRACETECH_TEC, true);
            AIBLDREQ = (AIBldReq)STBOF.getInternalFile(Stbof.fileAIBLDREQ_BIN, true);
            BLDSET[0] = (BldSet)STBOF.getInternalFile(Stbof.fileBLDSET1_BIN, true);
            BLDSET[1] = (BldSet)STBOF.getInternalFile(Stbof.fileBLDSET2_BIN, true);
            BLDSET[2] = (BldSet)STBOF.getInternalFile(Stbof.fileBLDSET3_BIN, true);
            BLDSET[3] = (BldSet)STBOF.getInternalFile(Stbof.fileBLDSET4_BIN, true);
            BLDSET[4] = (BldSet)STBOF.getInternalFile(Stbof.fileBLDSET5_BIN, true);
            TECH_TREE = (TechTree)STBOF.getInternalFile(Stbof.fileTECHTREE_TEC, true);
        }
        catch (FileNotFoundException fnf)
        {
            UE.displayError(fnf);
            return;
        }
        
        DESCRIPTION.reset();
        
        for (int i = 0; i < BUILDING.getNumberOfEntries(); i++)
        {
            try
            {
                DESCRIPTION.setIndex(BUILDING.getDescAddress(i), i);
            }
            catch (Exception e)
            {
                UE.displayError(e);
            }
        }
	
        /*CREATE*/
        lstBUILD = new JList();
        pnlMAIN = new JPanel();
        pnlSWITCH = new JPanel(new GridBagLayout());
        layCARD = new CardLayout();
        layCARD.setHgap(0);
        layCARD.setVgap(0);
        pnlCARD = new JPanel(layCARD);
        pnlONE = new JPanel();
        pnlTWO = new JPanel();
        pnlTHR = new JPanel();
        pnlFOR = new JPanel();
        pnlFIV = new JPanel();
        pnlSIX = new JPanel();
        txtNAME = new JTextField(40);
        txtNAMES = new JTextField(40);
        txtDESC = new JTextArea();
        btnADD = new JButton(Language.getString("BuildingsGUI.1")); //$NON-NLS-1$
        btnREMOVE = new JButton(Language.getString("BuildingsGUI.2")); //$NON-NLS-1$
        cmbTGA = new JComboBox();
        lblPIC = new JLabel();
        cmbTECH = new JComboBox();
        cmbTECH_LVL = new JComboBox();
        txtIND_COST = new JTextField(7);
        txtEN_COST = new JTextField(7);
        cmbSYS_REQ = new JComboBox();
        cmbCATEGORY = new JComboBox();
        cmbPOLITIC = new JComboBox();
        cmbFREQ = new JComboBox();
        txtMORALE_BONI = new JTextField(8);
        cmbBONI_TYPE = new JComboBox();
        
        for (int i = 0; i < 6; i++)
        {
            txtBONI[i] = new JTextField(8);
            txtBONI_2[i] = new JTextField(8);
        }
	
        btnEDIT_BONI = new JButton(Language.getString("BuildingsGUI.3")); //$NON-NLS-1$
        lstCAN_BUILD = new JList();
        lstNEEDED_RACE = new JList();
        cmbMASK = new JComboBox();
        cmbPOP_COST = new JComboBox();
        cmbUPGRADE = new JComboBox();
        cmbGROUP = new JComboBox();
        lblINDEX = new JLabel();
	
        for (int i = 0; i < chkTREK_ID_BASIC.length; i++)
        {
            chkTREK_ID_BASIC[i] = new JCheckBox(BUILDING.getTrekExeIDDescription(i));
        }
        for (int i = 0; i < chkTREK_ID_MARTIAL_LAW.length; i++)
        {
            try
            {
                chkTREK_ID_MARTIAL_LAW[i] = new JCheckBox(RACE.getName(i));
                chkTREK_ID_SHIPYARD[i] = new JCheckBox(RACE.getName(i));
            }
            catch (InvalidArgumentsException ex)
            {
                chkTREK_ID_MARTIAL_LAW[i] = new JCheckBox("Race " + i);
                chkTREK_ID_SHIPYARD[i] = new JCheckBox("Race " + i);
            }
        }
        
        chkTREK_ID_MINOR_SP = new JCheckBox[RACE.getNumberOfEntries() - 5];
        for (int i = 0; i < chkTREK_ID_MINOR_SP.length; i++)
        {
            try
            {
                chkTREK_ID_MINOR_SP[i] = new JCheckBox(RACE.getName(i + 5));
            }
            catch (InvalidArgumentsException ex)
            {
                chkTREK_ID_MINOR_SP[i] = new JCheckBox("Race " + (i - 5));
            }
        }

        chkBUILDS_SPECIAL = new JCheckBox(Language.getString("BuildingsGUI.38")); //$NON-NLS-1$
        btnMoveUp = new JButton(Language.getString("BuildingsGUI.47")); //$NON-NLS-1$
        btnMoveDown = new JButton(Language.getString("BuildingsGUI.48")); //$NON-NLS-1$

        /*SETUP*/
        //font
        Font def = UE.SETTINGS.getDefaultFont();
        //main panel
        pnlMAIN.setBorder(new LineBorder(Color.BLACK));
        //panel card
        pnlCARD.setBorder(new LineBorder(Color.BLACK));
        // move buttons
        btnMoveUp.setFont(def);
        btnMoveUp.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                btnMoveUpClick(true);
            }
        });
        
        btnMoveDown.setFont(def);
        btnMoveDown.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if (SELECTED >= 0)
                {
                    try
                    {
                        BuildingsGUI.this.finalWarning();
                        int index = BUILDING.moveDown(SELECTED);
                        if (SELECTED != index)
                        {
                            String desc1 = DESCRIPTION.getDesc((short)SELECTED);
                            DESCRIPTION.setDesc((short)SELECTED, DESCRIPTION.getDesc((short)index));
                            DESCRIPTION.setDesc((short)index, desc1);
                            
                            boolean av;
                            
                            for (int i = 0; i < RACETECH.getNumberOfEntries(); i++)
                            {
                                av = RACETECH.isAvailable(i, SELECTED);
                                RACETECH.setAvailable(i, SELECTED, RACETECH.isAvailable(i, index));
                                RACETECH.setAvailable(i, index, av);
                            }
                            
                            AIBLDREQ.switchIDs(SELECTED, index);
                            
                            // switch starting buildings
                            int num;
                            
                            for (int i = 0; i < 5; i++)
                            {
                                for (short empire = 0; empire < 5; empire++)
                                {
                                    num = BLDSET[i].getNum(empire, (short)SELECTED);
                                    BLDSET[i].setNum(empire, (short)SELECTED, BLDSET[i].getNum(empire, (short)index));
                                    BLDSET[i].setNum(empire, (short)index, num);
                                }
                            }
                            
                            // fix sp
                            if (TREK != null)
                            {
                                try
                                {
                                    Jump bjmp = (Jump)TREK.getInternalFile(Trek.fileSPECIAL_STRUCT_JUMP, true);
                                    SpecialShips bub = (SpecialShips)TREK.getInternalFile(Trek.fileSPECIAL_SHIPS, true);
                                    switch (bjmp.get())
                                    {
                                        case Jump.JZ:
                                        {
                                            if (SELECTED == bub.getSPBuilding())
                                            {
                                                bub.setSPBuilding(index);
                                            }
                                            else if (index == bub.getSPBuilding())
                                            {
                                                bub.setSPBuilding(SELECTED);
                                            }
                                            break;
                                        }
                                        default:
                                        {
                                        }
                                    }
                                }catch (Exception k)
                                {
                                    UE.displayError(k);
                                }
                            }

                            SELECTED = -1;
                            BuildingsGUI.this.fillList();
                            lstBUILD.setSelectedValue(new ID("", index), true); //$NON-NLS-1$
                        }
                    }
                    catch (Exception e)
                    {
                        UE.displayError(e);
                    }
                }
            }
        });
        
        //technology combos
        cmbTECH.setFont(def);
        cmbTECH_LVL.setFont(def);
        cmbTECH.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if ((SELECTED < 0) || (cmbTECH.getSelectedIndex() < 0) || PAUSE)
                {
                    return;
                }
                try
                {
                    // fill
                    int max = 9;
                    
                    if (UE.SETTINGS.getBooleanProperty(SettingsManager.EXPERIMENTAL))
                    {
                        max = TECH_TREE.getMaxTechLevel((byte)cmbTECH.getSelectedIndex());
                    }

                    int sel = cmbTECH_LVL.getSelectedIndex();

                    PAUSE = true;
                    cmbTECH_LVL.removeAllItems();

                    for (int i = 0; i <= max; i++)
                    {
                        cmbTECH_LVL.addItem(Integer.toString(i));
                    }
                    cmbTECH_LVL.setSelectedIndex(sel);
                    PAUSE = false;

                    BUILDING.setTechReq(SELECTED, (byte)cmbTECH.getSelectedIndex());
                }
                catch (Exception t)
                {
                    UE.displayError(t);
                }
            }
        });
        cmbTECH_LVL.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if ((SELECTED < 0) || (cmbTECH_LVL.getSelectedIndex() < 0) || PAUSE)
                {
                    return;
                }
                try
                {
                    BUILDING.setTechLvl(SELECTED, (byte)cmbTECH_LVL.getSelectedIndex());
                }
                catch (Exception t)
                {
                    UE.displayError(t);
                }
            }
        });
        //population cost combo
        cmbPOP_COST.setFont(def);
        cmbPOP_COST.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if ((SELECTED < 0) || (cmbPOP_COST.getSelectedIndex() < 0) || PAUSE)
                {
                    return;
                }
                try
                {
                    if (cmbPOP_COST.getSelectedIndex() == 0)
                    {
                        BUILDING.setPopCost(SELECTED, (short)0);
                        if (cmbGROUP.getSelectedIndex() < 5)
                        {
                            cmbGROUP.setSelectedIndex(6);
                        }
                    }
                    else
                    {
                        BUILDING.setPopCost(SELECTED, (short)10);
                    }
                }catch (Exception t)
                {
                    UE.displayError(t);
                }
            }
        });
        //upgrade req combo
        cmbUPGRADE.setFont(def);
        cmbUPGRADE.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if ((SELECTED < 0) || (cmbUPGRADE.getSelectedIndex() < 0))
                {
                    return;
                }
                try
                {
                    BUILDING.setUpgradedFrom(SELECTED, (short)cmbUPGRADE.getSelectedIndex());
                }
                catch (Exception t)
                {
                    UE.displayError(t);
                }
            }
        });
        //group combo
        cmbGROUP.setFont(def);
        cmbGROUP.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if ((SELECTED < 0) || (cmbGROUP.getSelectedIndex() < 0))
                {
                    return;
                }
                try
                {
                    BUILDING.setGroup(SELECTED, cmbGROUP.getSelectedIndex());
                    if (cmbGROUP.getSelectedIndex() < 5)
                    {
                        cmbPOP_COST.setSelectedIndex(1);
                    }
                }catch (Exception t)
                {
                    UE.displayError(t);
                }
            }
        });
        //system req combo
        cmbSYS_REQ.setFont(def);
        cmbSYS_REQ.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if ((SELECTED<0) || (cmbSYS_REQ.getSelectedIndex()<0))
                {
                    return;
                }
                try
                {
                    BUILDING.setSysReq(SELECTED, (byte)cmbSYS_REQ.getSelectedIndex());
                }
                catch (Exception t)
                {
                    UE.displayError(t);
                }
            }
        });
        //category combo
        cmbCATEGORY.setFont(def);
        cmbCATEGORY.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if ((SELECTED < 0) || (cmbCATEGORY.getSelectedIndex() < 0))
                {
                    return;
                }
                try
                {
                    BUILDING.setCategory(SELECTED, (byte)cmbCATEGORY.getSelectedIndex());
                }
                catch (Exception t)
                {
                    UE.displayError(t);
                }
            }
        });
        //politic combo
        cmbPOLITIC.setFont(def);
        cmbPOLITIC.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if ((SELECTED < 0) || (cmbPOLITIC.getSelectedIndex() < 0))
                {
                    return;
                }
                try
                {
                    BUILDING.setPoliticReq(SELECTED, (byte)((ID)cmbPOLITIC.getSelectedItem()).hashCode());
                }
                catch (Exception t)
                {
                    UE.displayError(t);
                }
            }
        });
        //frequency combo
        cmbFREQ.setFont(def);
        cmbFREQ.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if ((SELECTED < 0) || (cmbFREQ.getSelectedIndex() < 0))
                {
                    return;
                }
                try
                {
                    BUILDING.setFreq(SELECTED, (byte)cmbFREQ.getSelectedIndex());
                }
                catch (Exception t)
                {
                    UE.displayError(t);
                }
            }
        });
        //boni type combo
        cmbBONI_TYPE.setFont(def);
        cmbBONI_TYPE.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if ((SELECTED < 0) || (cmbBONI_TYPE.getSelectedIndex() < 0))
                {
                    return;
                }
                try
                {
                    BUILDING.setBoniType(SELECTED, (byte)cmbBONI_TYPE.getSelectedIndex());
                }
                catch (Exception t)
                {
                    UE.displayError(t);
                }
            }
        });
        //mask combo
        cmbMASK.setFont(def);
        cmbMASK.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if ((SELECTED < 0) || (cmbMASK.getSelectedIndex() < 0))
                {
                    return;
                }
                BuildingsGUI.this.fillList();
                lstBUILD.setSelectedIndex(0);
                lstBUILD.ensureIndexIsVisible(0);
                LISTEN.valueChanged(null);
            }
        });
        //list of buildings
        lstBUILD.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        lstBUILD.setFont(def);
        lstBUILD.addListSelectionListener(LISTEN);
        //add button
        btnADD.setFont(def);
        btnADD.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                int sel_id = lstBUILD.getSelectedIndex();

                try
                {
                    ID[] possibleValues = new ID[BUILDING.getNumberOfEntries()];
                    
                    for (int x = 0; x < BUILDING.getNumberOfEntries(); x++)
                    {
                        possibleValues[x]= new ID(BUILDING.getName(x), x);
                    }

                    ID selectedValue = (ID)JOptionPane.showInputDialog(UE.WINDOW,
                                        Language.getString("BuildingsGUI.4"), UE.APP_NAME, //$NON-NLS-1$
                                        JOptionPane.INFORMATION_MESSAGE, null,
                                        possibleValues, possibleValues[0]);
						
                    if (selectedValue != null)
                    {
                        int ix = selectedValue.hashCode();
                        int newBg = BUILDING.add(ix);
                        int newAdd = DESCRIPTION.add();
			
                        DESCRIPTION.setIndex(newAdd, BUILDING.getNumberOfEntries() - 1);
                        BUILDING.setDescAddress(newBg, newAdd);
                        BUILDING.setName(newBg, Language.getString("BuildingsGUI.5")); //$NON-NLS-1$
                        BUILDING.setPluralName(newBg, Language.getString("BuildingsGUI.6")); //$NON-NLS-1$

                        if (!BUILDING.isMainBuilding(newBg)
                                && BUILDING.getBoniType(newBg) != Edifice.BONUS_BUILDS_SHIPS
                                && BUILDING.getBoniType(newBg) != Edifice.BONUS_MORALE_MARTIAL_LAW)
                        {
                            AIBLDREQ.add(newBg);
                            AIBLDREQ.setEnergyReq(newBg, AIBLDREQ.getEnergyReq(ix));
                            AIBLDREQ.setMaxPopReq(newBg, AIBLDREQ.getMaxPopReq(ix));
                            AIBLDREQ.setPopReq(newBg, AIBLDREQ.getPopReq(ix));
                        }
                        fillList();
                        lstBUILD.setSelectedIndex(newBg);
                        lstBUILD.ensureIndexIsVisible(newBg);

                        if (sel_id >= 0)
                        {
                            sel_id++;

                            while (sel_id < newBg)
                            {
                                btnMoveUpClick(sel_id + 1 == newBg);
                                newBg--;
                            }
                        }
                    }
        		}
                catch (InvalidArgumentsException tu)
                {
                    UE.displayError(tu);
                }
            }
        });

        //remove button
    	btnREMOVE.setFont(def);
        btnREMOVE.setEnabled(false);
        btnREMOVE.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if (SELECTED < 0 && BUILDING.getNumberOfEntries() > 1)
                {
                    return;
                }

                try
                {
                    DESCRIPTION.remove((short)SELECTED);

                    //reset descriptions
                    for (int i = 0; i < BUILDING.getNumberOfEntries(); i++)
                    {
                        if (i != SELECTED)
                        {
                            BUILDING.setDescAddress(i, DESCRIPTION.getAddress((short)i));
                        }
                    }

                    short upgrade;
                    for (int i = 0; i < BUILDING.getNumberOfEntries(); i++)
                    {
                        upgrade = BUILDING.getUpgradedFrom(i);

                        if (upgrade == SELECTED)
                        {
                            BUILDING.setUpgradedFrom(i, (short)(BUILDING.getNumberOfEntries() - 1));
                        }
                        else if (upgrade > SELECTED)
                        {
                            upgrade--;
                            BUILDING.setUpgradedFrom(i, upgrade);
                        }
                    }

                    BUILDING.remove(SELECTED);

                    // reset indexes
                    DESCRIPTION.reset();

                    for (int i = 0; i < BUILDING.getNumberOfEntries(); i++)
                    {
                        DESCRIPTION.setIndex(BUILDING.getDescAddress(i), i);
                    }

                    // fix AIBLDREQ
                    AIBLDREQ.remove(SELECTED);

                    for (int i = SELECTED + 1; i < BUILDING.getNumberOfEntries() + 1; i++)
                    {
                        if (AIBLDREQ.contains(i))
                        {
                            AIBLDREQ.changeID(i, i - 1);
                        }
                    }

                    // fix bld sets
                    int bnum = 0;

                    for (int k = 0; k < 5; k++)
                    {
                        for (int r = 0; r < 5; r++)
                        {
                            if (BLDSET[k].getNum((short)r, (short)SELECTED) > 0)
                            {
                                BLDSET[k].setNum((short)r, (short)SELECTED, 0);
                            }

                            for (int i = SELECTED + 1; i < BUILDING.getNumberOfEntries() + 1; i++)
                            {
                                bnum = BLDSET[k].getNum((short)r, (short)i);
                                if (bnum > 0)
                                {
                                    BLDSET[k].setNum((short)r, (short)i, 0);
                                    BLDSET[k].setNum((short)r, (short)(i - 1), bnum);
                                }
                            }
                        }
                    }

                    int hm = SELECTED;

                    while (hm != 0 && BUILDING.getNumberOfEntries() <= hm)
                    {
                        hm--;
                    }

                    PAUSE = true;
                    SELECTED = - 1;
                    lstBUILD.clearSelection();
                    PAUSE = false;

                    fillList();

                    lstBUILD.setSelectedIndex(hm);
                }
                catch (Exception tu)
                {
                    UE.displayError(tu);
                }
            }
        });
        btnEDIT_BONI.setFont(def);
        btnEDIT_BONI.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if (cmbBONI_TYPE.getSelectedIndex() >= 0)
                {
                    try
                    {
                        String n = JOptionPane.showInputDialog(Language.getString("BuildingsGUI.8"),
                            BONUS.getBoniDesc(cmbBONI_TYPE.getSelectedIndex())); //$NON-NLS-1$

                        if (n != null)
                        {
                            int selectedValue = SELECTED;
                            BONUS.setBoniDesc(cmbBONI_TYPE.getSelectedIndex(), n);
                            BuildingsGUI.this.fillList();
                            SELECTED = selectedValue;
                        }
                        }
                    catch (InvalidArgumentsException g)
                    {
                        UE.displayError(g);
                    }
                }
            }
        });
        //description
        txtDESC.setLineWrap(true);
        txtDESC.setWrapStyleWord(true);
        txtDESC.setFont(def);
        //tga combo box
        cmbTGA.setFont(def);
        Enumeration<String[]> enu = STBOF.getFiles(new java.io.FilenameFilter()
        {
            @Override
            public boolean accept(File dir, String name)
            {
                String str = name.toLowerCase();
                return str.endsWith("_b.tga"); //$NON-NLS-1$
            }
        });
        while (enu.hasMoreElements())
        {
            cmbTGA.addItem(enu.nextElement()[0]);
        }
        cmbTGA.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                if (SELECTED < 0)
                {
                    return;
                }
                try
                {
                    String str = (String)cmbTGA.getSelectedItem();
                    BUILDING.setPicture(SELECTED, str.substring(0, str.length()-6));
                    try
                    {
                        TargaImage tar = STBOF.getTargaImage(BUILDING.getPicture(SELECTED) + ".tga", false); //$NON-NLS-1$
                        
                        Dimension dim = tar.getImageSize();
                        if (dim.height > 100)
                        {
                            lblPIC.setIcon(new ImageIcon(tar.getThumbnail(100, false, false)));
                            return;
                        }
                        if (dim.width > 120)
                        {
                            lblPIC.setIcon(new ImageIcon(tar.getThumbnail(120, false, false)));
                            return;
                        }
                        lblPIC.setIcon(new ImageIcon(tar.getImage(false)));
                    }
                    catch (Exception fnf)
                    {
                        fnf.printStackTrace();
                        lblPIC.setIcon(null);
                    }
                }
                catch (InvalidArgumentsException xy)
                {
                    UE.displayError(xy);
                }
            }
        });
        //can build list
        lstCAN_BUILD.setFont(def);
        lstCAN_BUILD.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        lstCAN_BUILD.addListSelectionListener(new ListSelectionListener()
        {
            @Override
            public void valueChanged(ListSelectionEvent e)
            {
                if (SELECTED < 0)
                {
                    return;
                }
                try
                {
                    int[] tin = lstCAN_BUILD.getSelectedIndices();
                    byte mask = 0; //mask is reverted
                    for (int i=0; (i<tin.length) && (i<5); i++)
                    {
                        mask+=(byte)Math.pow(2, tin[i]);
                    }
                    byte fin = (byte)(mask^((byte)0x1F));
                    BUILDING.setExEmpire(SELECTED, fin);
                }
                catch (Exception h)
                {
                    UE.displayError(h);
                }
            }
        });
        //needed resident races list
        lstNEEDED_RACE.setFont(def);
        lstNEEDED_RACE.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        lstNEEDED_RACE.addListSelectionListener(new ListSelectionListener()
        {
            @Override
            public void valueChanged(ListSelectionEvent e)
            {
                if (SELECTED < 0)
                {
                    return;
                }
                try
                {
                    int[] tin = lstNEEDED_RACE.getSelectedIndices();
                    long mask = 0; //normal mask
                    for (int element : tin)
                    {
                        mask+=Math.pow(2, element);
                    }
                    BUILDING.setReqRace(SELECTED, mask);
                }
                catch (Exception h)
                {
                    UE.displayError(h);
                }
            }
        });
        //xyz
        txtNAME.setFont(def);
        txtNAMES.setFont(def);
        txtIND_COST.setFont(def);
        txtEN_COST.setFont(def);
        txtMORALE_BONI.setFont(def);
        for (int i=0; i<6; i++)
        {
            txtBONI[i].setFont(def);
            txtBONI_2[i].setFont(def);
        }
        lblINDEX.setFont(def);
        chkBUILDS_SPECIAL.setFont(def);
        chkBUILDS_SPECIAL.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent arg0)
            {
                // builds special ships?
                if ((TREK != null) && (SELECTED <= 255))
                {
                    try
                    {
                        Jump bjmp = (Jump)TREK.getInternalFile(Trek.fileSPECIAL_STRUCT_JUMP, true);
                        SpecialShips bub = (SpecialShips)TREK.getInternalFile(Trek.fileSPECIAL_SHIPS, true);
                        
                        switch (bjmp.get())
                        {
                            case Jump.JLE:
                            { // from 0 - sel
                                if (SELECTED == bub.getSPBuilding())
                                {
                                    if (SELECTED == 1)
                                    {
                                        // only one left
                                        bjmp.set(Jump.JZ);
                                    }
                                    bub.setSPBuilding(SELECTED - 1);
                                }
                                else
                                {
                                    bub.setSPBuilding(SELECTED);
                                }
                                break;
                            }
                            case Jump.JZ:
                            { // single
                                if ((bub.getSPBuilding() == 0) && (SELECTED == 1))
                                {
                                    bjmp.set(Jump.JLE);
                                }
                                bub.setSPBuilding(SELECTED);
                                chkBUILDS_SPECIAL.setEnabled(false);
                                break;
                            }
                        }
                    }
                    catch (Exception k)
                    {
                        UE.displayError(k);
                    }
                }
                else
                {
                    return;
                }
            }
        });

        for (int i = 0; i < chkTREK_ID_BASIC.length; i++)
        {
            chkTREK_ID_BASIC[i].addActionListener(new ActionListener()
            {
                @Override
                public void actionPerformed(ActionEvent e)
                {
                    for (int i = 0; i < chkTREK_ID_BASIC.length; i++)
                    {
                        if (chkTREK_ID_BASIC[i] == e.getSource())
                        {
                            try
                            {
                                int id = (chkTREK_ID_BASIC[i].isSelected()) ? SELECTED : -1;
                                BUILDING.setTrekExeID(i, id);
                                return;
                            } catch (Exception ex)
                            {
                                UE.displayError(ex);
                            }
                        }
                    }
                }
            });
        }

        for (int i = 0; i < chkTREK_ID_MARTIAL_LAW.length; i++)
        {
            chkTREK_ID_MARTIAL_LAW[i].addActionListener(new ActionListener()
            {
                @Override
                public void actionPerformed(ActionEvent e)
                {
                    for (int i = 0; i < chkTREK_ID_MARTIAL_LAW.length; i++)
                    {
                        if (chkTREK_ID_MARTIAL_LAW[i] == e.getSource())
                        {
                            try
                            {
                                int id = (chkTREK_ID_MARTIAL_LAW[i].isSelected()) ? SELECTED : -1;
                                BUILDING.setTrekExeID(Edifice.MARTIAL_LAW_ID_SET, i, id);
                                return;
                            } catch (Exception ex)
                            {
                                UE.displayError(ex);
                            }
                        }
                    }
                }
            });
            chkTREK_ID_SHIPYARD[i].addActionListener(new ActionListener()
            {
                @Override
                public void actionPerformed(ActionEvent e)
                {
                    for (int i = 0; i < chkTREK_ID_SHIPYARD.length; i++)
                    {
                        if (chkTREK_ID_SHIPYARD[i] == e.getSource())
                        {
                            try
                            {
                                int id = (chkTREK_ID_SHIPYARD[i].isSelected()) ? SELECTED : -1;
                                BUILDING.setTrekExeID(Edifice.SHIPYARD_ID_SET, i, id);
                                return;
                            } catch (Exception ex)
                            {
                                UE.displayError(ex);
                            }
                        }
                    }
                }
            });
        }

        for (int i = 0; i < chkTREK_ID_MINOR_SP.length; i++)
        {
            chkTREK_ID_MINOR_SP[i].addActionListener(new ActionListener()
            {
                @Override
                public void actionPerformed(ActionEvent e)
                {
                    for (int i = 0; i < chkTREK_ID_MINOR_SP.length; i++)
                    {
                        if (chkTREK_ID_MINOR_SP[i] == e.getSource())
                        {
                            try
                            {
                                int id = (chkTREK_ID_MINOR_SP[i].isSelected()) ? SELECTED : -1;
                                BUILDING.setTrekExeID(Edifice.MINOR_SP_BLD_ID_SET, i + 5, id);
                                return;
                            } catch (Exception ex)
                            {
                                UE.displayError(ex);
                            }
                        }
                    }
                }
            });
        }

        // picture
        lblPIC.setPreferredSize(new Dimension(120,100)); 
        /*PLACE*/
        this.setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
        c.insets=new Insets(5, 5, 5, 5);
        c.fill=GridBagConstraints.BOTH;
        c.anchor=GridBagConstraints.CENTER;
        c.gridx = 0;
        c.gridy = 0;
        c.gridwidth = 1;
        c.gridheight = 1;
        //LEFT PANEL
            JPanel pnlLEFT = new JPanel(new GridBagLayout());
            pnlLEFT.add(cmbMASK, c);
            c.gridy = 1;
            JScrollPane JSP = new JScrollPane(lstBUILD);
            pnlLEFT.add(JSP, c);
            c.gridy = 2;
            pnlLEFT.add(btnMoveUp, c);
            c.gridy = 3;
            pnlLEFT.add(btnMoveDown, c);
            c.gridy = 4;
            pnlLEFT.add(btnADD, c);
            c.gridy = 5;
            pnlLEFT.add(btnREMOVE, c);
        //MAIN PANEL
            pnlMAIN.setLayout(new GridBagLayout());
            c.gridx = 0;
            c.gridy = 0;
            c.gridwidth = 1;
            c.gridheight = 1;
            JLabel lbl = new JLabel(Language.getString("BuildingsGUI.9")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlMAIN.add(lbl, c);
            c.gridy = 1;
            lbl = new JLabel(Language.getString("BuildingsGUI.10")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlMAIN.add(lbl, c);
            c.gridy = 0;
            c.gridx = 1;
            pnlMAIN.add(txtNAME, c);
            c.gridy = 1;
            pnlMAIN.add(txtNAMES, c);
            c.gridy = 2;
            c.gridx = 0;
            pnlMAIN.add(lblPIC, c);
            c.gridy = 3;
            pnlMAIN.add(cmbTGA, c);
            c.gridx = 1;
            c.gridy = 2;
            c.gridheight = 2;
            JScrollPane scrDESC = new JScrollPane(txtDESC);
            scrDESC.setPreferredSize(new Dimension(200, 80));
            pnlMAIN.add(scrDESC, c);
        //ONE PANEL
            pnlONE.setLayout(new GridBagLayout());
            c.gridx = 0;
            c.gridy = 0;
            c.gridwidth = 1;
            c.gridheight = 1;
            lbl = new JLabel(Language.getString("BuildingsGUI.11")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlONE.add(lbl, c);
            c.gridy = 1;
            lbl = new JLabel(Language.getString("BuildingsGUI.12")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlONE.add(lbl, c);
            c.gridy = 2;
            lbl = new JLabel(Language.getString("BuildingsGUI.13")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlONE.add(lbl, c);
            c.gridy = 3;
            lbl = new JLabel(Language.getString("BuildingsGUI.14")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlONE.add(lbl, c);
            c.gridy = 4;
            lbl = new JLabel(Language.getString("BuildingsGUI.15")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlONE.add(lbl, c);
            c.gridy = 0;
            c.gridx = 1;
            pnlONE.add(cmbCATEGORY, c);
            c.gridy = 2;
            pnlONE.add(cmbTECH_LVL, c);
            c.gridy = 1;
            pnlONE.add(cmbTECH, c);
            c.gridy = 3;
            pnlONE.add(txtIND_COST, c);
            c.gridy = 4;
            pnlONE.add(txtEN_COST, c);
            c.gridx = 2;
            c.gridy = 0;
            lbl = new JLabel(Language.getString("BuildingsGUI.16")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlONE.add(lbl, c);
            c.gridy = 1;
            lbl = new JLabel(Language.getString("BuildingsGUI.17")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlONE.add(lbl, c);
            c.gridy = 2;
            lbl = new JLabel(Language.getString("BuildingsGUI.18")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlONE.add(lbl, c);
            c.gridy = 3;
            lbl = new JLabel(Language.getString("BuildingsGUI.39")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlONE.add(lbl, c);
            c.gridy = 4;
            lbl = new JLabel(Language.getString("BuildingsGUI.20")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlONE.add(lbl, c);
            c.gridx = 3;
            c.gridy = 0;
            pnlONE.add(cmbSYS_REQ, c);
            c.gridy = 1;
            pnlONE.add(cmbPOLITIC, c);
            c.gridy = 2;
            pnlONE.add(cmbFREQ, c);
            c.gridy = 3;
            pnlONE.add(cmbGROUP, c);
            c.gridy = 4;
            pnlONE.add(cmbPOP_COST, c);
        //TWO PANEL
            pnlTWO.setLayout(new GridBagLayout());
            c.fill=GridBagConstraints.NONE;
            c.gridwidth = 1;
            c.gridheight = 1;
            c.gridx = 0;
            c.gridy = 0;
            lbl = new JLabel(Language.getString("BuildingsGUI.21")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlTWO.add(lbl, c);
            c.gridx = 1;
            c.gridwidth = 2;
            pnlTWO.add(cmbBONI_TYPE, c);
            c.gridwidth = 1;
            for (int i = 0; i < 6; i++)
            {
                try
                {
                    if (i < 3)
                    {
                        c.gridx = 0;
                        c.gridy = i+1;
                    }
                    else
                    {
                        c.gridx = 2;
                        c.gridy = i-2;
                    }
                    if (i < 5)
                    {
                        lbl = new JLabel(RACE.getName(i) + ":"); //$NON-NLS-1$
                    }
                    else
                    {
                        lbl = new JLabel(Language.getString("BuildingsGUI.22")); //$NON-NLS-1$ 
                    }
                    lbl.setFont(def);
                    pnlTWO.add(lbl, c);
                    c.gridx++;
                    pnlTWO.add(txtBONI[i], c);
                }
                catch (Exception zu)
                {
                    UE.displayError(zu);
                }
            }
            c.gridx = 3;
            c.gridy = 0;
            c.fill=GridBagConstraints.BOTH;
            pnlTWO.add(btnEDIT_BONI, c);
            c.gridx = 0;
            c.gridy = 4;
            c.gridwidth = 1;
            lbl = new JLabel(Language.getString("BuildingsGUI.19")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlTWO.add(lbl, c);
            c.gridx = 1;
            c.anchor=GridBagConstraints.WEST;
            pnlTWO.add(txtMORALE_BONI, c);
        //THREE PANEL
            pnlTHR.setLayout(new GridBagLayout());
            c.fill=GridBagConstraints.BOTH;
            c.anchor=GridBagConstraints.CENTER;
            c.gridwidth = 1;
            c.gridheight = 1;
            c.gridx = 0;
            c.gridy = 0;
            lbl = new JLabel(Language.getString("BuildingsGUI.24")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlTHR.add(lbl, c);
            c.gridy = 1;
            JScrollPane scrCAN_BUILD = new JScrollPane(lstCAN_BUILD);
            scrCAN_BUILD.setPreferredSize(new Dimension(200, 100));
            scrCAN_BUILD.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
            pnlTHR.add(scrCAN_BUILD, c);
            c.gridx = 1;
            c.gridy = 0;
            lbl = new JLabel(Language.getString("BuildingsGUI.25")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlTHR.add(lbl, c);
            c.gridy = 1;
            JScrollPane scrNEEDED = new JScrollPane(lstNEEDED_RACE);
            scrNEEDED.setPreferredSize(new Dimension(200, 100));
            scrNEEDED.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
            pnlTHR.add(scrNEEDED, c);
            c.gridx = 0;
            c.gridy = 2;
            lbl = new JLabel(Language.getString("BuildingsGUI.23")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlTHR.add(lbl, c);
            c.gridx = 1;
            pnlTHR.add(cmbUPGRADE, c);
         //FOUR PANEL
            pnlFOR.setLayout(new GridBagLayout());
            c.fill=GridBagConstraints.NONE;
            c.gridwidth = 4;
            c.gridheight = 1;
            c.gridx = 0;
            c.gridy = 0;
            lbl = new JLabel(Language.getString("BuildingsGUI.26")); //$NON-NLS-1$
            lbl.setFont(def);
            pnlFOR.add(lbl, c);
            c.gridwidth = 1;
            for (int i = 0; i < 6; i++)
            {
                try
                {
                    if (i < 3)
                    {
                        c.gridx = 0;
                        c.gridy = i+1;
                    }
                    else
                    {
                        c.gridx = 2;
                        c.gridy = i-2;
                    }
                    if (i < 5)
                    {
                        lbl = new JLabel(RACE.getName(i) + ":"); //$NON-NLS-1$
                    }
                    else
                    {
                        lbl = new JLabel(Language.getString("BuildingsGUI.22")); //$NON-NLS-1$ 
                    }
                    lbl.setFont(def);
                    pnlFOR.add(lbl, c);
                    c.gridx++;
                    pnlFOR.add(txtBONI_2[i], c);
                }
                catch (Exception zu)
                {
                    UE.displayError(zu);
                }
            }
            c.gridy++;
            c.gridx = 0;
            c.gridwidth = 4;
            pnlFOR.add(chkBUILDS_SPECIAL, c);
        // PANEL FIVE
            pnlFIV.setLayout(new GridBagLayout());
            c.fill=GridBagConstraints.BOTH;
            c.anchor=GridBagConstraints.CENTER;
            c.insets=new Insets(0, 0, 0, 0);
            c.gridwidth = 1;
            c.gridheight = 1;
            c.gridx = 0;

            JPanel pnl = new JPanel(new GridBagLayout());

            for (int i = 0; i < chkTREK_ID_BASIC.length; i++)
            {
                c.gridy = i;
                pnl.add(chkTREK_ID_BASIC[i], c);
            }
            c.gridy = 0;
            pnlFIV.add(pnl, c);
            
            c.gridx++;

            pnl = new JPanel(new GridBagLayout());
            pnl.setBorder(BorderFactory.createTitledBorder("Martial Law"));

            for (int i = 0; i < chkTREK_ID_MARTIAL_LAW.length; i++)
            {
                c.gridy = i;
                pnl.add(chkTREK_ID_MARTIAL_LAW[i], c);
            }
            c.gridy = 0;
            pnlFIV.add(pnl, c);
            
            pnl = new JPanel(new GridBagLayout());
            pnl.setBorder(BorderFactory.createTitledBorder("Shipyard"));

            c.gridx++;
            for (int i = 0; i < chkTREK_ID_SHIPYARD.length; i++)
            {
                c.gridy = i;
                pnl.add(chkTREK_ID_SHIPYARD[i], c);
            }
            c.gridy = 0;
            pnlFIV.add(pnl, c);
        // PANEL SIX
            pnlSIX.setLayout(new GridBagLayout());
            c.fill=GridBagConstraints.BOTH;
            c.anchor=GridBagConstraints.CENTER;
            c.insets=new Insets(0, 0, 0, 0);
            c.gridwidth = 1;
            c.gridheight = 1;
            c.gridx = 0;

            pnl = new JPanel(new GridBagLayout());
            pnl.setBorder(BorderFactory.createTitledBorder("Minor race special structure"));

            for (int i = 0; i < chkTREK_ID_MINOR_SP.length; i++)
            {
                c.gridy = i % 6;
                c.gridx = i / 6;
                pnl.add(chkTREK_ID_MINOR_SP[i], c);
            }

            pnlSIX.add(pnl, c);
        //CARD PANEL
            pnlCARD.add(pnlONE, "1"); //$NON-NLS-1$
            pnlCARD.add(pnlTWO, "2"); //$NON-NLS-1$
            pnlCARD.add(pnlTHR, "3"); //$NON-NLS-1$
            pnlCARD.add(pnlFOR, "4"); //$NON-NLS-1$
            pnlCARD.add(pnlFIV, "5"); //$NON-NLS-1$
            pnlCARD.add(pnlSIX, "6"); //$NON-NLS-1$
        //SWITCH PANEL
            c.fill=GridBagConstraints.NONE;
            c.anchor=GridBagConstraints.WEST;
            c.insets=new Insets(5, 5, 5, 5);
            c.gridwidth = 1;
            c.gridheight = 1;
            c.gridx = 0;
            c.gridy = 0;
            JButton btn = new JButton("<<<"); //$NON-NLS-1$
            btn.setFont(def);
            btn.addActionListener(new ActionListener()
            {
            @Override
                public void actionPerformed(ActionEvent ae)
                {
                    layCARD.previous(pnlCARD);
                }
            });
            pnlSWITCH.add(btn, c);
            c.anchor=GridBagConstraints.EAST;
            c.gridx = 2;
            btn = new JButton(">>>"); //$NON-NLS-1$
            btn.setFont(def);
            btn.addActionListener(new ActionListener()
            {
            @Override
                public void actionPerformed(ActionEvent ae)
                {
                    layCARD.next(pnlCARD);
                }
            });
            pnlSWITCH.add(btn, c);
            c.anchor=GridBagConstraints.CENTER;
            c.gridx = 1;
            pnlSWITCH.add(lblINDEX, c);
        c.gridx = 0;
        c.gridy = 0;
        c.fill=GridBagConstraints.BOTH;
        c.anchor=GridBagConstraints.CENTER;
        c.gridwidth = 1;
        c.gridheight = 2;
        c.insets=new Insets(0, 0, 0, 0);
        this.add(pnlLEFT, c);
        c.gridx = 1;
        c.gridheight = 1;
        c.insets=new Insets(5, 5, 5, 5);
        c.fill=GridBagConstraints.BOTH;
        this.add(pnlMAIN, c);
        c.gridy = 1;
        this.add(pnlCARD, c);
        c.gridy = 2;
        c.gridx = 1;
        c.insets=new Insets(0, 0, 0, 0);
        this.add(pnlSWITCH, c);
        // size fix
        int h1 = pnlMAIN.getPreferredSize().height;
        int h2 = pnlCARD.getPreferredSize().height;
        int h3 = cmbMASK.getPreferredSize().height;
        int h4 = btnMoveUp.getPreferredSize().height;
        JSP.setPreferredSize(new Dimension(cmbMASK.getPreferredSize().width, h1+h2 - h3 - 4*h4 - 40));
        /*INIT*/
        //mask
        try
        {
            cmbMASK.addItem(new ID(Language.getString("BuildingsGUI.27"),0)); //$NON-NLS-1$
            for (int n = 0; n < 5; n++)
            {
                cmbMASK.addItem(new ID(RACE.getName(n), n+1));
            }
            cmbMASK.addItem(new ID(Language.getString("BuildingsGUI.28"), 6)); //$NON-NLS-1$
            String msg;
            for (int n = 0; n < 5; n++)
            {
                msg = Language.getString("BuildingsGUI.29"); //$NON-NLS-1$
                msg = msg.replace("%1", RACE.getName(n)); //$NON-NLS-1$
                cmbMASK.addItem(new ID(msg, n+7));
            }
            cmbMASK.addItem(new ID(Language.getString("BuildingsGUI.30"), 12)); //$NON-NLS-1$
        }
        catch (Exception t)
        {
            UE.displayError(t);
        }
        //tech
        String[] str = TECH.getFields();
        int ix=0;
        for (ix = 0; ix < str.length-1; ix++)
        {
            cmbTECH.addItem(new ID(str[ix], ix));
        }
        cmbTECH.addItem(new ID(Language.getString("BuildingsGUI.27"), ix)); //$NON-NLS-1$
        
        int max = 9;

        if (UE.SETTINGS.getBooleanProperty(SettingsManager.EXPERIMENTAL))
        {
            max = TECH_TREE.getMaxTechLevel((byte)0);
        }

        for (int i=0; i <= max; i++)
        {
            cmbTECH_LVL.addItem(new ID(Integer.toString(i), i));
        }
        //system req
        int i=0;
        try
        {
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(38), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(56), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(230), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(410), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(559), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(879), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(1259), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(1415), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(872), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(47), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(48), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(239), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(1447), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(968), i++));
            cmbSYS_REQ.addItem(new ID(LEX.getEntry(1450), i++));
        }
        catch (Exception t)
        {
            UE.displayError(t);
            String msg;
            for (; i < 15; i++)
            {
                msg = Language.getString("BuildingsGUI.31"); //$NON-NLS-1$
                msg = msg.replace("%1", Integer.toString(i)); //$NON-NLS-1$
                cmbSYS_REQ.addItem(new ID(msg, i));
            }
        }
        //category
        cmbCATEGORY.addItem(Language.getString("BuildingsGUI.32")); //$NON-NLS-1$
        cmbCATEGORY.addItem(Language.getString("BuildingsGUI.33")); //$NON-NLS-1$
        cmbCATEGORY.addItem(Language.getString("BuildingsGUI.34")); //$NON-NLS-1$
        cmbCATEGORY.addItem(Language.getString("BuildingsGUI.35")); //$NON-NLS-1$
        cmbCATEGORY.addItem(Language.getString("BuildingsGUI.36")); //$NON-NLS-1$
        //politic
        i = 0;
        try
        {
            cmbPOLITIC.addItem(new ID(LEX.getEntry(437), i++));
            cmbPOLITIC.addItem(new ID(LEX.getEntry(801), i++));
            cmbPOLITIC.addItem(new ID(LEX.getEntry(863), i++));
            cmbPOLITIC.addItem(new ID(LEX.getEntry(1187), i++));
            cmbPOLITIC.addItem(new ID(LEX.getEntry(6), i++));
            cmbPOLITIC.addItem(new ID(LEX.getEntry(527), i++));
            cmbPOLITIC.addItem(new ID(LEX.getEntry(184), i++));
            i++;
            i++;
            cmbPOLITIC.addItem(new ID(LEX.getEntry(872), i++));
            cmbPOLITIC.addItem(new ID(LEX.getEntry(977), i++));
            cmbPOLITIC.addItem(new ID(LEX.getEntry(277), i++));
        }
        catch (Exception t)
        {
            UE.displayError(t);
            String msg;
            for (; i < 12; i++)
            {
                msg = Language.getString("BuildingsGUI.31"); //$NON-NLS-1$
                msg = msg.replace("%1", Integer.toString(i)); //$NON-NLS-1$
                cmbPOLITIC.addItem(new ID(msg, i));
            }
        }
        //frequency
        i=0;
        try
        {
            cmbFREQ.addItem(new ID(LEX.getEntry(872), i++));
            cmbFREQ.addItem(new ID(LEX.getEntry(885), i++));
            cmbFREQ.addItem(new ID(LEX.getEntry(884), i++));
        }
        catch (Exception t)
        {
            UE.displayError(t);
            String msg;
            for (; i < 3; i++)
            {
                msg = Language.getString("BuildingsGUI.31"); //$NON-NLS-1$
                msg = msg.replace("%1", Integer.toString(i)); //$NON-NLS-1$
                cmbFREQ.addItem(new ID(msg, i));
            }
        }
        //races
        ID[] istr = new ID[5];
        ID[] rstr = new ID[RACE.getNumberOfEntries()];
        for (int n = 0; n < RACE.getNumberOfEntries(); n++)
        {
            try
            {
                if (n < 5)
                {
                    istr[n] = new ID(RACE.getName(n), n);
                }
                rstr[n] = new ID(RACE.getName(n), n);
            }
            catch (Exception t)
            {
                UE.displayError(t);
            }
        }
        lstCAN_BUILD.setListData(istr);
        lstNEEDED_RACE.setListData(rstr);
        //pop cost
        cmbPOP_COST.addItem("0"); //$NON-NLS-1$
        cmbPOP_COST.addItem("10"); //$NON-NLS-1$
        //group
        cmbGROUP.addItem(Language.getString("BuildingsGUI.40")); //$NON-NLS-1$
        cmbGROUP.addItem(Language.getString("BuildingsGUI.41")); //$NON-NLS-1$
        cmbGROUP.addItem(Language.getString("BuildingsGUI.42")); //$NON-NLS-1$
        cmbGROUP.addItem(Language.getString("BuildingsGUI.43")); //$NON-NLS-1$
        cmbGROUP.addItem(Language.getString("BuildingsGUI.44")); //$NON-NLS-1$
        cmbGROUP.addItem(Language.getString("BuildingsGUI.45")); //$NON-NLS-1$
        cmbGROUP.addItem(Language.getString("BuildingsGUI.46")); //$NON-NLS-1$
        this.fillList();
        lstBUILD.setSelectedIndex(0);
        lstBUILD.ensureIndexIsVisible(0);
        layCARD.first(pnlCARD);
    }
    
    private void fillList()
    {
        PAUSE = true;
        int tempS = lstBUILD.getSelectedIndex();
        SELECTED = -1;
        //boni type
        try
        {
            int dun = cmbBONI_TYPE.getSelectedIndex();
            cmbBONI_TYPE.removeAllItems();
            for (int i = 0; i < BONUS.getNumberOfEntries(); i++)
            {
                cmbBONI_TYPE.addItem(new ID(i + ": " + BONUS.getBoniDesc(i), i)); //$NON-NLS-1$
            }
            cmbBONI_TYPE.setSelectedIndex(dun);
        }
        catch (Exception z)
        {
            UE.displayError(z);
        }
        //upgrade list
        try
        {
            int dun = cmbUPGRADE.getSelectedIndex();
            cmbUPGRADE.removeAllItems();
            for (int i = 0; i<BUILDING.getNumberOfEntries(); i++)
            {
                cmbUPGRADE.addItem(
                        new ID("%1: %2".replace("%1", Integer.toString(i)).replace("%2", BUILDING.getName(i)), i));
            }
            cmbUPGRADE.addItem(new ID(Language.getString("BuildingsGUI.37"), BUILDING.getNumberOfEntries())); //$NON-NLS-1$

            if (dun < 0 || dun >= cmbUPGRADE.getItemCount())
            {
                dun = cmbUPGRADE.getItemCount() - 1;
            }
            cmbUPGRADE.setSelectedIndex(dun);
        }
        catch (Exception z)
        {
            UE.displayError(z);
        }
        //main [buildings] list
        byte msk = (byte)cmbMASK.getSelectedIndex();
        ID[] ed = BUILDING.getShortIDs(msk, 20);
        lstBUILD.setListData(ed);
        lstBUILD.setSelectedIndex(tempS);
        lstBUILD.ensureIndexIsVisible(tempS);
        PAUSE = false;
    }

    private void btnMoveUpClick(boolean refreshList)
    {
        if (SELECTED >= 0)
        {
            try
            {
                BuildingsGUI.this.finalWarning();
                int index = BUILDING.moveUp(SELECTED);
                if (SELECTED != index)
                {
                    // switch descriptions
                    String desc1 = DESCRIPTION.getDesc((short)SELECTED);
                    DESCRIPTION.setDesc((short)SELECTED, DESCRIPTION.getDesc((short)index));
                    DESCRIPTION.setDesc((short)index, desc1);

                    // switch availability
                    boolean av;

                    for (int i = 0; i < RACETECH.getNumberOfEntries(); i++)
                    {
                        av = RACETECH.isAvailable(i, SELECTED);
                        RACETECH.setAvailable(i, SELECTED, RACETECH.isAvailable(i, index));
                        RACETECH.setAvailable(i, index, av);
                    }

                    // switch ai building requirements
                    AIBLDREQ.switchIDs(SELECTED, index);

                    // switch starting buildings
                    int num;

                    for (int i = 0; i < 5; i++)
                    {
                        for (short empire = 0; empire < 5; empire++)
                        {
                            num = BLDSET[i].getNum(empire, (short)SELECTED);
                            BLDSET[i].setNum(empire, (short)SELECTED, BLDSET[i].getNum(empire, (short)index));
                            BLDSET[i].setNum(empire, (short)index, num);
                        }
                    }

                    // fix sp
                    if (TREK != null)
                    {
                        try
                        {
                            Jump bjmp = (Jump)TREK.getInternalFile(Trek.fileSPECIAL_STRUCT_JUMP, true);
                            SpecialShips bub = (SpecialShips)TREK.getInternalFile(Trek.fileSPECIAL_SHIPS, true);
                            switch (bjmp.get())
                            {
                                case Jump.JZ:
                                {
                                    if (SELECTED == bub.getSPBuilding())
                                    {
                                        bub.setSPBuilding(index);
                                    }
                                    else if (index == bub.getSPBuilding())
                                    {
                                        bub.setSPBuilding(SELECTED);
                                    }
                                    break;
                                }
                                default:
                                {
                                }
                            }
                        }catch (Exception k)
                        {
                            UE.displayError(k);
                        }
                    }

                    if (refreshList)
                    {
                        SELECTED = -1;
                        BuildingsGUI.this.fillList();
                        lstBUILD.setSelectedValue(new ID("", index), true); //$NON-NLS-1$
                    }
                    else
                    {
                        SELECTED = index;
                    }
                }
            }
            catch (Exception e)
            {
                UE.displayError(e);
            }
        }
    }

    @Override
    public void finalWarning() throws Exception
    {
        if (SELECTED >= 0)
        {
            BUILDING.setName(SELECTED, txtNAME.getText());
            BUILDING.setPluralName(SELECTED, txtNAMES.getText());
            DESCRIPTION.setDesc((short)SELECTED, txtDESC.getText());
            for (int i = 0; i < BUILDING.getNumberOfEntries(); i++)
            {
                BUILDING.setDescAddress(i, DESCRIPTION.getAddress((short)i));
            }
            short cst;
            int vhm;
            
            //cost
            vhm = Integer.parseInt(txtIND_COST.getText());
            if (vhm > 65535)
            {
                vhm = 65535;
            }
            if (!(vhm < 0))
            {
                BUILDING.setIndCost(SELECTED, vhm);
            }

            //energy
            cst = Short.parseShort(txtEN_COST.getText());
            if (!(cst<0))
            {
                BUILDING.setEnCost(SELECTED, cst);
            }

            //morale
            cst = Short.parseShort(txtMORALE_BONI.getText());
            BUILDING.setMoraleBoni(SELECTED, cst);
            //bonuses
            for (int i = 0; i < 6; i++)
            {
                cst = Short.parseShort(txtBONI[i].getText());
                BUILDING.setBoni(SELECTED, i, cst);

                cst = Short.parseShort(txtBONI_2[i].getText());
                BUILDING.setBoni2(SELECTED, i, cst);
            }
        }
    }
}
