/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: ColValGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui.stbof;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import ue.edit.res.stbof.wtf.*;
import ue.edit.res.stbof.rst.*;
import ue.edit.res.*;
import ue.gui.*;
import ue.*;
import ue.util.*;

@SuppressWarnings("serial")  //$NON-NLS-1$
public class ColValGUI extends MainPanel{
	/**
	 * 
	 */
	//files
	private Colval[] COLON = new Colval[5];
	//components
	private JComboBox jcbEMP;
	private JTextField[] txtSET;
	private int SELECTED = -1;
	
	/**constructor*/
	public ColValGUI(Stbof st){
		try{
			COLON[0] = (Colval)st.getInternalFile(Stbof.fileCCOLVAL_WTF, true);
			COLON[1] = (Colval)st.getInternalFile(Stbof.fileHCOLVAL_WTF, true);
			COLON[2] = (Colval)st.getInternalFile(Stbof.fileFCOLVAL_WTF, true);
			COLON[3] = (Colval)st.getInternalFile(Stbof.fileKCOLVAL_WTF, true);
			COLON[4] = (Colval)st.getInternalFile(Stbof.fileRCOLVAL_WTF, true);
			Race RACE = (Race)st.getInternalFile(Stbof.fileRACE_RST, true);
			//create
			jcbEMP = new JComboBox();
			txtSET = new JTextField[13];
			//setup
			Font def = UE.SETTINGS.getDefaultFont();
			jcbEMP.setFont(def);
			for (int i=0; i<13; i++){
				txtSET[i] = new JTextField(10);
				txtSET[i].setFont(def);
			}
			jcbEMP.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent ae){
					if (jcbEMP.getSelectedIndex()<0) {
						return;
					}
					try{
						finalWarning();
						SELECTED = jcbEMP.getSelectedIndex();
						for (int i=0; i<13; i++){
							txtSET[i].setText(Double.toString(COLON[SELECTED].getValue(0, i)));
						}
					}catch (Exception t){
						UE.displayError(t);
					}
				}
			});
			for (int i=0; i<5; i++){
				jcbEMP.addItem(new ID(RACE.getName(i), i));
			}
			//place
			JLabel lbl;
			setLayout(new GridBagLayout());
			GridBagConstraints c = new GridBagConstraints();
			c.gridx=1;
			c.gridy=0;
			c.gridwidth=1;
			c.gridheight=1;
			c.fill=GridBagConstraints.BOTH;
			c.insets=new Insets(5, 5, 5, 5);
			add(jcbEMP, c);
			c.gridx=0;
			c.gridy=1;
			lbl = new JLabel(Language.getString("ColValGUI.0")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=2;
			lbl = new JLabel(Language.getString("ColValGUI.1")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=3;
			lbl = new JLabel(Language.getString("ColValGUI.2")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=4;
			lbl = new JLabel(Language.getString("ColValGUI.3")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=5;
			lbl = new JLabel(Language.getString("ColValGUI.4")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=6;
			lbl = new JLabel(Language.getString("ColValGUI.5")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=7;
			lbl = new JLabel(Language.getString("ColValGUI.6")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=8;
			lbl = new JLabel(Language.getString("ColValGUI.7")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=9;
			lbl = new JLabel(Language.getString("ColValGUI.8")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=10;
			lbl = new JLabel(Language.getString("ColValGUI.9")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=11;
			lbl = new JLabel(Language.getString("ColValGUI.10")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=12;
			lbl = new JLabel(Language.getString("ColValGUI.11")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridy=13;
			lbl = new JLabel(Language.getString("ColValGUI.12")); //$NON-NLS-1$
			lbl.setFont(def);
			add(lbl, c);
			c.gridx=1;
			for (int i=0; i<13; i++){
				c.gridy=1+i;
				add(txtSET[i], c);
			}
		}catch (Exception e){
			UE.displayError(e);
		}
	}
	
	@Override
	public void finalWarning() throws Exception {
		if (SELECTED<0) {
			return;
		}
		for (int i=0; i<13; i++){
            String str = txtSET[i].getText();
            double t = Double.parseDouble(str);
            COLON[SELECTED].setValue(0, i, t);
		}
	}
}
