/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: EnvironGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui.stbof;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import ue.edit.res.stbof.est.*;
import ue.gui.*;
import ue.util.SettingsManager;
import ue.*;
import ue.exception.*;

/**Used to edit planet types.*/
@SuppressWarnings("serial")  //$NON-NLS-1$
public class EnvironGUI extends MainPanel{
	private Environ ENVIRON;
	//items
	private JComboBox jcbTYPE = new JComboBox();
	private JButton btnAPPLY = new JButton(Language.getString("EnvironGUI.0")); //$NON-NLS-1$
	private JLabel lblFREQ = new JLabel(Language.getString("EnvironGUI.1")); //$NON-NLS-1$
	private JTextField txtFREQ = new JTextField(5);
	private JLabel lblSUM = new JLabel();
	// strings
	private static String strSUM = Language.getString("EnvironGUI.2"); //$NON-NLS-1$
	
	/**Creates an instance of EnvironGUI.
	@param env the Environ to work with.
	*/
	public EnvironGUI(Environ env){
		if (env==null) {
			return;
		}
		ENVIRON = env;
		//set font
		Font def = UE.SETTINGS.getDefaultFont();
		jcbTYPE.setFont(def);
		lblFREQ.setFont(def);
		txtFREQ.setFont(def);
		btnAPPLY.setFont(def);
		lblSUM.setFont(def);
		//add listeners
		btnAPPLY.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int indi = jcbTYPE.getSelectedIndex();
				if (indi != -1){
					try{
						Float flt = new Float(txtFREQ.getText());
						ENVIRON.setFrequency(indi, flt.floatValue());
						lblSUM.setText(strSUM.replace("%1", Float.toString(ENVIRON.getFreqSum()))); //$NON-NLS-1$
					}catch (InvalidArgumentsException g){
						displayError(g);
					}catch (Exception gu){
						try{
							txtFREQ.setText(Float.toString(ENVIRON.getFrequency(indi)));
							lblSUM.setText(strSUM.replace("%1", Float.toString(ENVIRON.getFreqSum()))); //$NON-NLS-1$
						}catch (InvalidArgumentsException g){
							displayError(g);
						}catch (Exception gui){
							displayError(gui);
						}
					}
				}
			}
		});
		jcbTYPE.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int indi = jcbTYPE.getSelectedIndex();
				if (indi != -1){
					try{
						txtFREQ.setText(Float.toString(ENVIRON.getFrequency(indi)));
					}catch (InvalidArgumentsException g){
						displayError(g);
					}
				}
			}
		});
		//add items
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.insets=new Insets(5, 5, 5, 5);
		c.fill=GridBagConstraints.BOTH;
		c.gridx = 0;
		c.gridy = 0;
		c.gridwidth = 3;
		c.gridheight = 1;
		add(jcbTYPE, c);
		c.gridx = 0;
		c.gridy = 1;
		c.gridwidth = 2;
		add(lblFREQ, c);
		c.gridx = 2;
		c.gridwidth = 1;
		add(txtFREQ, c);
		c.gridx = 3;
		add(btnAPPLY, c);
		c.gridx = 0;
		c.gridy = 2;
		add(lblSUM, c);
		fillList();
		lblSUM.setText(strSUM.replace("%1", Float.toString(ENVIRON.getFreqSum()))); //$NON-NLS-1$
	}
	//fill the type combo
	private void fillList(){
		//fill TYPE
		try{
			jcbTYPE.removeAllItems();
			for (short x=0; x<ENVIRON.entries() && x<8; x++){ jcbTYPE.addItem(ENVIRON.getName(x));}
		}catch (Exception e){
			e.printStackTrace();
			//this should never happen
		}		
	}
	//displays and prints the error to error.log
	private void displayError(Exception e){
		UE.displayError(e);
	}
	
	/*this is used to apply recent changes before panel is removed
	no need for it in this case tho*/
	@Override
	public void finalWarning() throws Exception{};
}

