/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: InGameTextGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui.stbof;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import ue.*;
import ue.edit.res.*;
import ue.edit.res.stbof.tdb.*;
import ue.gui.*;
import ue.util.*;

@SuppressWarnings("serial")  //$NON-NLS-1$
public class InGameTextGUI extends MainPanel{
	private Stbof STBOF;
	private int BIG_INDEX = -1;
	private int INDEX = -1;
	private int FIND_INDEX = -1;
	ArrayList<TextDataBase> DATA = new ArrayList<TextDataBase>();
	
	private JComboBox cmbTDBS = new JComboBox();
	private JList LIST = new JList();
	private JTextArea TEXT = new JTextArea(12, 30);
	private JLabel INT = new JLabel();
	private JTextField txtFIND = new JTextField();
	private JButton btnFIND = new JButton(Language.getString("InGameTextGUI.0")); //$NON-NLS-1$
	private JButton btnFINDNEXT = new JButton(Language.getString("InGameTextGUI.1")); //$NON-NLS-1$
	private ArrayList<Integer> intFIND = null;
	// strings
	private static String strINDEX = Language.getString("InGameTextGUI.2"); //$NON-NLS-1$
	
	public InGameTextGUI(Stbof st){
		STBOF = st;
		Font def = UE.SETTINGS.getDefaultFont();
		cmbTDBS.setFont(def);
		LIST.setFont(def);
		LIST.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		btnFIND.setFont(def);
		txtFIND.setFont(def);
		btnFINDNEXT.setFont(def);
		TEXT.setFont(def);
		TEXT.setLineWrap(true);
		TEXT.setWrapStyleWord(true);
		INT.setFont(def);
		JScrollPane scrolly = new JScrollPane(LIST);
		scrolly.setPreferredSize(new Dimension(200, 200));
		JScrollPane JSP = new JScrollPane(TEXT);

		LIST.addListSelectionListener(new ListSelectionListener(){
            @Override
			public void valueChanged(ListSelectionEvent e){
				if (BIG_INDEX<0 || LIST.getSelectedIndex() < 0) {
					return;
				}
                try
                {
                    finalWarning();
                }
                catch (Exception ex)
                {
                    // really bad stuff happening - bail
                    UE.displayError(ex);
                    return;
                }
				TextDataBase txt = DATA.get(BIG_INDEX);
				try{
					TEXT.setText(txt.getString(LIST.getSelectedIndex()));
				}catch (Exception ze){
					UE.displayError(ze);
				}
				INDEX = LIST.getSelectedIndex();
				INT.setText(strINDEX.replace("%1", Integer.toString(INDEX))); //$NON-NLS-1$
				int tmp = BIG_INDEX;
				BIG_INDEX=-1;
				LIST.setListData(txt.getShortStrings());
				LIST.setSelectedIndex(INDEX);
				BIG_INDEX=tmp;
			}
		});
		cmbTDBS.addActionListener(new ActionListener(){
            @Override
			public void actionPerformed(ActionEvent e){
				if (BIG_INDEX!=-1)
                {
                    try
                    {
                        finalWarning();
                    }
                    catch (Exception ex)
                    {
                        // really bad stuff happening - bail
                        UE.displayError(ex);
                        return;
                    }
				}
				BIG_INDEX = cmbTDBS.getSelectedIndex();
				TextDataBase txt = DATA.get(BIG_INDEX);
				INDEX = -1;
				TEXT.setText(""); //$NON-NLS-1$
				LIST.setListData(txt.getShortStrings());
				INT.setText(""); //$NON-NLS-1$
				txtFIND.setText(""); //$NON-NLS-1$
				intFIND=null;
			}
		});
		btnFIND.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (BIG_INDEX==-1) {
					return;
				}
				TextDataBase txt = DATA.get(BIG_INDEX);
				String[] ser = txt.getFullStrings();
				String tmp = txtFIND.getText();
				intFIND=null;
				tmp=tmp.toLowerCase();
				for (int i=0; i<ser.length; i++){
					ser[i] = ser[i].toLowerCase();
					if (ser[i].indexOf(tmp)!=-1){
						if (intFIND==null) {
							intFIND=new ArrayList<Integer>();
						}
						intFIND.add(i);
					}
				}
				if (intFIND!=null){
					FIND_INDEX=0;
					LIST.setSelectedIndex(intFIND.get(0));
					LIST.ensureIndexIsVisible(intFIND.get(0));
				}
			}
		});
		btnFINDNEXT.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (intFIND!=null){
					if (BIG_INDEX==-1) {
						return;
					}
					FIND_INDEX+=1;
					if (intFIND.size()==FIND_INDEX) {
						FIND_INDEX=0;
					}
					LIST.setSelectedIndex(intFIND.get(FIND_INDEX));
					LIST.ensureIndexIsVisible(intFIND.get(FIND_INDEX));
				}
			}
		});		
		//lay
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.insets=new Insets(5, 5, 5, 5);
		c.fill=GridBagConstraints.BOTH;
		c.gridwidth = 4;
		c.gridheight = 1;
		c.gridx = 0;
		c.gridy = 0;
		add(cmbTDBS, c);
		c.gridwidth = 1;
		c.gridy = 1;
		add(scrolly, c);
		c.gridx = 1;
		c.gridwidth = 3;
		add(JSP, c);
		c.gridx = 0;
		c.gridy = 2;
		add(INT, c);
		c.gridy = 3;
		c.gridwidth = 2;
		add(txtFIND, c);
		c.gridwidth = 1;
		c.gridx = 2;
		add(btnFIND, c);
		c.gridx = 3;
		add(btnFINDNEXT, c);
		//fill
		Enumeration<String[]> enumi = STBOF.getFiles(new java.io.FilenameFilter(){
			public boolean accept(File dir, String name){
				String str=name.toLowerCase();
				if (str.endsWith(".tdb")) { //$NON-NLS-1$
					return true;
				} else {
					return false; //$NON-NLS-1$
				}
			}
		});
		String str;
		GenericFile gen;
		ByteArrayInputStream bais;
		while (enumi.hasMoreElements()){
			str = enumi.nextElement()[0];
			try{
				gen = (GenericFile)STBOF.getInternalFile(str, true);
				bais = new ByteArrayInputStream(gen.getData());
                                //System.out.println("Test1: " + gen.getName());
				DATA.add(new TextDataBase(gen.getName(), bais));
				cmbTDBS.addItem(str);
			}catch(Exception zu){
				UE.displayError(zu);
			}
		}
		
		INT.setText(strINDEX.replace("%1", Integer.toString(INDEX))); //$NON-NLS-1$
	}
	
	@Override
	public void finalWarning() throws Exception{
        if (BIG_INDEX==-1 || INDEX==-1) {
            return;
        }
        TextDataBase txt = DATA.get(BIG_INDEX);
        boolean b = txt.setString(INDEX, TEXT.getText());
        if (b){
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            txt.save(baos);
            byte[] byt = baos.toByteArray();
                            //System.out.println("Test2: " + txt.getName());
            STBOF.addInternalFile(new GenericFile(txt.getName(), byt));
        }
	}
}
