/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: LexiconGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui.stbof;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import ue.Language;
import ue.UE;
import ue.edit.res.stbof.dic.*;
import ue.gui.*;

@SuppressWarnings("serial")  //$NON-NLS-1$
public class LexiconGUI extends MainPanel{
	private Lexicon LEC;
	private int INDEX = -1;
	private int FIND_INDEX = -1;
	private JList LIST = new JList();
	private JTextArea TEXT = new JTextArea(12, 30);
	private JLabel INT = new JLabel();
	private JTextField txtFIND = new JTextField();
	private JButton btnFIND = new JButton(Language.getString("LexiconGUI.0")); //$NON-NLS-1$
	private JButton btnFINDNEXT = new JButton(Language.getString("LexiconGUI.1")); //$NON-NLS-1$
	private ArrayList<Integer> intFIND = null;
	// strings
	private static String strINDEX = Language.getString("LexiconGUI.2"); //$NON-NLS-1$

	
	public LexiconGUI(Lexicon l){
		LEC = l;
		Font def = UE.SETTINGS.getDefaultFont();
		LIST.setFont(def);
		LIST.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		TEXT.setFont(def);
		btnFIND.setFont(def);
		txtFIND.setFont(def);
		btnFINDNEXT.setFont(def);
		TEXT.setLineWrap(true);
		TEXT.setWrapStyleWord(true);
		INT.setFont(def);
		LIST.setListData(LEC.getEntries());
		JScrollPane scrolly = new JScrollPane(LIST);
		scrolly.setPreferredSize(new Dimension(200, 200));
		JScrollPane JSP = new JScrollPane(TEXT);

		LIST.addListSelectionListener(new ListSelectionListener(){
            @Override
			public void valueChanged(ListSelectionEvent e){
				if (LIST.getSelectedIndex() < 0) {
					return;
				}
                try
                {
    				finalWarning();
                }
                catch (Exception ex)
                {
                    // really bad stuff happening - bail
                    UE.displayError(ex);
                    return;
                }
			}
		});
		btnFIND.addActionListener(new ActionListener(){
            @Override
			public void actionPerformed(ActionEvent ae){
				String[] ser = LEC.getFullEntries();
				String tmp = txtFIND.getText();
				intFIND=null;
				tmp=tmp.toLowerCase();
				for (int i=0; i<ser.length; i++){
					ser[i] = ser[i].toLowerCase();
					if (ser[i].indexOf(tmp)!=-1){
						if (intFIND==null) {
							intFIND=new ArrayList<Integer>();
						}
						intFIND.add(i);
					}
				}
				if (intFIND!=null){
					FIND_INDEX=0;
					LIST.setSelectedIndex(intFIND.get(0));
					LIST.ensureIndexIsVisible(intFIND.get(0));
				}
			}
		});
		btnFINDNEXT.addActionListener(new ActionListener(){
            @Override
			public void actionPerformed(ActionEvent ae){
				if (intFIND!=null){
					FIND_INDEX+=1;
					if (intFIND.size()==FIND_INDEX) {
						FIND_INDEX=0;
					}
					LIST.setSelectedIndex(intFIND.get(FIND_INDEX));
					LIST.ensureIndexIsVisible(intFIND.get(FIND_INDEX));
				}
			}
		});
		//lay
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.insets=new Insets(5, 5, 5, 5);
		c.fill=GridBagConstraints.BOTH;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.gridx = 0;
		c.gridy = 0;
		add(scrolly, c);
		c.gridx = 1;
		c.gridwidth = 3;
		add(JSP, c);
		c.gridx = 0;
		c.gridy = 1;
		add(INT, c);
		c.gridwidth = 2;
		c.gridy = 2;
		add(txtFIND, c);
		c.gridwidth = 1;
		c.gridx = 2;
		add(btnFIND, c);
		c.gridx = 3;
		add(btnFINDNEXT, c);
	}
	
	@Override
	public void finalWarning() throws Exception{
        boolean b = false;
        if (INDEX > 0) {
            b = LEC.setEntry(INDEX, TEXT.getText());
        }
        INDEX = LIST.getSelectedIndex();
        if (INDEX>=0) {
            TEXT.setText(LEC.getEntry(INDEX));
        }
        INT.setText(strINDEX.replace("%1", Integer.toString(INDEX))); //$NON-NLS-1$
        if (b){
            LIST.setListData(LEC.getEntries());
            LIST.setSelectedIndex(INDEX);
        }
	}
}
