/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: MeplanetGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui.stbof;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import ue.*;
import ue.gui.*;
import ue.util.SettingsManager;
import ue.edit.res.stbof.bin.*;

@SuppressWarnings("serial")  //$NON-NLS-1$
public class MeplanetGUI extends MainPanel{
	private Meplanet PLANET;
	//components
	JButton btnADD = new JButton(Language.getString("MeplanetGUI.0")); //$NON-NLS-1$
	JButton btnEDIT = new JButton(Language.getString("MeplanetGUI.1")); //$NON-NLS-1$
	JButton btnREMOVE = new JButton(Language.getString("MeplanetGUI.2")); //$NON-NLS-1$
	JButton btnADD2 = new JButton(Language.getString("MeplanetGUI.0")); //$NON-NLS-1$
	JButton btnEDIT2 = new JButton(Language.getString("MeplanetGUI.1")); //$NON-NLS-1$
	JButton btnREMOVE2 = new JButton(Language.getString("MeplanetGUI.2")); //$NON-NLS-1$
	JComboBox jcbOWNER = new JComboBox();
	JList jlPLANET = new JList();
	JLabel jlCOLON = new JLabel(Language.getString("MeplanetGUI.3")); //$NON-NLS-1$
	JComboBox jcbLEVEL = new JComboBox();
	/**constructor
	@param planet the Meplanet to work with*/
	public MeplanetGUI(Meplanet planet){
		PLANET = planet;
		//font
		Font def = UE.SETTINGS.getDefaultFont();
		btnADD.setFont(def);
		btnEDIT.setFont(def);
		btnREMOVE.setFont(def);
		btnADD2.setFont(def);
		btnEDIT2.setFont(def);
		btnREMOVE2.setFont(def);
		jcbOWNER.setFont(def);
		jlPLANET.setFont(def);
		jlCOLON.setFont(def);
		jcbLEVEL.setFont(def);
		jlPLANET.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		//listeners
		ActionListener first = new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (ae.getActionCommand().equals(Language.getString("MeplanetGUI.0"))){ //$NON-NLS-1$
					String n = JOptionPane.showInputDialog(Language.getString("MeplanetGUI.4"), Language.getString("MeplanetGUI.5")); //$NON-NLS-1$ //$NON-NLS-2$
					if (n!=null){
						try{
							PLANET.addOwner(n);
							fillOwners();
						}catch (Exception g){
							UE.displayError(g);
						}
					}
					return;
				}
				if (jcbOWNER.getSelectedIndex()<0) {
					return;
				}
				if (ae.getActionCommand().equals(Language.getString("MeplanetGUI.1"))){ //$NON-NLS-1$
					String n = JOptionPane.showInputDialog(Language.getString("MeplanetGUI.6"), jcbOWNER.getSelectedItem()); //$NON-NLS-1$
					if (n!=null){
						try{
							int SELECTED = jcbOWNER.getSelectedIndex();
							PLANET.setOwner((String)jcbOWNER.getSelectedItem(), n);
							fillOwners();
							jcbOWNER.setSelectedIndex(SELECTED);
						}catch (Exception g){
							UE.displayError(g);
						}
					}
					return;
				}
				if (ae.getActionCommand().equals(Language.getString("MeplanetGUI.2"))){ //$NON-NLS-1$
					PLANET.removeOwner((String)jcbOWNER.getSelectedItem());
					fillOwners();
					return;
				}
			}
		};
		btnADD.addActionListener(first);
		btnEDIT.addActionListener(first);
		btnREMOVE.addActionListener(first);
		ActionListener second = new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (jcbOWNER.getSelectedIndex()<0) {
					return;
				}
				if (ae.getActionCommand().equals(Language.getString("MeplanetGUI.0"))){ //$NON-NLS-1$
					String n = JOptionPane.showInputDialog(Language.getString("MeplanetGUI.7"), Language.getString("MeplanetGUI.8")); //$NON-NLS-1$ //$NON-NLS-2$
					if (n!=null){
						try{
							String own = (String)jcbOWNER.getSelectedItem();
							PLANET.addPlanet(own, n);
							jlPLANET.setListData(PLANET.getPlanets(own));
						}catch (Exception g){
							UE.displayError(g);
						}
					}
					return;
				}
				if (jlPLANET.getSelectedIndex()<0) {
					return;
				}
				if (ae.getActionCommand().equals(Language.getString("MeplanetGUI.1"))){ //$NON-NLS-1$
					String n = JOptionPane.showInputDialog(Language.getString("MeplanetGUI.9"), jlPLANET.getSelectedValue()); //$NON-NLS-1$
					if (n!=null){
						try{
							String own = (String)jcbOWNER.getSelectedItem();
							PLANET.setPlanet(own, jlPLANET.getSelectedIndex(), n);
							jlPLANET.setListData(PLANET.getPlanets(own));
						}catch (Exception g){
							UE.displayError(g);
						}
					}
					return;
				}
				if (ae.getActionCommand().equals(Language.getString("MeplanetGUI.2"))){ //$NON-NLS-1$
					try{
						String own = (String)jcbOWNER.getSelectedItem();
						PLANET.removePlanet(own, jlPLANET.getSelectedIndex());
						jlPLANET.setListData(PLANET.getPlanets(own));
					}catch (Exception g){
						UE.displayError(g);
					}
					return;
				}
			}
		};
		btnADD2.addActionListener(second);
		btnEDIT2.addActionListener(second);
		btnREMOVE2.addActionListener(second);
		jcbOWNER.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				//nothing to save
				//read
				String own = (String)jcbOWNER.getSelectedItem();
				jlPLANET.setListData(PLANET.getPlanets(own));
			}
		});
		jlPLANET.addListSelectionListener(new ListSelectionListener(){
			public void valueChanged(ListSelectionEvent e){
				if (jcbOWNER.getSelectedIndex()<0){
					btnEDIT2.setEnabled(false);
					btnREMOVE2.setEnabled(false);
					jcbLEVEL.setEnabled(false);
				}else if (jlPLANET.getSelectedIndex()<0){
					btnEDIT2.setEnabled(false);
					btnREMOVE2.setEnabled(false);
					jcbLEVEL.setEnabled(false);
				}else{
					btnEDIT2.setEnabled(true);
					btnREMOVE2.setEnabled(true);
					jcbLEVEL.setEnabled(true);
					String own = (String)jcbOWNER.getSelectedItem();
					try{
						jcbLEVEL.setSelectedIndex(PLANET.getColonized(own, jlPLANET.getSelectedIndex()));
					}catch (Exception g){
						UE.displayError(g);
					}
				}
			}
		});
		jcbLEVEL.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (jlPLANET.getSelectedIndex()<0 || jcbOWNER.getSelectedIndex()<0) {
					return;
				}
				String own = (String)jcbOWNER.getSelectedItem();
				try{
					PLANET.setColonized(own, jlPLANET.getSelectedIndex(), jcbLEVEL.getSelectedIndex());
				}catch (Exception g){
					UE.displayError(g);
				}
			}
		});
		//ok init
		jcbLEVEL.addItem("1"); //$NON-NLS-1$
		jcbLEVEL.addItem("2"); //$NON-NLS-1$
		jcbLEVEL.addItem("3"); //$NON-NLS-1$
		jcbLEVEL.addItem("4"); //$NON-NLS-1$
		jcbLEVEL.addItem("5"); //$NON-NLS-1$
		jcbLEVEL.addItem(Language.getString("MeplanetGUI.10")); //$NON-NLS-1$
		fillOwners();
		//place it
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.insets=new Insets(5, 5, 5, 5);
		c.fill=GridBagConstraints.BOTH;
		c.gridx = 0;
		c.gridy = 0;
		c.gridwidth = 1;
		c.gridheight = 1;
		add(jcbOWNER, c);
		c.gridx = 0;
		c.gridy = 1;
		c.gridheight = 3;
		JScrollPane scrolly = new JScrollPane(jlPLANET);
		scrolly.setPreferredSize(new Dimension(200, 200));
		add(scrolly, c);
		c.gridx = 1;
		c.gridy = 0;
		c.gridheight = 1;
		add(btnADD, c);
		c.gridx = 2;
		c.gridy = 0;
		add(btnEDIT, c);
		c.gridx = 3;
		c.gridy = 0;
		add(btnREMOVE, c);
		c.gridx = 1;
		c.gridy = 1;
		add(btnADD2, c);
		c.gridx = 2;
		c.gridy = 1;
		add(btnEDIT2, c);
		c.gridx = 3;
		c.gridy = 1;
		add(btnREMOVE2, c);
		c.gridx = 1;
		c.gridy = 2;
		c.gridwidth = 2;
		add(jlCOLON, c);
		c.gridx = 3;
		c.gridy = 2;
		c.gridwidth = 1;
		add(jcbLEVEL, c);
		btnEDIT2.setEnabled(false);
		btnREMOVE2.setEnabled(false);
		jcbLEVEL.setEnabled(false);
	}
	
	private void fillOwners(){
		jcbOWNER.removeAllItems();
		String[] ret = PLANET.getOwners();
		for (int i=0; i<ret.length; i++){
			jcbOWNER.addItem(ret[i]);
		}
		if (ret.length==0){
			btnEDIT.setEnabled(false);
			btnREMOVE.setEnabled(false);
		}else{
			btnEDIT.setEnabled(true);
			btnREMOVE.setEnabled(true);
		}
	}
	@Override
	public void finalWarning() throws Exception{
	}
}
