/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: MoraleGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui.stbof;

import javax.swing.*;

import java.awt.*;
import ue.edit.res.stbof.bin.*;
import ue.edit.res.stbof.rst.*;
import ue.gui.*;
import ue.*;

/**This class is used to edit morale penalties for major races.*/
@SuppressWarnings("serial")  //$NON-NLS-1$
public class MoraleGUI extends MainPanel{
	//data
	private Morale MORALE = null;
	private Race RACES = null;
	//items
	JLabel[] lblDESC = new JLabel[28];
	JTextField[] txtMORAL = new JTextField[115];
	
	/**Creates an instance of this class.*/
	public MoraleGUI(Morale morale, Race race){
		//check and associate
		if (morale==null || race==null) {
			return;
		}
		this.MORALE = morale;
		this.RACES = race;
		//build and set up
		Font def = UE.SETTINGS.getDefaultFont();
		for (short i=0; i<5; i++){
			try{
				lblDESC[i] = new JLabel(RACES.getName(i));
			}catch (Exception ze){
				UE.displayError(ze);
			}
			lblDESC[i].setFont(def);
			lblDESC[i].setHorizontalAlignment(SwingConstants.CENTER);
		}
		String str = null;
		int a = 0;
		for (short i=0; i<23; i++){
			switch (i){
				case 0:{
					str = Language.getString("MoraleGUI.0"); //$NON-NLS-1$
					break;
				}
				case 1:{
					str = Language.getString("MoraleGUI.1"); //$NON-NLS-1$
					break;
				}
				case 2:{
					str = Language.getString("MoraleGUI.2"); //$NON-NLS-1$
					break;
				}
				case 3:{
					str = Language.getString("MoraleGUI.3"); //$NON-NLS-1$
					break;
				}
				case 4:{
					str = Language.getString("MoraleGUI.4"); //$NON-NLS-1$
					break;
				}
				case 5:{
					str = Language.getString("MoraleGUI.5"); //$NON-NLS-1$
					break;
				}
				case 6:{
					str = Language.getString("MoraleGUI.6"); //$NON-NLS-1$
					break;
				}
				case 7:{
					str = Language.getString("MoraleGUI.7"); //$NON-NLS-1$
					break;
				}
				case 8:{
					str = Language.getString("MoraleGUI.8"); //$NON-NLS-1$
					break;
				}
				case 9:{
					str = Language.getString("MoraleGUI.9"); //$NON-NLS-1$
					break;
				}
				case 10:{
					str = Language.getString("MoraleGUI.10"); //$NON-NLS-1$
					break;
				}
				case 11:{
					str = Language.getString("MoraleGUI.11"); //$NON-NLS-1$
					break;
				}
				case 12:{
					str = Language.getString("MoraleGUI.12"); //$NON-NLS-1$
					break;
				}
				case 13:{
					str = Language.getString("MoraleGUI.13"); //$NON-NLS-1$
					break;
				}
				case 14:{
					str = Language.getString("MoraleGUI.14"); //$NON-NLS-1$
					break;
				}
				case 15:{
					str = Language.getString("MoraleGUI.15"); //$NON-NLS-1$
					break;
				}
				case 16:{
					str = Language.getString("MoraleGUI.16"); //$NON-NLS-1$
					break;
				}
				case 17:{
					str = Language.getString("MoraleGUI.17"); //$NON-NLS-1$
					break;
				}
				case 18:{
					str = Language.getString("MoraleGUI.18"); //$NON-NLS-1$
					break;
				}
				case 19:{
					str = Language.getString("MoraleGUI.19"); //$NON-NLS-1$
					break;
				}
				case 20:{
					str = Language.getString("MoraleGUI.20"); //$NON-NLS-1$
					break;
				}
				case 21:{
					str = Language.getString("MoraleGUI.21"); //$NON-NLS-1$
					break;
				}
				case 22:{
					str = Language.getString("MoraleGUI.22"); //$NON-NLS-1$
					break;
				}
			}
			a = i+5;
			lblDESC[a] = new JLabel(str);
			lblDESC[a].setFont(def);
			lblDESC[a].setHorizontalAlignment(SwingConstants.CENTER);
			for (int j=0; j<5; j++){
				a = i*5+j;
				txtMORAL[a] = new JTextField(5);
				txtMORAL[a].setFont(def);
				txtMORAL[a].setHorizontalAlignment(SwingConstants.CENTER);
			}
		}
		//lay out
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.insets=new Insets(0, 5, 0, 5);
		c.fill=GridBagConstraints.BOTH;
			//top
			c.gridy=0;
			c.gridwidth=1;
			c.gridheight=1;
			for (int i=0; i<5; i++){
				c.gridx=i+1;
				add(lblDESC[i], c);
			}
			//rest
			for (int i=0; i<23; i++){
				c.insets=new Insets(0, 5, 0, 5);
				c.gridy=i+1;
				c.gridx=0;
				add(lblDESC[i+5], c);
				for (int j=0; j<5; j++){
					c.insets=new Insets(0, 0, 0, 0);
					c.gridx=j+1;
					add(txtMORAL[i*5+j], c);
				}
			}
		//fill
		for (int i=0; i<23; i++){
			for (int j=0; j<5; j++){
				try{
					txtMORAL[i*5+j].setText(Integer.toString(MORALE.getValue(j, i)));
				}catch (Exception ze){
					UE.displayError(ze);
				}
			}
		}
		//setPreferredSize(new Dimension(420, 440));
	}
	@Override
	public void finalWarning() throws Exception{
		String ans = ""; //$NON-NLS-1$
		short shrt = 0;
		for (int i=0; i<23; i++){
			for (int j=0; j<5; j++){
                ans = txtMORAL[i*5+j].getText();
                shrt = Short.parseShort(ans);
                MORALE.changeValue(j, i, shrt);
			}
		}
	}
}
