/*
Ultimate Editor for Birth Of The Federation 1.02
Copyright (C) 2005-2007  Alan Podlesek

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


File: ShipGUI.java

Written by: Alan Podlesek <seqdcer@yahoo.com>

Last modified: 6.9.2007
 */
package ue.gui.stbof;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.io.*;
import java.util.*;
import ue.edit.exe.*;
import ue.edit.exe.trek.*;
import ue.edit.res.*;
import ue.edit.res.stbof.*;
import ue.edit.res.stbof.sst.*;
import ue.edit.res.stbof.rst.*;
import ue.edit.res.stbof.dic.*;
import ue.edit.res.stbof.tec.*;
import ue.gui.*;
import ue.util.*;
import ue.*;

@SuppressWarnings("serial")  //$NON-NLS-1$
public class ShipGUI extends MainPanel {
    /*DATA//DATA//DATA//DATA//DATA///**/

    private Trek TREK;  		    /**/ // make sure this one can be null!

    private Stbof STBOF;		    /**/

    private ShipList SHIP;		    /**/

    private ShipRace SHIPRACE;	    /**/

    private ShipTech SHIPTECH;	    /**/

    private StringFile DESC;	    /**/

    private Race RACE;  		    /**/

    private Lexicon LEX;		    /**/

    private TecField TECH;         /**/

    private SpecialShips SP;
    /*/GADGETS////GADGETS///GADGETS/**/
    private JPanel pnlCARD;        /**/

    private CardLayout layCARD;    /**/

    private JList lstSHIP;         /**/

    private JLabel lblPIC;         /**/

    private JTextArea txtDESC;     /* <- ship description	*/

    private JComboBox jcbSHIP;     /**/

    private JTextField txtNAME;    /* <- ship name		*/

    private JTextField txtCLASS;   /* <- ship class	*/

    private JComboBox jcbPIC;	    /* <- ship's picture	*/

    private JComboBox jcbFUNC;	    /* <- ship's function	*/

    private JComboBox jcbSHIP_NAME;	/* <- Ship name group	*/

    private JComboBox jcbMAP_RANGE;	/* <- short,medium,long	*/

    private JTextField txtMAP_SPEED;/* <- speed of ship	*/

    private JTextField txtSCN_RANGE;/* <- scanner range	*/

    private JComboBox jcbRACE;	    /**/

    private JComboBox jcbRACE_OVR;  /**/

    private JTextField txtBLD_COST;	/**/

    private JTextField txtMAIN_COST;/**/

    private JComboBox jcbCLOAK;	    /* <- Cloak level	*/

    private JTextField txtPROD;	    /**/

    private JTextField txtBEAM_ACCU;/**/

    private JTextField txtBEAM_NUM;	/**/

    private JTextField txtBEAM_MLT;	/**/

    private JTextField txtBEAM_DAM;	/**/

    private JTextField txtBEAM_MIN;	/**/

    private JTextField txtBEAM_MAX;	/**/

    private JTextField txtTORP_ACCU;/**/

    private JTextField txtTORP_NUM;	/**/

    private JTextField txtTORP_MLT;	/**/

    private JTextField txtTORP_DAM;	/**/

    private JTextField txtTORP_MIN;	/**/

    private JTextField txtTORP_MAX;	/**/

    private JTextField txtSHLD_PEN;	/**/

    private JTextField txtSHLD_LVL;	/**/

    private JTextField txtSHLD_STR;	/**/

    private JTextField txtSHLD_REC;	/**/

    private JTextField txtHULL_STR;	/**/

    private JTextField txtDEFENSE;	/**/

    private JTextField txtAGILITY;	/**/

    private JComboBox jcbPARENT;	/**/

    private JLabel[] lblPRNT_TECH;	/**/

    private JLabel lblPARREQ;	    /**/

    private JLabel lblDESCBOT;	    /**/

    private JLabel lblSPECIAL;          /**/

    private JTextField[] txtTEC_REQ;/**/

    private JCheckBox chkSPECIAL;   /**/

    private JCheckBox chkSCREENSAVER;   /**/

    private JButton btnNEW;			/**/

    private JButton btnRM;			/**/

    private JButton btnMUP;			/**/

    private JButton btnMDN;			/**/

    private JCheckBox   chkPHASER_HOB_MOD;

    private JComboBox   cmbPHASER_HOB;

    private JCheckBox   chkTORPEDO_HOB_MOD;

    private JComboBox   cmbTORPEDO_HOB;

    /*///CONTROLERS////CONTROLERS////**/
    private int SELECTED = -1;	    /**/

    private boolean PAUSE = false;	/**/

    private HashSet<Integer> SPECIAL;
    private HashSet<String> SCREENSAVER;
    private int MAX_SCREENSAVER = 0;
    /*///////////////////////////////**/
    // strings
    private static String strUPGRADE = Language.getString("ShipGUI.0"); //$NON-NLS-1$
    private static String strSP_TOTAL = Language.getString("ShipGUI.53"); //$NON-NLS-1$

    public ShipGUI(Stbof st, Trek trek)
    {
        SPECIAL = new HashSet<Integer>();
        SCREENSAVER = new HashSet<String>();
        /*LOAD DATA*/
        if (st == null) {
            return;
        }
        STBOF = st;
        TREK = trek;
        try {
            SHIP = (ShipList) STBOF.getInternalFile(Stbof.fileSHIPLIST_SST, true);
            SHIPRACE = (ShipRace) STBOF.getInternalFile(Stbof.fileSHIPRACE_SST, true);
            SHIPTECH = (ShipTech) STBOF.getInternalFile(Stbof.fileSHIPTECH_SST, true);
            RACE = (Race) STBOF.getInternalFile(Stbof.fileRACE_RST, true);
            DESC = (StringFile) STBOF.getInternalFile(Stbof.fileSHIPDESC_SST, true);
            LEX = (Lexicon) STBOF.getInternalFile(Stbof.fileLEXICON_DIC, true);
            TECH = (TecField) STBOF.getInternalFile(Stbof.fileTECFIELD_TEC, true);
        } catch (Exception n) {
            UE.displayError(n);
        }
        if (SHIP == null || SHIPRACE == null || SHIPTECH == null || RACE == null || DESC == null || LEX == null || TECH == null) {
            return;
        }
        Font def = UE.SETTINGS.getDefaultFont();
        /*SINCHRONIZE FILES*/
        for (int i = 0; i < SHIP.getNumberOfEntries(); i++) {
            try {
                int race_o = SHIP.getRace(i);
                int race = SHIPTECH.getRace(i);
                if (race_o != race) {
                    SHIP.setRace(i, (short) race, false);
                }
            } catch (Exception op) {
                UE.displayError(op);
            }
        }
        try {
            int[] id2 = SHIP.allignIDs();
            SHIPTECH.reOrder(id2);
            int[] id = SHIP.getStartingIDs();
            SHIPRACE.setShipStarts(id);
        } catch (Exception e) {
            UE.displayError(e);
            return;
        }

        //setup description indexes
        DESC.reset();
        for (int i = 0; i < SHIP.getNumberOfEntries(); i++) {
            try {
                DESC.setIndex(SHIP.getDescAddress(i), i);
            } catch (Exception e) {
                UE.displayError(e);
            }
        }

        if (TREK != null) {
            try {
                SP = (SpecialShips) TREK.getInternalFile(Trek.fileSPECIAL_SHIPS, true);

                SPECIAL = SP.getShipIDs();

                ScreensaverModelList sml = (ScreensaverModelList) TREK.getInternalFile(Trek.fileSCREENSAVER_MODEL_LIST, true);
                MAX_SCREENSAVER = sml.getMax();
                String m;

                for (int i = 0; i < sml.getNumberofEntries(); i++) {
                    m = sml.get(i);
                    m = m.substring(0, m.length() - 4);

                    if (SHIP.getFirstIDWithPrefix(m) >= 0)
                    {
                        SCREENSAVER.add(sml.get(i));
                    }
                }
            } catch (Exception e) {
                UE.displayError(e);
            }
        }
        /*CREATE AND FILL PANELS*/
        /*SWITCH*/
        JPanel pnlSWITCH = new JPanel(new BorderLayout());
        JButton btn = new JButton("<<<"); //$NON-NLS-1$
        btn.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent ae) {
                layCARD.previous(pnlCARD);
            }
        });
        pnlSWITCH.add(btn, BorderLayout.WEST);
        ////
        JLabel lbl;
        lblDESCBOT = new JLabel();
        lblDESCBOT.setFont(def);
        lblDESCBOT.setHorizontalAlignment(SwingConstants.CENTER);
        pnlSWITCH.add(lblDESCBOT, BorderLayout.CENTER);
        ////
        btn = new JButton(">>>"); //$NON-NLS-1$
        btn.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent ae) {
                layCARD.next(pnlCARD);
            }
        });
        pnlSWITCH.add(btn, BorderLayout.EAST);
        /*ONE*/
        //create
        JPanel pnlONE = new JPanel(new GridBagLayout());
        lblPIC = new JLabel();
        txtDESC = new JTextArea();
        txtNAME = new JTextField(40);
        txtCLASS = new JTextField(40);
        jcbPIC = new JComboBox();
        JPanel pnlONE_1 = new JPanel(new GridBagLayout());
        jcbFUNC = new JComboBox();
        jcbSHIP_NAME = new JComboBox();
        jcbMAP_RANGE = new JComboBox();
        txtMAP_SPEED = new JTextField(6);
        txtSCN_RANGE = new JTextField(6);
        jcbRACE = new JComboBox();
        txtBLD_COST = new JTextField(6);
        txtMAIN_COST = new JTextField(6);
        jcbCLOAK = new JComboBox();
        txtPROD = new JTextField(6);
        //setup
        txtDESC.setLineWrap(true);
        txtDESC.setWrapStyleWord(true);
        txtDESC.setFont(def);
        txtNAME.setFont(def);
        txtCLASS.setFont(def);
        txtPROD.setFont(def);
        jcbPIC.setFont(def);
        Enumeration<String[]> enu = STBOF.getFiles(new java.io.FilenameFilter()
        {
            @Override
            public boolean accept(File dir, String name) {
                if ((name.toLowerCase()).startsWith("i_") && (name.toLowerCase()).endsWith("120.tga")) { //$NON-NLS-1$ //$NON-NLS-2$
                    return true; //$NON-NLS-1$ //$NON-NLS-2$
                }
                return false;
            }
        });
        while (enu.hasMoreElements()) {
            jcbPIC.addItem(enu.nextElement()[0]);
        }
        jcbPIC.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0) {
                    return;
                }

                String nm = (String) jcbPIC.getSelectedItem();
                try {
                    String tr = SHIP.getImageName(SELECTED);

                    TargaImage img = STBOF.getTargaImage(nm, false);
                    lblPIC.setIcon(new ImageIcon(img.getThumbnail(120, false, false)));
                    nm = nm.substring(2, nm.length() - 7);
                    SHIP.setImageName(SELECTED, nm);

                    if (TREK != null) {
                        ScreensaverModelList sml = (ScreensaverModelList) TREK.getInternalFile(Trek.fileSCREENSAVER_MODEL_LIST, true);

                        if (!SHIP.getGraphics().contains(tr)) {
                            sml.remove(tr + ".hob"); //$NON-NLS-1$
                        }
                    }
                } catch (Exception ex) {
                    lblPIC.setIcon(null);
                    UE.displayError(ex);
                }
            }
        });
        jcbFUNC.setFont(def);
        try {
            jcbFUNC.addItem(new ID(LEX.getEntry(1103), 0));
            jcbFUNC.addItem(new ID(LEX.getEntry(232), 1));
            jcbFUNC.addItem(new ID(LEX.getEntry(204), 2));
            jcbFUNC.addItem(new ID(LEX.getEntry(1183), 3));
            jcbFUNC.addItem(new ID(LEX.getEntry(173), 4));
            jcbFUNC.addItem(new ID(LEX.getEntry(166), 5));
            jcbFUNC.addItem(new ID(LEX.getEntry(895), 6));
            jcbFUNC.addItem(new ID(LEX.getEntry(57), 7));
            jcbFUNC.addItem(new ID(Language.getString("ShipGUI.1"), 8)); //$NON-NLS-1$
            jcbFUNC.addItem(new ID(LEX.getEntry(1366), 9));
        } catch (Exception et) {
            UE.displayError(et);
            return;
        }
        jcbFUNC.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0 || jcbFUNC.getSelectedIndex() < 0) {
                    return;
                }
                try {
                    SHIP.setFunction(SELECTED, (short) jcbFUNC.getSelectedIndex());
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });
        jcbSHIP_NAME.setFont(def);
        try {
            for (int i = 0; i < 62; i++) {
                jcbSHIP_NAME.addItem(Integer.toString(i));
            }
        } catch (Exception et) {
            UE.displayError(et);
            return;
        }
        jcbSHIP_NAME.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0 || jcbSHIP_NAME.getSelectedIndex() < 0) {
                    return;
                }
                try {
                    SHIP.setNameGroup(SELECTED, (short) jcbSHIP_NAME.getSelectedIndex());
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });
        jcbMAP_RANGE.setFont(def);
        try {
            int i = -1;
            jcbMAP_RANGE.addItem(new ID(Language.getString("ShipGUI.2"), i++));                //-1 //$NON-NLS-1$
            jcbMAP_RANGE.addItem(new ID(LEX.getEntry(1147), i++));    //0
            jcbMAP_RANGE.addItem(new ID(LEX.getEntry(627), i++));     //1
            jcbMAP_RANGE.addItem(new ID(LEX.getEntry(611), i++));     //2
            jcbMAP_RANGE.addItem(new ID(Language.getString("ShipGUI.3"), i++));             //3 //$NON-NLS-1$
        } catch (Exception et) {
            UE.displayError(et);
            return;
        }
        jcbMAP_RANGE.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0 || jcbMAP_RANGE.getSelectedIndex() < 0) {
                    return;
                }
                try {
                    SHIP.setMapRange(SELECTED, ((ID) jcbMAP_RANGE.getSelectedItem()).hashCode());
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });
        txtMAP_SPEED.setFont(def);
        txtSCN_RANGE.setFont(def);
        jcbRACE.setFont(def);
        jcbRACE.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0 || jcbRACE.getSelectedIndex() < 0) {
                    return;
                }
                try {
                    short huh = (short) jcbRACE.getSelectedIndex();
                    if (huh >= 35) {
                        huh = 36; //36 stands for aliens, 35 seems not to be a valid value
                    }
                    if (SHIP.setRace(SELECTED, huh, true)) {
                        SHIPTECH.setRace(SELECTED, huh);
                        int[] id2 = SHIP.allignIDs(); // <- resets ship id's
                        int h = -1;
                        for (int i = 0; i < id2.length && h == -1; i++) {
                            if (id2[i] == SELECTED) {
                                h = i;
                            }
                        }
                        SELECTED = h;
                        SHIPTECH.reOrder(id2); // reorders tech requirements
                        int[] id = SHIP.getStartingIDs(); // returns new starting id's
                        SHIPRACE.setShipStarts(id); //set starting ship id's
                        DESC.reset(); //reset description indices
                        for (int i = 0; i < SHIP.getNumberOfEntries(); i++) {
                            try {
                                DESC.setIndex(SHIP.getDescAddress(i), i); //reset description indexes
                            } catch (Exception e) {
                                UE.displayError(e);
                            }
                        }
                        if (jcbSHIP.getSelectedIndex() == 35) { //if All ships are shows just refill list
                            fillList(); //refill list
                        } else {
                            jcbSHIP.setSelectedIndex(huh); //make jcbSHIP show new owners ship list
                        }
                    }
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });
        txtBLD_COST.setFont(def);
        txtMAIN_COST.setFont(def);
        jcbCLOAK.setFont(def);
        try {
            jcbCLOAK.addItem(Language.getString("ShipGUI.2")); //$NON-NLS-1$
            jcbCLOAK.addItem(Language.getString("ShipGUI.4")); //$NON-NLS-1$
            jcbCLOAK.addItem(Language.getString("ShipGUI.5")); //$NON-NLS-1$
            jcbCLOAK.addItem(Language.getString("ShipGUI.6")); //$NON-NLS-1$
            jcbCLOAK.addItem(Language.getString("ShipGUI.7")); //$NON-NLS-1$
            jcbCLOAK.addItem(Language.getString("ShipGUI.8")); //$NON-NLS-1$
            jcbCLOAK.addItem(Language.getString("ShipGUI.9")); //$NON-NLS-1$
        } catch (Exception et) {
            UE.displayError(et);
            return;
        }
        jcbCLOAK.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0 || jcbCLOAK.getSelectedIndex() < 0) {
                    return;
                }
                try {
                    SHIP.setCloak(SELECTED, jcbCLOAK.getSelectedIndex());
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });
        //place
        GridBagConstraints c = new GridBagConstraints();
        c.insets = new Insets(5, 5, 5, 5);
        c.fill = GridBagConstraints.BOTH;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.gridx = 0;
        c.gridy = 0;
        lbl = new JLabel(Language.getString("ShipGUI.50")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE.add(lbl, c);
        c.gridx = 1;
        pnlONE.add(txtNAME, c);
        c.gridx = 0;
        c.gridy = 1;
        lbl = new JLabel(Language.getString("ShipGUI.10")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE.add(lbl, c);
        c.gridx = 1;
        pnlONE.add(txtCLASS, c);
        c.gridx = 0;
        c.gridy = 2;
        pnlONE.add(lblPIC, c);
        c.gridheight = 2;
        c.gridx = 1;
        JScrollPane jpdesc = new JScrollPane(txtDESC);
        pnlONE.add(jpdesc, c);
        c.gridy = 3;
        c.gridx = 0;
        c.gridheight = 1;
        pnlONE.add(jcbPIC, c);
        ////
        c.gridwidth = 1;
        c.gridheight = 1;
        c.gridx = 0;
        c.gridy = 0;
        lbl = new JLabel(Language.getString("ShipGUI.11")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE_1.add(lbl, c);
        c.gridy = 1;
        lbl = new JLabel(Language.getString("ShipGUI.12")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE_1.add(lbl, c);
        c.gridy = 2;
        lbl = new JLabel(Language.getString("ShipGUI.13")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE_1.add(lbl, c);
        c.gridy = 3;
        lbl = new JLabel(Language.getString("ShipGUI.14")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE_1.add(lbl, c);
        c.gridy = 4;
        lbl = new JLabel(Language.getString("ShipGUI.15")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE_1.add(lbl, c);
        c.gridy = 0;
        c.gridx = 1;
        pnlONE_1.add(jcbFUNC, c);
        c.gridy = 1;
        pnlONE_1.add(jcbSHIP_NAME, c);
        c.gridy = 2;
        pnlONE_1.add(jcbMAP_RANGE, c);
        c.gridy = 3;
        pnlONE_1.add(txtMAP_SPEED, c);
        c.gridy = 4;
        pnlONE_1.add(txtSCN_RANGE, c);
        c.gridx = 3;
        c.gridy = 0;
        lbl = new JLabel(Language.getString("ShipGUI.16")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE_1.add(lbl, c);
        c.gridy = 1;
        lbl = new JLabel(Language.getString("ShipGUI.17")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE_1.add(lbl, c);
        c.gridy = 2;
        lbl = new JLabel(Language.getString("ShipGUI.18")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE_1.add(lbl, c);
        c.gridy = 3;
        lbl = new JLabel(Language.getString("ShipGUI.19")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE_1.add(lbl, c);
        c.gridy = 4;
        lbl = new JLabel(Language.getString("ShipGUI.20")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlONE_1.add(lbl, c);
        ////////////////////////////////////
        c.gridy = 0;
        c.gridx = 4;
        pnlONE_1.add(jcbRACE, c);
        c.gridy = 1;
        pnlONE_1.add(txtBLD_COST, c);
        c.gridy = 2;
        pnlONE_1.add(txtMAIN_COST, c);
        c.gridy = 3;
        pnlONE_1.add(jcbCLOAK, c);
        c.gridy = 4;
        pnlONE_1.add(txtPROD, c);
        ////
        c.gridy = 4;
        c.gridx = 0;
        c.gridheight = 1;
        c.gridwidth = 2;
        pnlONE.add(pnlONE_1, c);
        /*TWO*/
        //create
        JPanel pnlTWO = new JPanel(new GridBagLayout());
        txtBEAM_ACCU = new JTextField(8);
        txtBEAM_NUM = new JTextField(8);
        txtBEAM_MLT = new JTextField(8);
        txtBEAM_DAM = new JTextField(8);
        txtBEAM_MLT = new JTextField(8);
        txtBEAM_MIN = new JTextField(8);
        txtBEAM_MAX = new JTextField(8);
        txtTORP_ACCU = new JTextField(8);
        txtTORP_NUM = new JTextField(8);
        txtTORP_MLT = new JTextField(8);
        txtTORP_DAM = new JTextField(8);
        txtTORP_MLT = new JTextField(8);
        txtTORP_MIN = new JTextField(8);
        txtTORP_MAX = new JTextField(8);
        txtSHLD_PEN = new JTextField(8);
        txtSHLD_LVL = new JTextField(8);
        txtSHLD_STR = new JTextField(8);
        txtSHLD_REC = new JTextField(8);
        txtHULL_STR = new JTextField(8);
        txtDEFENSE = new JTextField(8);
        txtAGILITY = new JTextField(8);
        chkPHASER_HOB_MOD = new JCheckBox();
        cmbPHASER_HOB = new JComboBox();
        chkTORPEDO_HOB_MOD = new JCheckBox();
        cmbTORPEDO_HOB = new JComboBox();
        //setup
        if (trek == null)
        {
            chkPHASER_HOB_MOD.setSelected(false);
            chkPHASER_HOB_MOD.setEnabled(false);
            cmbPHASER_HOB.setEnabled(false);
            chkTORPEDO_HOB_MOD.setSelected(false);
            chkTORPEDO_HOB_MOD.setEnabled(false);
            cmbTORPEDO_HOB.setEnabled(false);
        }
        else
        {
            try
            {
                SelectPhaserHobFile sphf =
                        (SelectPhaserHobFile) trek.getInternalFile(Trek.fileSELECTPHASERHOBFILE, true);

                chkPHASER_HOB_MOD.setSelected(sphf.isPatched());
                cmbPHASER_HOB.setEnabled(sphf.isPatched());

                chkPHASER_HOB_MOD.addActionListener(new ActionListener()
                {
                    @Override
                    public void actionPerformed(ActionEvent e)
                    {
                        try
                        {
                            SelectPhaserHobFile sphf =
                                    (SelectPhaserHobFile) TREK.getInternalFile(Trek.fileSELECTPHASERHOBFILE, true);

                            String msg = "%1 custom phaser hob selection for all ships?";

                            msg = msg.replace("%1", (sphf.isPatched()) ? "Disable" : "Enable");

                            int ans = JOptionPane.showConfirmDialog(null, msg, UE.APP_NAME, JOptionPane.YES_NO_OPTION);

                            if (ans == JOptionPane.YES_OPTION)
                            {
                                sphf.setPatched(!sphf.isPatched());

                                if (sphf.isPatched())
                                {
                                    try
                                    {
                                        // fix prefixes
                                        EmpireImgPrefixes prefixes = (EmpireImgPrefixes)TREK.getInternalFile(Trek.fileEMPIRE_IMAGE_PREFIXES, false);

                                        int r;

                                        for (int i = 0; i < SHIP.getNumberOfEntries(); i++)
                                        {
                                            r = SHIP.getRace(i);

                                            if (r < 5)
                                            {
                                                SHIP.setPhaserPrefix(i, prefixes.getEmpirePrefix(r));
                                            }
                                            else
                                            {
                                                SHIP.setPhaserPrefix(i, 'M');
                                            }
                                        }
                                        cmbPHASER_HOB.setEnabled(true);
                                        cmbPHASER_HOB.setSelectedItem(new ID(null,
                                                Character.toLowerCase(SHIP.getPhaserPrefix(SELECTED))));
                                    }
                                    catch (Exception ex)
                                    {
                                        UE.displayError(ex);
                                    }
                                }
                            }

                            chkPHASER_HOB_MOD.setEnabled(false);
                            chkPHASER_HOB_MOD.setSelected(sphf.isPatched());
                            cmbPHASER_HOB.setEnabled(sphf.isPatched());
                            chkPHASER_HOB_MOD.setEnabled(true);
                        }
                        catch (FileNotFoundException ex)
                        {
                            UE.displayError(ex);
                        }
                    }
                });

                ArrayList<String> files = STBOF.getFileList(new FilenameFilter()
                {
                    @Override
                    public boolean accept(File dir, String name)
                    {
                        return (name.length() == 11 &&
                                name.toLowerCase().endsWith("phaser.hob"));
                    }
                });

                for (int i = 0; i < files.size(); i++)
                {
                    cmbPHASER_HOB.addItem(new ID(files.get(i), files.get(i).charAt(0)));
                }

                cmbPHASER_HOB.addItemListener(new ItemListener()
                {
                    @Override
                    public void itemStateChanged(ItemEvent e)
                    {
                        if (SELECTED < 0 || cmbPHASER_HOB.getSelectedIndex() < 0)
                        {
                            return;
                        }

                        try
                        {
                            SHIP.setPhaserPrefix(SELECTED, (char)cmbPHASER_HOB.getSelectedItem().hashCode());
                        } catch (Exception ex) {
                            UE.displayError(ex);
                        }
                    }
                });
            }
            catch (FileNotFoundException ex)
            {
                chkPHASER_HOB_MOD.setSelected(false);
                chkPHASER_HOB_MOD.setEnabled(false);
                cmbPHASER_HOB.setEnabled(false);
                UE.displayError(ex);
            }
            try
            {
                SelectTorpedoHobFile sthf =
                        (SelectTorpedoHobFile) trek.getInternalFile(Trek.fileSELECTTORPEDOHOBFILE, true);

                chkTORPEDO_HOB_MOD.setSelected(sthf.isPatched());
                cmbTORPEDO_HOB.setEnabled(sthf.isPatched());

                chkTORPEDO_HOB_MOD.addActionListener(new ActionListener()
                {
                    @Override
                    public void actionPerformed(ActionEvent e)
                    {
                        try
                        {
                            SelectTorpedoHobFile sthf =
                                    (SelectTorpedoHobFile) TREK.getInternalFile(Trek.fileSELECTTORPEDOHOBFILE, true);

                            String msg = "%1 custom torpedo hob selection for all ships?";

                            msg = msg.replace("%1", (sthf.isPatched()) ? "Disable" : "Enable");

                            int ans = JOptionPane.showConfirmDialog(null, msg, UE.APP_NAME, JOptionPane.YES_NO_OPTION);

                            if (ans == JOptionPane.YES_OPTION)
                            {
                                sthf.setPatched(!sthf.isPatched());

                                if (sthf.isPatched())
                                {
                                    try
                                    {
                                        // fix prefixes
                                        EmpireImgPrefixes prefixes = (EmpireImgPrefixes)TREK.getInternalFile(Trek.fileEMPIRE_IMAGE_PREFIXES, false);

                                        int r;

                                        for (int i = 0; i < SHIP.getNumberOfEntries(); i++)
                                        {
                                            r = SHIP.getRace(i);

                                            if (r < 5)
                                            {
                                                SHIP.setTorpedoPrefix(i, prefixes.getEmpirePrefix(r));
                                            }
                                            else
                                            {
                                                SHIP.setTorpedoPrefix(i, 'M');
                                            }
                                        }

                                        cmbTORPEDO_HOB.setEnabled(true);
                                        cmbTORPEDO_HOB.setSelectedItem(new ID(null,
                                                Character.toLowerCase(SHIP.getTorpedoPrefix(SELECTED))));
                                    }
                                    catch (Exception ex)
                                    {
                                        UE.displayError(ex);
                                    }
                                }
                            }

                            chkTORPEDO_HOB_MOD.setEnabled(false);
                            chkTORPEDO_HOB_MOD.setSelected(sthf.isPatched());
                            cmbTORPEDO_HOB.setEnabled(sthf.isPatched());
                            chkTORPEDO_HOB_MOD.setEnabled(true);
                        }
                        catch (FileNotFoundException ex)
                        {
                            UE.displayError(ex);
                        }
                    }
                });

                ArrayList<String> files = STBOF.getFileList(new FilenameFilter()
                {
                    @Override
                    public boolean accept(File dir, String name)
                    {
                        return (name.length() == 11 &&
                                name.toLowerCase().endsWith("photon.hob"));
                    }
                });

                for (int i = 0; i < files.size(); i++)
                {
                    cmbTORPEDO_HOB.addItem(new ID(files.get(i), files.get(i).charAt(0)));
                }

                cmbTORPEDO_HOB.addItemListener(new ItemListener()
                {
                    @Override
                    public void itemStateChanged(ItemEvent e)
                    {
                        if (SELECTED < 0 || cmbTORPEDO_HOB.getSelectedIndex() < 0)
                        {
                            return;
                        }

                        try
                        {
                            SHIP.setTorpedoPrefix(SELECTED,
                                    (char)cmbTORPEDO_HOB.getSelectedItem().hashCode());
                        } catch (Exception ex) {
                            UE.displayError(ex);
                        }
                    }
                });
            }
            catch (FileNotFoundException ex)
            {
                chkTORPEDO_HOB_MOD.setSelected(false);
                chkTORPEDO_HOB_MOD.setEnabled(false);
                cmbTORPEDO_HOB.setEnabled(false);
                UE.displayError(ex);
            }
        }

        //place
        c.insets = new Insets(5, 5, 5, 5);
        c.fill = GridBagConstraints.BOTH;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.gridx = 0;
        c.gridy = 0;
        lbl = new JLabel(Language.getString("ShipGUI.21")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 1;
        lbl = new JLabel(Language.getString("ShipGUI.22")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 2;
        lbl = new JLabel(Language.getString("ShipGUI.23")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 3;
        lbl = new JLabel(Language.getString("ShipGUI.24")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 4;
        lbl = new JLabel(Language.getString("ShipGUI.25")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 5;
        lbl = new JLabel(Language.getString("ShipGUI.26")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 6;
        lbl = new JLabel("Phaser hob:");
        pnlTWO.add(lbl, c);
        c.gridy = 7;
        lbl = new JLabel(" "); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 8;
        lbl = new JLabel(Language.getString("ShipGUI.27")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 9;
        lbl = new JLabel(Language.getString("ShipGUI.28")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 10;
        lbl = new JLabel(Language.getString("ShipGUI.29")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 11;
        lbl = new JLabel(Language.getString("ShipGUI.30")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 12;
        lbl = new JLabel(Language.getString("ShipGUI.31")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        ////////////////////////////////////////
        c.gridx = 1;
        c.gridy = 0;
        pnlTWO.add(txtBEAM_ACCU, c);
        c.gridy = 1;
        pnlTWO.add(txtBEAM_NUM, c);
        c.gridy = 2;
        pnlTWO.add(txtBEAM_MLT, c);
        c.gridy = 3;
        pnlTWO.add(txtBEAM_DAM, c);
        c.gridy = 4;
        pnlTWO.add(txtBEAM_MIN, c);
        c.gridy = 5;
        pnlTWO.add(txtBEAM_MAX, c);
        c.gridy = 6;
        pnlTWO.add(cmbPHASER_HOB, c);
        c.gridy = 8;
        pnlTWO.add(txtSHLD_PEN, c);
        c.gridy = 9;
        pnlTWO.add(txtSHLD_LVL, c);
        c.gridy = 10;
        pnlTWO.add(txtSHLD_REC, c);
        c.gridy = 11;
        pnlTWO.add(txtSHLD_STR, c);
        c.gridy = 12;
        pnlTWO.add(txtHULL_STR, c);
        //////////////////////////////////////
        c.gridx = 2;
        c.gridy = 6;
        pnlTWO.add(chkPHASER_HOB_MOD, c);
        //////////////////////////////////////
        c.gridx = 3;
        c.gridy = 0;
        lbl = new JLabel(Language.getString("ShipGUI.32")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 1;
        lbl = new JLabel(Language.getString("ShipGUI.33")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 2;
        lbl = new JLabel(Language.getString("ShipGUI.34")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 3;
        lbl = new JLabel(Language.getString("ShipGUI.35")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 4;
        lbl = new JLabel(Language.getString("ShipGUI.36")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 5;
        lbl = new JLabel(Language.getString("ShipGUI.37")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 6;
        lbl = new JLabel("Torpedo hob:");
        pnlTWO.add(lbl, c);
        c.gridy = 8;
        lbl = new JLabel(Language.getString("ShipGUI.38")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        c.gridy = 9;
        lbl = new JLabel(Language.getString("ShipGUI.39")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTWO.add(lbl, c);
        /////////////////////////////////////////////
        c.gridx = 4;
        c.gridy = 0;
        pnlTWO.add(txtTORP_ACCU, c);
        c.gridy = 1;
        pnlTWO.add(txtTORP_NUM, c);
        c.gridy = 2;
        pnlTWO.add(txtTORP_MLT, c);
        c.gridy = 3;
        pnlTWO.add(txtTORP_DAM, c);
        c.gridy = 4;
        pnlTWO.add(txtTORP_MIN, c);
        c.gridy = 5;
        pnlTWO.add(txtTORP_MAX, c);
        c.gridy = 6;
        pnlTWO.add(cmbTORPEDO_HOB, c);
        c.gridy = 8;
        pnlTWO.add(txtDEFENSE, c);
        c.gridy = 9;
        pnlTWO.add(txtAGILITY, c);
        //////////////////////////////////////
        c.gridx = 5;
        c.gridy = 6;
        pnlTWO.add(chkTORPEDO_HOB_MOD, c);
        /*THREE*/
        //create
        JPanel pnlTHR = new JPanel(new GridBagLayout());
        chkSPECIAL = new JCheckBox();
        chkSPECIAL.setFont(def);
        chkSPECIAL.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae) {
                try {
                    if (SPECIAL.contains(SELECTED)) {
                        SPECIAL.remove(SELECTED);
                    } else {
                        SPECIAL.add(SELECTED);
                    }

                    if (SP != null) {
                        SP.setShipIDs(SPECIAL);

                        chkSPECIAL.setText(strSP_TOTAL.replace("%1", Integer.toString(SPECIAL.size()))); //$NON-NLS-1$
                    }
                } catch (Exception e) {
                    UE.displayError(e);
                }
            }
        });
        chkSCREENSAVER = new JCheckBox();
        chkSCREENSAVER.setFont(def);
        chkSCREENSAVER.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae) {
                try {
                    if (TREK == null) {
                        return;
                    }

                    ScreensaverModelList sml = (ScreensaverModelList) TREK.getInternalFile(Trek.fileSCREENSAVER_MODEL_LIST, true);

                    String m = SHIP.getImageName(SELECTED).toLowerCase() + ".hob"; //$NON-NLS-1$

                    if (SCREENSAVER.contains(m)) {
                        SCREENSAVER.remove(m);
                    } else {
                        if (sml.getMax() <= SCREENSAVER.size()) {
                            return;
                        }
                        SCREENSAVER.add(m);
                    }

                    String[] t = SCREENSAVER.toArray(new String[0]);

                    for (String s : t) {
                        if (SHIP.getFirstIDWithPrefix(s.substring(0, s.length() - 4)) < 0) {
                            SCREENSAVER.remove(s);
                        }
                    }

                    sml.set(SCREENSAVER.toArray(new String[0]));
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });
        jcbRACE_OVR = new JComboBox();
        jcbRACE_OVR.setFont(def);
        jcbRACE_OVR.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0 || jcbRACE_OVR.getSelectedIndex() < 0) {
                    return;
                }
                try {
                    short huh = (short) jcbRACE_OVR.getSelectedIndex();
                    if (huh >= 35) {
                        huh = 36; //36 stands for aliens, 35 seems not to be a valid value
                    }
                    SHIP.setRaceOverride(SELECTED, huh);
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });
        jcbPARENT = new JComboBox();
        lblPRNT_TECH = new JLabel[12];
        txtTEC_REQ = new JTextField[6];
        lblPARREQ = new JLabel();
        //setup
        lblPARREQ.setFont(def);
        jcbPARENT.setFont(def);
        jcbPARENT.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0 || jcbPARENT.getSelectedIndex() < 0) {
                    return;
                }
                try {
                    ID h = (ID) jcbPARENT.getSelectedItem();
                    SHIPTECH.setParent(SELECTED, (short) h.hashCode());
                    if (h.hashCode() >= 0) {
                        lblPARREQ.setText(strUPGRADE.replace("%1", SHIP.getName(h.hashCode()))); //$NON-NLS-1$
                        byte[] rot = SHIPTECH.getTechLvls(h.hashCode());
                        for (int gut = 0; gut < 6; gut++) {
                            lblPRNT_TECH[6 + gut].setText(Byte.toString(rot[gut]));
                        }
                    } else {
                        lblPARREQ.setText(strUPGRADE.replace("%1", Language.getString("ShipGUI.40"))); //$NON-NLS-1$ //$NON-NLS-2$
                        for (int gut = 0; gut < 6; gut++) {
                            lblPRNT_TECH[6 + gut].setText("/"); //$NON-NLS-1$
                        }
                    }
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });
        String[] str = TECH.getFields();
        for (int i = 0; i < 12; i++) {
            lblPRNT_TECH[i] = new JLabel();
            if (i < 6) {
                lblPRNT_TECH[i].setText(str[i] + ":"); //$NON-NLS-1$
                txtTEC_REQ[i] = new JTextField(5);
                txtTEC_REQ[i].setFont(def);
            }
            lblPRNT_TECH[i].setFont(def);
        }
        //place
        c.insets = new Insets(5, 5, 5, 5);
        c.fill = GridBagConstraints.BOTH;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.gridx = 0;
        c.gridy = 0;
        lblSPECIAL = new JLabel(Language.getString("ShipGUI.41")); //$NON-NLS-1$
        lblSPECIAL.setFont(def);
        pnlTHR.add(lblSPECIAL, c);
        c.gridy = 1;
        lbl = new JLabel(Language.getString("ShipGUI.42")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTHR.add(lbl, c);
        c.gridy = 2;
        lbl = new JLabel(" "); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTHR.add(lbl, c);
        c.gridy = 3;
        c.gridwidth = 4;
        lbl = new JLabel(Language.getString("ShipGUI.43")); //$NON-NLS-1$
        c.gridwidth = 1;
        lbl.setFont(def);
        pnlTHR.add(lbl, c);
        for (int i = 0; i < 3; i++) {
            c.gridy = 4 + i;
            lbl = new JLabel(str[i] + ":"); //$NON-NLS-1$
            lbl.setFont(def);
            pnlTHR.add(lbl, c);
            c.gridy = 9 + i;
            pnlTHR.add(lblPRNT_TECH[i], c);
        }
        c.gridy = 7;
        lbl = new JLabel(" "); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTHR.add(lbl, c);
        c.gridy = 8;
        c.gridwidth = 4;
        pnlTHR.add(lblPARREQ, c);
        c.gridwidth = 1;
        c.gridx = 1;
        c.gridy = 0;
        pnlTHR.add(chkSPECIAL, c);
        c.gridy = 1;
        pnlTHR.add(jcbPARENT, c);
        for (int i = 0; i < 3; i++) {
            c.gridy = 4 + i;
            pnlTHR.add(txtTEC_REQ[i], c);
            c.gridy = 9 + i;
            pnlTHR.add(lblPRNT_TECH[i + 6], c);
        }

        c.gridx = 2;
        c.gridy = 0;
        lbl = new JLabel(Language.getString("ShipGUI.55")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTHR.add(lbl, c);
        c.gridx = 2;
        c.gridy = 1;
        lbl = new JLabel(Language.getString("ShipGUI.51")); //$NON-NLS-1$
        lbl.setFont(def);
        pnlTHR.add(lbl, c);

        for (int i = 3; i < 6; i++) {
            c.gridy = i + 1;
            lbl = new JLabel(str[i] + ":"); //$NON-NLS-1$
            lbl.setFont(def);
            pnlTHR.add(lbl, c);
            c.gridy = 6 + i;
            pnlTHR.add(lblPRNT_TECH[i], c);
        }

        c.gridx = 3;
        c.gridy = 0;
        pnlTHR.add(chkSCREENSAVER, c);
        c.gridx = 3;
        c.gridy = 1;
        pnlTHR.add(jcbRACE_OVR, c);

        for (int i = 3; i < 6; i++) {
            c.gridy = i + 1;
            pnlTHR.add(txtTEC_REQ[i], c);
            c.gridy = 6 + i;
            pnlTHR.add(lblPRNT_TECH[i + 6], c);
        }

        /*SETUP CARD PANEL*/
        pnlCARD = new JPanel();
        layCARD = new CardLayout();
        pnlCARD.setLayout(layCARD);
        pnlCARD.add(pnlONE, "1"); //$NON-NLS-1$
        pnlCARD.add(pnlTWO, "2"); //$NON-NLS-1$
        pnlCARD.add(pnlTHR, "3"); //$NON-NLS-1$
        pnlCARD.setBorder(new LineBorder(Color.BLACK));
        /*OTHER STUFF*/
        //ship combo
        jcbSHIP = new JComboBox();
        try {
            for (int i = 0; i < RACE.getNumberOfEntries(); i++) {
                ID id = new ID(RACE.getName(i), i);
                jcbSHIP.addItem(id);
                jcbRACE.addItem(id);
                jcbRACE_OVR.addItem(id);
            }
            jcbSHIP.addItem(new ID(Language.getString("ShipGUI.44"), -1)); //$NON-NLS-1$
            jcbSHIP.addItem(new ID(Language.getString("ShipGUI.45"), -2)); //$NON-NLS-1$
            jcbRACE.addItem(new ID(Language.getString("ShipGUI.45"), -2)); //$NON-NLS-1$
            jcbRACE_OVR.addItem(new ID(Language.getString("ShipGUI.45"), -2)); //$NON-NLS-1$
        } catch (Exception ex) {
            UE.displayError(ex);
            return;
        }
        jcbSHIP.setFont(def);
        jcbSHIP.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae)
            {
                try
                {
                    finalWarning();
                }
                catch (Exception ex)
                {
                    // really bad stuff happening - bail
                    UE.displayError(ex);
                    return;
                }

                fillList();
            }
        });
        //ship list
        lstSHIP = new JList();
        lstSHIP.setFont(def);
        lstSHIP.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        lstSHIP.addListSelectionListener(new ListSelectionListener()
        {
            @Override
            public void valueChanged(ListSelectionEvent e) {
                if (PAUSE) {
                    return;
                }
                // save changes
                try
                {
                    finalWarning();
                }
                catch (Exception ex)
                {
                    // really bad stuff happening - bail
                    UE.displayError(ex);
                    return;
                }

                if (lstSHIP.getSelectedIndex() < 0) {
                    return;
                }
                ID hm = (ID) lstSHIP.getSelectedValue();
                SELECTED = hm.hashCode();
                //description, name, class
                try {
                    txtDESC.setText(DESC.getDesc((short) SELECTED));
                    txtNAME.setText(SHIP.getName(SELECTED));
                    txtCLASS.setText(SHIP.getClass(SELECTED));
                    String pic = "i_" + SHIP.getImageName(SELECTED) + "120.tga"; //$NON-NLS-1$ //$NON-NLS-2$
                    jcbPIC.setSelectedItem(pic);
                    if (!jcbPIC.getSelectedItem().equals(pic)) {
                        UE.displayError(new IOException(Language.getString("ShipGUI.54").replace("%1", pic))); //$NON-NLS-1$ //$NON-NLS-2$
                    }
                    jcbFUNC.setSelectedIndex(SHIP.getFunction(SELECTED));
                    jcbSHIP_NAME.setSelectedIndex(SHIP.getNameGroup(SELECTED));
                    jcbMAP_RANGE.setSelectedItem(new ID("", (int) SHIP.getMapRange(SELECTED))); //$NON-NLS-1$
                    txtMAP_SPEED.setText(Short.toString((short) SHIP.getMapSpeed(SELECTED)));
                    txtSCN_RANGE.setText(Integer.toString(SHIP.getScanRange(SELECTED) + 1));
                    int t = SHIP.getRace(SELECTED);
                    if (t < 35) {
                        jcbRACE.setSelectedIndex(t);
                    } else {
                        jcbRACE.setSelectedIndex(35);
                    }
                    t = SHIP.getRaceOverride(SELECTED);
                    if (t < 35) {
                        jcbRACE_OVR.setSelectedIndex(t);
                    } else {
                        jcbRACE_OVR.setSelectedIndex(35);
                    }
                    txtBLD_COST.setText(Integer.toString(SHIP.getBuildCost(SELECTED)));
                    txtMAIN_COST.setText(Integer.toString(SHIP.getMaintenance(SELECTED)));
                    jcbCLOAK.setSelectedIndex(SHIP.getCloak(SELECTED));
                    txtBEAM_ACCU.setText(Integer.toString(SHIP.getBeamAccu(SELECTED)));
                    txtBEAM_NUM.setText(Integer.toString(SHIP.getBeamNum(SELECTED)));
                    txtBEAM_MLT.setText(Integer.toString(SHIP.getBeamMulti(SELECTED)));
                    txtBEAM_DAM.setText(Integer.toString(SHIP.getBeamDamage(SELECTED)));
                    txtBEAM_MIN.setText(Double.toString(SHIP.getBeamMin(SELECTED)));
                    txtBEAM_MAX.setText(Double.toString(SHIP.getBeamMax(SELECTED)));
                    txtTORP_ACCU.setText(Integer.toString(SHIP.getTorpAccu(SELECTED)));
                    txtTORP_NUM.setText(Integer.toString(SHIP.getTorpNum(SELECTED)));
                    txtTORP_MLT.setText(Integer.toString(SHIP.getTorpMulti(SELECTED)));
                    txtTORP_DAM.setText(Integer.toString(SHIP.getTorpDamage(SELECTED)));
                    txtTORP_MIN.setText(Double.toString(SHIP.getTorpMin(SELECTED)));
                    txtTORP_MAX.setText(Double.toString(SHIP.getTorpMax(SELECTED)));
                    txtSHLD_PEN.setText(Integer.toString(SHIP.getShieldPen(SELECTED)));
                    txtSHLD_LVL.setText(Integer.toString(SHIP.getShieldLvl(SELECTED)));
                    txtSHLD_STR.setText(Integer.toString(SHIP.getShieldStr(SELECTED)));
                    txtSHLD_REC.setText(Integer.toString(SHIP.getShieldRec(SELECTED)));
                    txtHULL_STR.setText(Integer.toString(SHIP.getHullStr(SELECTED)));
                    txtDEFENSE.setText(Integer.toString(SHIP.getDefense(SELECTED)));
                    txtPROD.setText(Integer.toString(SHIP.getProduction(SELECTED)));

                    lblDESCBOT.setText(jcbRACE.getSelectedItem() + ": " + SHIP.getName(SELECTED) + ": " + SELECTED); //$NON-NLS-1$ //$NON-NLS-2$
                    if (SPECIAL.contains(SELECTED)) {
                        lblDESCBOT.setText(lblDESCBOT.getText() + ", " + Language.getString("ShipGUI.46"));             //$NON-NLS-1$ //$NON-NLS-2$
                    }

                    byte[] hah = SHIPTECH.getTechLvls(SELECTED);
                    for (int g = 0; g < 6; g++) {
                        txtTEC_REQ[g].setText(Byte.toString(hah[g]));
                    }
                    txtAGILITY.setText(Double.toString(SHIP.getAgility(SELECTED)));

                    chkSCREENSAVER.setSelected(SCREENSAVER.contains(SHIP.getImageName(SELECTED).toLowerCase() + ".hob")); //$NON-NLS-1$
                    chkSCREENSAVER.setEnabled(TREK != null && (SCREENSAVER.size() < MAX_SCREENSAVER || chkSCREENSAVER.isSelected()));

                    btnNEW.setEnabled(SHIP.getNumberOfEntries() < 264 && SHIP.getRace(SELECTED) != 36 && TREK != null);
                    btnRM.setEnabled(SHIP.getNumberOfEntries() > 15 && SHIP.getRace(SELECTED) != 36 && TREK != null);
                    btnMUP.setEnabled(SHIP.getRace(SELECTED) != 36);
                    btnMDN.setEnabled(SHIP.getRace(SELECTED) != 36);

                    if (SHIP.getRace(SELECTED) != 36) {
                        chkSPECIAL.setSelected(SPECIAL.contains(SELECTED));
                        chkSPECIAL.setEnabled((SP != null && SPECIAL.size() < SP.getSPIdSlotsNumber()) || SPECIAL.contains(SELECTED));

                        if (SP == null) {
                            chkSPECIAL.setText(strSP_TOTAL.replace("%1", "?")); //$NON-NLS-1$ //$NON-NLS-2$
                        } else {
                            chkSPECIAL.setText(strSP_TOTAL.replace("%1", Integer.toString(SPECIAL.size()))); //$NON-NLS-1$
                        }//                                lblSPECIAL.setText(Language.getString("ShipGUI.41")); //$NON-NLS-1$
                    } else {
                        chkSPECIAL.setEnabled(false);
                        chkSPECIAL.setSelected(false);
                    }

                    cmbPHASER_HOB.setSelectedItem(
                            new ID(null, Character.toLowerCase(SHIP.getPhaserPrefix(SELECTED))));
                    cmbTORPEDO_HOB.setSelectedItem(
                            new ID(null, Character.toLowerCase(SHIP.getTorpedoPrefix(SELECTED))));
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
                fillList(); // this is because fillList fills the parent list
            }
        });
        //UP DOWN
        btnMUP = new JButton(Language.getString("ShipGUI.47")); //$NON-NLS-1$
        btnMDN = new JButton(Language.getString("ShipGUI.48")); //$NON-NLS-1$
        btnMUP.setFont(def);
        btnMDN.setFont(def);
        btnMUP.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0) {
                    return;
                }
                try {
                    int[] id2 = SHIP.moveUp(SELECTED);
                    int h = -1;
                    for (int i = 0; i < id2.length && h == -1; i++) {
                        if (id2[i] == SELECTED) {
                            h = i;
                        }
                    }
                    SELECTED = h;
                    SHIPTECH.reOrder(id2);
                    int[] id = SHIP.getStartingIDs();
                    SHIPRACE.setShipStarts(id);
                    DESC.reset();
                    for (int i = 0; i < SHIP.getNumberOfEntries(); i++) {
                        try {
                            DESC.setIndex(SHIP.getDescAddress(i), i);
                        } catch (Exception e) {
                            UE.displayError(e);
                        }
                    }
                    chkSPECIAL.setSelected(SPECIAL.contains(SELECTED));
                    fillList();
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });
        btnMDN.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0) {
                    return;
                }
                try {
                    int[] id2 = SHIP.moveDown(SELECTED);
                    int h = -1;
                    for (int i = 0; i < id2.length && h == -1; i++) {
                        if (id2[i] == SELECTED) {
                            h = i;
                        }
                    }
                    SELECTED = h;
                    SHIPTECH.reOrder(id2);
                    int[] id = SHIP.getStartingIDs();
                    SHIPRACE.setShipStarts(id);
                    DESC.reset();
                    for (int i = 0; i < SHIP.getNumberOfEntries(); i++) {
                        try {
                            DESC.setIndex(SHIP.getDescAddress(i), i);
                        } catch (Exception e) {
                            UE.displayError(e);
                        }
                    }
                    chkSPECIAL.setSelected(SPECIAL.contains(SELECTED));
                    fillList();
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });
        // ADD NEW SHIP
        btnNEW = new JButton(Language.getString("ShipGUI.49")); //$NON-NLS-1$
        btnNEW.setFont(def);
        btnNEW.setEnabled(TREK != null); // this function does not work without modifying trek.exe
        btnNEW.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0) {
                    return;
                }
                try {
                    if (SHIP.getRace(SELECTED) > 34) {
                        return;
                    }
                    int address = DESC.add();

                    SHIPTECH.insert(SELECTED);
                    SHIP.createShip(SELECTED, address);

                    int[] id = SHIP.getStartingIDs();
                    SHIPRACE.setShipStarts(id);

                    DESC.reset();
                    for (int i = 0; i < SHIP.getNumberOfEntries(); i++) {
                        try {
                            DESC.setIndex(SHIP.getDescAddress(i), i);
                        } catch (Exception e) {
                            UE.displayError(e);
                        }
                    }
                    // now set shipnum and aliens in trek.exe
                    Shipnum sh = (Shipnum) TREK.getInternalFile("shipnum1", true); //$NON-NLS-1$
                    sh.setNum((short) SHIP.getNumberOfEntries());
                    sh = (Shipnum) TREK.getInternalFile("shipnum2", true); //$NON-NLS-1$
                    sh.setNum((short) SHIP.getNumberOfEntries());
                    ShipLoadLimit sll = (ShipLoadLimit) TREK.getInternalFile(Trek.fileSHIP_LOAD_LIMIT1, true);
                    sll.setID(SHIP.getNumberOfEntries());
                    sll = (ShipLoadLimit) TREK.getInternalFile(Trek.fileSHIP_LOAD_LIMIT2, true);
                    sll.setID(SHIP.getNumberOfEntries());
                    // set aliens in trek.exe
                    Alien an;
                    short fid = (short) SHIP.getIDs(36)[0].hashCode();
                    short mid = fid;

                    for (int i = 1; i <= 9; i++) {
                        try {
                            if (i == 9) {
                                mid++;
                            }

                            an = (Alien) TREK.getInternalFile("alien" + i, true); //$NON-NLS-1$
                            an.setIndex(mid++);
                        } catch (FileNotFoundException e) {
                            // ignore
                            mid++;
                        }
                    }
                    // set first alien 1-4
                    AlienStartingID sid = (AlienStartingID) TREK.getInternalFile(Trek.fileALIEN_STARTING_ID, true);
                    sid.setID(fid);
                    sid = (AlienStartingID) TREK.getInternalFile(Trek.fileALIEN_STARTING_ID2, true);
                    sid.setID(fid);
                    sid = (AlienStartingID) TREK.getInternalFile(Trek.fileALIEN_STARTING_ID3, true);
                    sid.setID(fid);
                    sid = (AlienStartingID) TREK.getInternalFile(Trek.fileALIEN_STARTING_ID4, true);
                    sid.setID(fid);

                    // reset special ships
                    Integer[] sp = new Integer[SPECIAL.size()];
                    SPECIAL.toArray(sp);
                    for (int i = 0; i < sp.length; i++) {
                        if (sp[i] > SELECTED) {
                            SPECIAL.remove(sp[i]);
                            SPECIAL.add(sp[i] + 1);
                        }
                    }

                    if (SP != null) {
                        SP.setShipIDs(SPECIAL);
                    }

                    fillList();
                    finalWarning();
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });
        // REMOVE SHIP
        btnRM = new JButton(Language.getString("ShipGUI.52")); //$NON-NLS-1$
        btnRM.setFont(def);
        btnRM.setEnabled(TREK != null); // this function does not work without modifying trek.exe
        btnRM.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent ae) {
                if (SELECTED < 0) {
                    return;
                }
                try {
                    if (SHIP.getRace(SELECTED) > 34) {
                        return;
                    }

                    SHIPTECH.remove(SELECTED);
                    SHIP.removeShip(SELECTED);

                    int[] id = SHIP.getStartingIDs();
                    SHIPRACE.setShipStarts(id);
                    DESC.remove((short) SELECTED);

                    // now update addresses
                    for (short i = 0; i < SELECTED; i++) {
                        SHIP.setDescAddress(i, DESC.getAddress(i));
                    }
                    for (short i = (short) SELECTED; i < SHIP.getNumberOfEntries(); i++) {
                        SHIP.setDescAddress(i, DESC.getAddress((short) (i + 1)));
                    }

                    DESC.reset();
                    for (int i = 0; i < SHIP.getNumberOfEntries(); i++) {
                        try {
                            DESC.setIndex(SHIP.getDescAddress(i), i);
                        } catch (Exception e) {
                            UE.displayError(e);
                        }
                    }

                    // now set shipnum and aliens in trek.exe
                    Shipnum sh = (Shipnum) TREK.getInternalFile(Trek.fileSHIPNUM1, true); //$NON-NLS-1$
                    sh.setNum((short) SHIP.getNumberOfEntries());
                    sh = (Shipnum) TREK.getInternalFile(Trek.fileSHIPNUM2, true); //$NON-NLS-1$
                    sh.setNum((short) SHIP.getNumberOfEntries());
                    ShipLoadLimit sll = (ShipLoadLimit) TREK.getInternalFile(Trek.fileSHIP_LOAD_LIMIT1, true);
                    sll.setID(SHIP.getNumberOfEntries());
                    sll = (ShipLoadLimit) TREK.getInternalFile(Trek.fileSHIP_LOAD_LIMIT2, true);
                    sll.setID(SHIP.getNumberOfEntries());

//                  set aliens in trek.exe
                    Alien an;
                    short fid = (short) SHIP.getIDs(36)[0].hashCode();
                    short mid = fid;

                    for (int i = 1; i <= 9; i++) {
                        try {
                            if (i == 9) {
                                mid++;
                            }

                            an = (Alien) TREK.getInternalFile("alien" + i, true); //$NON-NLS-1$
                            an.setIndex(mid++);
                        } catch (FileNotFoundException e) {
                            // ignore
                            mid++;
                        }
                    }
                    // set first alien 1-4
                    AlienStartingID sid = (AlienStartingID) TREK.getInternalFile(Trek.fileALIEN_STARTING_ID, true);
                    sid.setID(fid);
                    sid = (AlienStartingID) TREK.getInternalFile(Trek.fileALIEN_STARTING_ID2, true);
                    sid.setID(fid);
                    sid = (AlienStartingID) TREK.getInternalFile(Trek.fileALIEN_STARTING_ID3, true);
                    sid.setID(fid);
                    sid = (AlienStartingID) TREK.getInternalFile(Trek.fileALIEN_STARTING_ID4, true);
                    sid.setID(fid);

                    // reset special ships
                    Integer[] sp = new Integer[SPECIAL.size()];
                    if (SPECIAL.contains(SELECTED)) {
                        SPECIAL.remove(SELECTED);
                    }
                    SPECIAL.toArray(sp);
                    for (int i = 0; i < sp.length; i++) {
                        if (sp[i] > SELECTED) {
                            SPECIAL.remove(sp[i]);
                            SPECIAL.add(sp[i] - 1);
                        }
                    }

                    if (SP != null) {
                        SP.setShipIDs(SPECIAL);
                    }

                    fillList();
                    int t = SELECTED;
                    SELECTED = -1;
                    lstSHIP.clearSelection();
                    lstSHIP.setSelectedIndex(t);
                } catch (Exception ex) {
                    UE.displayError(ex);
                }
            }
        });

        /*DONE*/
        setLayout(new GridBagLayout());
        c.insets = new Insets(5, 5, 5, 5);
        c.fill = GridBagConstraints.BOTH;
        c.gridwidth = 2;
        c.gridheight = 1;
        c.gridx = 0;
        c.gridy = 0;
        // main
        JPanel pnlMain = new JPanel(new GridBagLayout());
        pnlMain.add(jcbSHIP, c);
        c.gridheight = 1;
        c.gridy = 1;
        JScrollPane jpship = new JScrollPane(lstSHIP);
        int h0 = pnlSWITCH.getPreferredSize().height;
        int h1 = pnlCARD.getPreferredSize().height;
        int h2 = btnNEW.getPreferredSize().height * 4;
        int h3 = jcbSHIP.getPreferredSize().height;
        jpship.setPreferredSize(new Dimension(150, h0 + h1 - h2 - h3 + 5 * 7));
        pnlMain.add(jpship, c);
        c.insets = new Insets(5, 5, 0, 5);
        c.gridwidth = 1;
        c.gridy = 2;
        pnlMain.add(btnMUP, c);
        c.gridx = 1;
        pnlMain.add(btnNEW, c);
        c.insets = new Insets(0, 5, 5, 5);
        c.gridx = 0;
        c.gridy = 3;
        pnlMain.add(btnMDN, c);
        c.gridx = 1;
        pnlMain.add(btnRM, c);

        c.gridwidth = 1;
        c.gridheight = 2;
        c.gridx = 0;
        c.gridy = 0;
        c.insets = new Insets(5, 5, 5, 5);
        add(pnlMain, c);
        c.gridy = 0;
        c.gridx = 1;
        c.gridheight = 1;
        add(pnlCARD, c);
        c.gridy = 1;
        add(pnlSWITCH, c);

        /*INIT*/
        jcbSHIP.setSelectedIndex(35);
        layCARD.first(pnlCARD);
    }

    private void fillList() {
        //finalWarning();
        PAUSE = true;
        int i = SELECTED;
        SELECTED = -1;
        jcbPARENT.removeAllItems();
        jcbPARENT.addItem(new ID(Language.getString("ShipGUI.40"), -1)); //$NON-NLS-1$
        if (i > -1) {
            try {
                ID[] idn = SHIP.getIDs(SHIP.getRace(i));
                for (int h = 0; h < idn.length; h++) {
                    jcbPARENT.addItem(idn[h]);
                }
                int jok = SHIPTECH.getParent(i);
                if (jok >= 0) {
                    jcbPARENT.setSelectedItem(new ID(SHIP.getName(jok), jok));
                    lblPARREQ.setText(strUPGRADE.replace("%1", SHIP.getName(jok))); //$NON-NLS-1$
                    byte[] rot = SHIPTECH.getTechLvls(jok);
                    for (int gut = 0; gut < 6; gut++) {
                        lblPRNT_TECH[6 + gut].setText(Byte.toString(rot[gut]));
                    }
                } else {
                    jcbPARENT.setSelectedIndex(0);
                    lblPARREQ.setText(strUPGRADE.replace("%1", Language.getString("ShipGUI.40"))); //$NON-NLS-1$ //$NON-NLS-2$
                    for (int gut = 0; gut < 6; gut++) {
                        lblPRNT_TECH[6 + gut].setText("/"); //$NON-NLS-1$
                    }
                }
            } catch (Exception ex) {
                UE.displayError(ex);
            }
        }
        lstSHIP.setListData(SHIP.getIDs(jcbSHIP.getSelectedIndex()));
        if (i >= 0) {
            lstSHIP.setSelectedValue(new ID("", i), true); //$NON-NLS-1$
            SELECTED = i;
            try {
                lblDESCBOT.setText(jcbRACE.getSelectedItem() + ": " + SHIP.getName(i) + ": " + i); //$NON-NLS-1$ //$NON-NLS-2$
            } catch (Exception z) {
                UE.displayError(z);
            }
            if (lstSHIP.getSelectedIndex() < 0) {
                SELECTED = -1;
                PAUSE = false;
                lstSHIP.setSelectedIndex(0);
            }
        } else {
            PAUSE = false;
            lstSHIP.setSelectedIndex(0);
        }
        PAUSE = false;
    }

    @Override
    public void finalWarning() throws Exception
    {
        if (SELECTED < 0) {
            return;
        }
        //description,name
        DESC.setDesc((short) SELECTED, txtDESC.getText());
        for (int i = 0; i < SHIP.getNumberOfEntries(); i++) {
            SHIP.setDescAddress(i, DESC.getAddress((short) i));
        }
        SHIP.setName(SELECTED, txtNAME.getText());
        SHIP.setClass(SELECTED, txtCLASS.getText());

        String str = txtMAP_SPEED.getText();
        double dk = Short.parseShort(str);
        if (dk < 0) {
            dk = -1; //infinite speed
        }
        SHIP.setMapSpeed(SELECTED, dk);

        str = txtSCN_RANGE.getText();
        int ik = Integer.parseInt(str);
        ik--;
        if (ik > 65535) {
            ik = 65535;
        }
        if (ik < 0) {
            ik = 0;
        }
        SHIP.setScanRange(SELECTED, ik);

        str = txtBLD_COST.getText();
        ik = Integer.parseInt(str);
        if (ik > 65535) {
            ik = 65535;
        }
        if (ik < 0) {
            ik = 0;
        }
        SHIP.setBuildCost(SELECTED, ik);

        str = txtMAIN_COST.getText();
        ik = Integer.parseInt(str);
        if (ik > 65535) {
            ik = 65535;
        }
        if (ik < 0) {
            ik = 0;
        }
        SHIP.setMaintenance(SELECTED, ik);

        str = txtBEAM_ACCU.getText();
        ik = Integer.parseInt(str);
        SHIP.setBeamAccu(SELECTED, ik);

        str = txtBEAM_NUM.getText();
        ik = Integer.parseInt(str);
        SHIP.setBeamNum(SELECTED, ik);

        str = txtBEAM_MLT.getText();
        ik = Integer.parseInt(str);
        SHIP.setBeamMulti(SELECTED, ik);

        str = txtBEAM_DAM.getText();
        ik = Integer.parseInt(str);
        SHIP.setBeamDamage(SELECTED, ik);

        str = txtBEAM_MIN.getText();
        dk = Double.parseDouble(str);
        SHIP.setBeamMin(SELECTED, dk);

        str = txtBEAM_MAX.getText();
        dk = Double.parseDouble(str);
        SHIP.setBeamMax(SELECTED, dk);

        str = txtTORP_ACCU.getText();
        ik = Integer.parseInt(str);
        SHIP.setTorpAccu(SELECTED, ik);

        str = txtTORP_NUM.getText();
        ik = Integer.parseInt(str);
        SHIP.setTorpNum(SELECTED, ik);

        str = txtTORP_MLT.getText();
        ik = Integer.parseInt(str);
        SHIP.setTorpMulti(SELECTED, ik);

        str = txtTORP_DAM.getText();
        ik = Integer.parseInt(str);
        SHIP.setTorpDamage(SELECTED, ik);

        str = txtTORP_MIN.getText();
        dk = Double.parseDouble(str);
        SHIP.setTorpMin(SELECTED, dk);

        str = txtTORP_MAX.getText();
        dk = Double.parseDouble(str);
        SHIP.setTorpMax(SELECTED, dk);

        str = txtSHLD_PEN.getText();
        ik = Integer.parseInt(str);
        SHIP.setShieldPen(SELECTED, ik);

        str = txtSHLD_LVL.getText();
        ik = Integer.parseInt(str);
        SHIP.setShieldLvl(SELECTED, ik);

        str = txtSHLD_STR.getText();
        ik = Integer.parseInt(str);
        SHIP.setShieldStr(SELECTED, ik);

        str = txtSHLD_REC.getText();
        ik = Integer.parseInt(str);
        SHIP.setShieldRec(SELECTED, ik);

        str = txtHULL_STR.getText();
        ik = Integer.parseInt(str);
        SHIP.setHullStr(SELECTED, ik);

        str = txtDEFENSE.getText();
        ik = Integer.parseInt(str);
        SHIP.setDefense(SELECTED, ik);

        str = txtPROD.getText();
        ik = Integer.parseInt(str);
        if (ik > 65535) {
            ik = 65535;
        }
        if (ik < 0) {
            ik = 0;
        }
        SHIP.setProduction(SELECTED, ik);

        byte[] tuna = new byte[6];
        for (int j = 0; j < 6; j++) {
            str = txtTEC_REQ[j].getText();
            tuna[j] = Byte.parseByte(str);
            if (tuna[j] < 0) {
                tuna[j] = 0;
            }
        }
        SHIPTECH.setTechLvls(SELECTED, tuna);

        str = txtAGILITY.getText();
        dk = Double.parseDouble(str);
        SHIP.setAgility(SELECTED, dk);

        // set upgrade_for, just in case the ship had an upgrade before
        // but got new owner causing the upgrade to become bogus
        ID h = (ID) jcbPARENT.getSelectedItem();
        SHIPTECH.setParent(SELECTED, (short) h.hashCode());
    }

    @Override
    public String getHelpFileName() {
        return "Ship.html"; //$NON-NLS-1$
    }
}
