/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: ShipMultiGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui.stbof;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

import ue.edit.res.*;
import ue.edit.res.stbof.sst.*;
import ue.edit.res.stbof.rst.*;
import ue.edit.res.stbof.dic.*;
import ue.gui.*;
import ue.util.SettingsManager;
import ue.*;

@SuppressWarnings("serial")  //$NON-NLS-1$
public class ShipMultiGUI extends MainPanel{
	/*DATA//DATA//DATA//DATA//DATA///**/
	private ShipList SHIP;			/**/
	private Race RACE;				/**/
	private Lexicon LEX;			/**/
	/*/GADGETS////GADGETS////GADGETS/**/
	private JTextField[] txtMUL;	/**/
	private JButton btnMUL;			/**/
	private JButton btnADD;			/**/
	private JButton btnSET;			/**/
	private JButton btnSEL;			/**/
	private JComboBox jcbSHIP;		/**/
	private JList lstSHIP;			/**/
	private JCheckBox chkUP;		/**/
	private JCheckBox chkDOWN;		/**/
	private JCheckBox chkNEAR;		/**/
	/*///////////////////////////////**/
	private int SHIP_NUM = 0;		/**/
	/*///////////////////////////////**/
	Timer tCOOLER = new Timer(5000, new ActionListener(){
		public void actionPerformed(ActionEvent arg0) {
			btnMUL.setEnabled(true);
			btnADD.setEnabled(true);
			btnSET.setEnabled(true);
		}
	});
	
	public ShipMultiGUI(Stbof st){
		/*LOAD DATA*/
		if (st==null) {
			return;
		}
		try{
			SHIP = (ShipList)st.getInternalFile(Stbof.fileSHIPLIST_SST, true);
			RACE = (Race)st.getInternalFile(Stbof.fileRACE_RST, true);
			LEX = (Lexicon)st.getInternalFile(Stbof.fileLEXICON_DIC, true);
		}catch (Exception n){
		}
		if (SHIP==null || RACE==null || LEX == null) {
			return;
		}
		/*CREATE*/
		txtMUL	= new JTextField[22];
		btnMUL	= new JButton(Language.getString("ShipMultiGUI.0")); //$NON-NLS-1$
		btnADD	= new JButton(Language.getString("ShipMultiGUI.1")); //$NON-NLS-1$
		btnSET	= new JButton(Language.getString("ShipMultiGUI.2")); //$NON-NLS-1$
		btnSEL	= new JButton(Language.getString("ShipMultiGUI.3")); //$NON-NLS-1$
		jcbSHIP = new JComboBox();
		lstSHIP = new JList();
		chkUP 	= new JCheckBox(Language.getString("ShipMultiGUI.4"), false); //$NON-NLS-1$
		chkNEAR	= new JCheckBox(Language.getString("ShipMultiGUI.5"), true); //$NON-NLS-1$
		chkDOWN	= new JCheckBox(Language.getString("ShipMultiGUI.6"), false); //$NON-NLS-1$
		ButtonGroup bgROUND = new ButtonGroup();
		/*SETUP*/
		Font def = UE.SETTINGS.getDefaultFont();

		// timer
		tCOOLER.setRepeats(false);
		
		for (int i=0; i<22; i++){
			txtMUL[i] = new JTextField(10);
			txtMUL[i].setText("1"); //$NON-NLS-1$
			txtMUL[i].setFont(def);
		}

		//Rounding
		bgROUND.add(chkUP);
		bgROUND.add(chkNEAR);
		bgROUND.add(chkDOWN);
		chkUP.setFont(def);
		chkNEAR.setFont(def);
		chkDOWN.setFont(def);
		//multiply
		btnMUL.setFont(def);
		btnMUL.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (lstSHIP.getSelectedIndex()<0){
					UE.displayError(new Exception(Language.getString("ShipMultiGUI.7"))); //$NON-NLS-1$
					return;
				}
				try{
					cool();
					Object[] val = lstSHIP.getSelectedValues();
					for (int i=0; i<val.length; i++){
						for (int j=0; j<22; j++){
							double mul = 1;
							try{
								mul = Double.parseDouble(txtMUL[j].getText());
								setVal(j, val[i].hashCode(), getVal(j, val[i].hashCode())*mul);
							}catch (Exception op){
								UE.displayError(op);
							}
						}
					}
				}catch (Exception ex){
					UE.displayError(ex);
				}
			}
		});
		//add
		btnADD.setFont(def);
		btnADD.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (lstSHIP.getSelectedIndex()<0){
					UE.displayError(new Exception(Language.getString("ShipMultiGUI.7"))); //$NON-NLS-1$
					return;
				}
				try{
					cool();
					Object[] val = lstSHIP.getSelectedValues();
					for (int i=0; i<val.length; i++){
						for (int j=0; j<22; j++){
							double mul = 1;
							try{
								mul = Double.parseDouble(txtMUL[j].getText());
								setVal(j, val[i].hashCode(), getVal(j, val[i].hashCode())+mul);
							}catch (Exception op){
								UE.displayError(op);
							}
						}
					}
				}catch (Exception ex){
					UE.displayError(ex);
				}
			}
		});
		//set
		btnSET.setFont(def);
		btnSET.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (lstSHIP.getSelectedIndex()<0){
					UE.displayError(new Exception(Language.getString("ShipMultiGUI.7"))); //$NON-NLS-1$
					return;
				}
				try{
					cool();
					Object[] val = lstSHIP.getSelectedValues();
					for (int i=0; i<val.length; i++){
						for (int j=0; j<22; j++){
							double mul = 1;
							try{
								mul = Double.parseDouble(txtMUL[j].getText());
								setVal(j, val[i].hashCode(), mul);
							}catch (Exception op){
								UE.displayError(op);
							}
						}
					}
				}catch (Exception ex){
					UE.displayError(ex);
				}
			}
		});
		//sel
		btnSEL.setFont(def);
		btnSEL.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (lstSHIP.getSelectedIndex()<0){
					if (SHIP_NUM>0){
						int[] set = new int[SHIP_NUM];
						for (int i=0; i<SHIP_NUM; i++) {
							set[i] = i;
						}
						lstSHIP.setSelectedIndices(set);
					}
				}else{
					lstSHIP.clearSelection();
				}
			}
		});
		jcbSHIP.setFont(def);
		jcbSHIP.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				fillList();
			}
		});
		lstSHIP.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		try{
			for (int i=0; i<RACE.getNumberOfEntries(); i++){
				jcbSHIP.addItem(RACE.getName(i));
			}
			jcbSHIP.addItem(Language.getString("ShipMultiGUI.8")); //$NON-NLS-1$
			jcbSHIP.addItem(Language.getString("ShipMultiGUI.9")); //$NON-NLS-1$
			jcbSHIP.addItem(LEX.getEntry(1103)); //scout
			jcbSHIP.addItem(LEX.getEntry(232)); //destroyer
			jcbSHIP.addItem(LEX.getEntry(204)); //cruiser
			jcbSHIP.addItem(LEX.getEntry(1183)); //strike
			jcbSHIP.addItem(LEX.getEntry(173)); //command
			jcbSHIP.addItem(LEX.getEntry(166)); //colony
			jcbSHIP.addItem(LEX.getEntry(895)); //outpost
			jcbSHIP.addItem(LEX.getEntry(57)); //starbase
			jcbSHIP.addItem(LEX.getEntry(1366)); //transport
		}catch (Exception ex){
			UE.displayError(ex);
			return;
		}
		lstSHIP.setFont(def);
		/*PLACE*/
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.insets=new Insets(5, 5, 5, 5);
		c.fill=GridBagConstraints.BOTH;
		//left bar
		c.gridwidth = 1;
		c.gridheight = 1;
		c.gridx = 0;
		c.gridy = 0;
		add(jcbSHIP, c);
		c.gridy = 1;
		c.gridheight = 12;
		JScrollPane jpship = new JScrollPane(lstSHIP);
		add(jpship, c);
		c.gridy = 13;
		c.gridheight = 1;
		add(btnSEL, c);
		//top
		c.gridx = 1;
		c.gridy = 0;
		JLabel lbl = new JLabel(Language.getString("ShipMultiGUI.10")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridx = 2;
		add(chkUP);
		c.gridx = 3;
		add(chkNEAR);
		c.gridx = 4;
		add(chkDOWN);
		//top left
		c.gridx = 1;
		c.gridy = 1;
		lbl = new JLabel(Language.getString("ShipMultiGUI.11")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 2;
		lbl = new JLabel(Language.getString("ShipMultiGUI.12")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 3;
		lbl = new JLabel(Language.getString("ShipMultiGUI.13")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 4;
		lbl = new JLabel(Language.getString("ShipMultiGUI.14")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 5;
		lbl = new JLabel(Language.getString("ShipMultiGUI.15")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 6;
		lbl = new JLabel(Language.getString("ShipMultiGUI.16")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 7;
		lbl = new JLabel(" "); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridx = 2;
		for (int i=0; i<6; i++){
			c.gridy = i+1;
			add(txtMUL[i], c);
		}
		//top right
		c.gridx = 3;
		c.gridy = 1;
		lbl = new JLabel(Language.getString("ShipMultiGUI.17")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 2;
		lbl = new JLabel(Language.getString("ShipMultiGUI.18")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 3;
		lbl = new JLabel(Language.getString("ShipMultiGUI.19")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 4;
		lbl = new JLabel(Language.getString("ShipMultiGUI.20")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 5;
		lbl = new JLabel(Language.getString("ShipMultiGUI.21")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 6;
		lbl = new JLabel(Language.getString("ShipMultiGUI.22")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridx = 4;
		for (int i=6; i<12; i++){
			c.gridy = i-5;
			add(txtMUL[i], c);
		}
		//bottom left
		c.gridx = 1;
		c.gridy = 8;
		lbl = new JLabel(Language.getString("ShipMultiGUI.23")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 9;
		lbl = new JLabel(Language.getString("ShipMultiGUI.24")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 10;
		lbl = new JLabel(Language.getString("ShipMultiGUI.25")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 11;
		lbl = new JLabel(Language.getString("ShipMultiGUI.26")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 12;
		lbl = new JLabel(Language.getString("ShipMultiGUI.27")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridx = 2;
		for (int i=12; i<17; i++){
			c.gridy = i-4;
			add(txtMUL[i], c);
		}
		//bottom right
		c.gridx = 3;
		c.gridy = 8;
		lbl = new JLabel(Language.getString("ShipMultiGUI.28")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 9;
		lbl = new JLabel(Language.getString("ShipMultiGUI.29")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 10;
		lbl = new JLabel(Language.getString("ShipMultiGUI.30")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 11;
		lbl = new JLabel(Language.getString("ShipMultiGUI.31")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridy = 12;
		lbl = new JLabel(Language.getString("ShipMultiGUI.32")); //$NON-NLS-1$
		lbl.setFont(def);
		add(lbl, c);
		c.gridx = 4;
		for (int i=17; i<22; i++){
			c.gridy = i-9;
			add(txtMUL[i], c);
		}
		//bottom
		JPanel pnlBTN = new JPanel();
		int w, h;
		w = btnMUL.getPreferredSize().width;
		if (w < btnADD.getPreferredSize().width) w = btnADD.getPreferredSize().width;
		if (w < btnSET.getPreferredSize().width) w = btnSET.getPreferredSize().width;
		h = btnMUL.getPreferredSize().height;
		if (h < btnADD.getPreferredSize().height) h = btnADD.getPreferredSize().height;
		if (h < btnSET.getPreferredSize().height) h = btnSET.getPreferredSize().height;
		Dimension dim = new Dimension(w, h);
		btnMUL.setPreferredSize(dim);
		btnADD.setPreferredSize(dim);
		btnSET.setPreferredSize(dim);
		pnlBTN.add(btnMUL);
		pnlBTN.add(btnADD);
		pnlBTN.add(btnSET);
		c.gridx = 1;
		c.gridy = 13;
		c.insets=new Insets(0, 0, 0, 0);
		c.gridwidth = 4;
		add(pnlBTN, c);
	}
	
	private void cool(){
		btnMUL.setEnabled(false);
		btnADD.setEnabled(false);
		btnSET.setEnabled(false);
		tCOOLER.start();
	}
	
	/*i-parameter index, j-ship index*/
	private double getVal(int i, int j) throws Exception{
		double ret;
		switch (i){
			case 0:{
				ret = SHIP.getBeamAccu(j);
				break;
			}
			case 1:{
				ret = SHIP.getBeamNum(j);
				break;
			}
			case 2:{
				ret = SHIP.getBeamMulti(j);
				break;
			}
			case 3:{
				ret = SHIP.getBeamDamage(j);
				break;
			}
			case 4:{
				ret = SHIP.getBeamMin(j);
				break;
			}
			case 5:{
				ret = SHIP.getBeamMax(j);
				break;
			}
			case 6:{
				ret = SHIP.getTorpAccu(j);
				break;
			}
			case 7:{
				ret = SHIP.getTorpNum(j);
				break;
			}
			case 8:{
				ret = SHIP.getTorpMulti(j);
				break;
			}
			case 9:{
				ret = SHIP.getTorpDamage(j);
				break;
			}
			case 10:{
				ret = SHIP.getTorpMin(j);
				break;
			}
			case 11:{
				ret = SHIP.getTorpMax(j);
				break;
			}
			case 12:{
				ret = SHIP.getShieldPen(j);
				break;
			}
			case 13:{
				ret = SHIP.getShieldLvl(j);
				break;
			}
			case 14:{
				ret = SHIP.getShieldRec(j);
				break;
			}
			case 15:{
				ret = SHIP.getShieldStr(j);
				break;
			}
			case 16:{
				ret = SHIP.getHullStr(j);
				break;
			}
			case 17:{
				ret = SHIP.getDefense(j);
				break;
			}
			case 18:{
				ret = SHIP.getAgility(j);
				break;
			}
			case 19:{
				ret = SHIP.getBuildCost(j);
				break;
			}
			case 20:{
				ret = SHIP.getMaintenance(j);
				break;
			}
			case 21:{
				ret = SHIP.getProduction(j);
				break;
			}
			default:{
				throw new Exception(Language.getString("ShipMultiGUI.33") + i); //$NON-NLS-1$
			}
		};
		return ret;
	}
	/*i-parameter index, j-ship index, val- value*/
	private void setVal(int i, int j, double val) throws Exception{
		switch (i){
			case 0:{
				SHIP.setBeamAccu(j, round(val));
				break;
			}
			case 1:{
				SHIP.setBeamNum(j, round(val));
				break;
			}
			case 2:{
				SHIP.setBeamMulti(j, round(val));
				break;
			}
			case 3:{
				SHIP.setBeamDamage(j, round(val));
				break;
			}
			case 4:{
				SHIP.setBeamMin(j, val);
				break;
			}
			case 5:{
				SHIP.setBeamMax(j, val);
				break;
			}
			case 6:{
				SHIP.setTorpAccu(j, round(val));
				break;
			}
			case 7:{
				SHIP.setTorpNum(j, round(val));
				break;
			}
			case 8:{
				SHIP.setTorpMulti(j, round(val));
				break;
			}
			case 9:{
				SHIP.setTorpDamage(j, round(val));
				break;
			}
			case 10:{
				SHIP.setTorpMin(j, val);
				break;
			}
			case 11:{
				SHIP.setTorpMax(j, val);
				break;
			}
			case 12:{
				SHIP.setShieldPen(j, round(val));
				break;
			}
			case 13:{
				SHIP.setShieldLvl(j, round(val));
				break;
			}
			case 14:{
				SHIP.setShieldRec(j, round(val));
				break;
			}
			case 15:{
				SHIP.setShieldStr(j, round(val));
				break;
			}
			case 16:{
				SHIP.setHullStr(j, round(val));
				break;
			}
			case 17:{
				SHIP.setDefense(j, round(val));
				break;
			}
			case 18:{
				SHIP.setAgility(j, val);
				break;
			}
			case 19:{
				SHIP.setBuildCost(j, round(val));
				break;
			}
			case 20:{
				SHIP.setMaintenance(j, round(val));
				break;
			}
			case 21:{
				SHIP.setProduction(j, round(val));
				break;
			}
			default:{
				throw new Exception(Language.getString("ShipMultiGUI.33") + i); //$NON-NLS-1$
			}
		};
	}
	@Override
	public void finalWarning() throws Exception{}
    
	//////////////////////////////////////////
	private void fillList(){
		Object[] obj = SHIP.getIDs(jcbSHIP.getSelectedIndex());
		SHIP_NUM = obj.length;
		lstSHIP.setListData(SHIP.getIDs(jcbSHIP.getSelectedIndex()));
	}

	private int round(double val){
		if (chkUP.isSelected()){
			return (int)Math.ceil(val);
		}else if (chkNEAR.isSelected()){
			return (int)Math.round(val);
		}else{
			return (int)Math.floor(val);
		}
	}
}
