/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: StartConGUI.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.gui.stbof;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import ue.*;
import ue.gui.*;
import ue.edit.res.stbof.bst.*;
import ue.edit.res.stbof.tec.*;
import ue.edit.res.stbof.pst.Planet;
import ue.edit.res.stbof.rst.*;
import ue.edit.res.*;
import ue.edit.res.stbof.wtf.Aiminor;
import ue.util.*;

@SuppressWarnings("serial")  //$NON-NLS-1$
public class StartConGUI extends MainPanel
{
	private int SELECTED = -1;
	//edited
	private Edifice BUILDING = null;
	private RaceTech STARTCON = null;
	private Race RACE = null;
    private Planet PLANET = null;
	private TecField TECH = null;
	//my goodness
	private JList lstRACE;
	private JTextField[] txtLVL = new JTextField[7];
	private JTextField[] txtPNT = new JTextField[7];
	private JPanel pnlBUILD;
	private IndexedCheckBox[] chkBUILD;
	private JComboBox cmbMASK;
	private JComboBox cmbLVLMASK;
	private JButton btnMARKALL;
	private JButton btnAUTOMARK;
	private JButton btnAUTOMARKALL;
	
	public StartConGUI(Stbof st)
        {
		//associate
		if (st==null) {
			return;
		}
		try
        {
			BUILDING = (Edifice)st.getInternalFile(Stbof.fileEDIFICE_BST, true);
			STARTCON = (RaceTech)st.getInternalFile(Stbof.fileRACETECH_TEC, true);
			RACE = (Race)st.getInternalFile(Stbof.fileRACE_RST, true);
                        PLANET = (Planet)st.getInternalFile(Stbof.filePLANET_PST, true);
			TECH = (TecField)st.getInternalFile(Stbof.fileTECFIELD_TEC, true);
		}catch (Exception z){
			UE.displayError(z);
		}
		if (RACE==null || BUILDING==null || STARTCON==null || TECH==null) {
			return;
		}
		//build
        lstRACE = new JList();
		for (int i=0; i<7; i++){
			txtLVL[i] = new JTextField(6);
			txtPNT[i] = new JTextField(6);
		}
		pnlBUILD = new JPanel(new GridBagLayout());
		cmbMASK = new JComboBox();
		cmbLVLMASK = new JComboBox();
		btnMARKALL = new JButton(Language.getString("StartConGUI.0")); //$NON-NLS-1$
		btnAUTOMARK = new JButton(Language.getString("StartConGUI.1")); //$NON-NLS-1$
		btnAUTOMARKALL = new JButton(Language.getString("StartConGUI.2")); //$NON-NLS-1$
		btnMARKALL.addActionListener(new ActionListener(){
            @Override
			public void actionPerformed(ActionEvent ae){
				if (chkBUILD == null || SELECTED<0) {
					return;
				}
				if (chkBUILD.length<=0) {
					return;
				}
				boolean val = !chkBUILD[0].isSelected();
				for (int j=0; j<chkBUILD.length; j++){
					chkBUILD[j].setSelected(val);
				}
			}
		});
		btnAUTOMARK.addActionListener(new ActionListener()
        {
            @Override
		    public void actionPerformed(ActionEvent ae)
            {
		        if (SELECTED < 0)
                {
		            return;
                }

                try
                {
		            finalWarning();

                    int NUM = BUILDING.getNumberOfEntries();		//NUMBER OF BUILDINGS

                    for (int bld = 0; bld < NUM; bld++)
                    {
                        STARTCON.setAvailable(SELECTED, bld,
                                isBuildable(SELECTED, bld, true));
                    }

                    //refuel
                    fillList();
                }
                catch (Exception e)
                {
                    UE.displayError(e);
                }
            }
		});
		btnAUTOMARKALL.addActionListener(new ActionListener()
        {
            @Override
		    public void actionPerformed(ActionEvent ae)
            {
		        try
                {
		            finalWarning();

                    int NUM = BUILDING.getNumberOfEntries();		//NUMBER OF BUILDINGS
				
                    for (int SEL = 0; SEL < STARTCON.getNumberOfEntries(); SEL++)
                    {
                        for (int bld = 0; bld < NUM; bld++)
                        {
                            STARTCON.setAvailable(SEL, bld, isBuildable(SEL, bld,
                                    true));
                        }
                    }

                     //refuel
                    fillList();
                }
                catch (Exception e)
                {
                    UE.displayError(e);
                }
            }
		});
		//setup
		Font def = UE.SETTINGS.getDefaultFont();
		btnMARKALL.setFont(def);
		btnAUTOMARK.setFont(def);
		btnAUTOMARKALL.setFont(def);
		lstRACE.setFont(def);
		for (int i=0; i<7; i++){
			txtLVL[i].setFont(def);
			txtPNT[i].setFont(def);
		}
		lstRACE.addListSelectionListener(new ListSelectionListener()
        {
            @Override
            public void valueChanged(ListSelectionEvent e)
            {
				//save
                try
                {
                    finalWarning();
                }
                catch (Exception ex)
                {
                    // really bad stuff happening - bail
                    UE.displayError(ex);
                    return;
                }
				//ok
				SELECTED = lstRACE.getSelectedIndex();
				if (SELECTED<0) {
					return;
				}
				try{
					for (int i=0; i<7; i++){
						txtLVL[i].setText(Short.toString(STARTCON.getTechLvl(SELECTED, i)));
						txtPNT[i].setText(Integer.toString(STARTCON.getTechPnt(SELECTED, i)));
					}
					fillList();
				}catch (Exception z){
					UE.displayError(z);
				}
			}
		});
		//combo
		cmbMASK.setFont(def);
		cmbMASK.addActionListener(new ActionListener(){
            @Override
			public void actionPerformed(ActionEvent ae){
				if (SELECTED<0) {
					return;
				}
				if (cmbMASK.getSelectedIndex()<0 || cmbLVLMASK.getSelectedIndex()<0) {
					return;
				}
                try
                {
                    finalWarning();
                }
                catch (Exception ex)
                {
                    // really bad stuff happening - bail
                    UE.displayError(ex);
                    return;
                }
				fillList();
			}
		});
		cmbLVLMASK.setFont(def);
		cmbLVLMASK.addActionListener(new ActionListener(){
            @Override
			public void actionPerformed(ActionEvent ae){
				if (SELECTED<0) {
					return;
				}
				if (cmbMASK.getSelectedIndex()<0 || cmbLVLMASK.getSelectedIndex()<0) {
					return;
				}
                try
                {
                    finalWarning();
                }
                catch (Exception ex)
                {
                    // really bad stuff happening - bail
                    UE.displayError(ex);
                    return;
                }
				fillList();
			}
		});
		//place
		setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        add(Box.createHorizontalGlue());

            // left panel
            JScrollPane scrRace = new JScrollPane(lstRACE);
            scrRace.setPreferredSize(new Dimension(200, 320));

            JPanel pnl = new JPanel(new BorderLayout());
            pnl.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
            pnl.add(scrRace, BorderLayout.CENTER);

            add(pnl); //, BorderLayout.WEST);

            // center panel
            pnl = new JPanel(new GridBagLayout());
            GridBagConstraints c = new GridBagConstraints();
            c.insets=new Insets(5, 5, 5, 5);
            c.fill=GridBagConstraints.BOTH;
            c.gridx = 0;
            c.gridy = 0;
            c.gridwidth = 1;
            c.gridheight = 1;

            String str = Language.getString("StartConGUI.3"); //$NON-NLS-1$

            try
            {
                String[] strt = TECH.getFields();
                for (int i=0; i<7; i++){
                    JLabel lbl = new JLabel(str.replace("%1", strt[i])); //$NON-NLS-1$
                    lbl.setFont(def);
                    c.gridx = 0;
                    c.gridy = i+1;
                    pnl.add(lbl, c);
                    c.gridx = 1;
                    pnl.add(txtLVL[i], c);
                    c.gridx = 2;
                    lbl = new JLabel(Language.getString("StartConGUI.4")); //$NON-NLS-1$
                    lbl.setFont(def);
                    pnl.add(lbl, c);
                    c.gridx = 3;
                    pnl.add(txtPNT[i], c);
                }
            }catch (Exception z){
                UE.displayError(z);
            }
            c.gridwidth = 4;
            c.gridx = 0;
            c.gridy = 8;
            pnl.add(btnAUTOMARK, c);
            c.gridy = 9;
            pnl.add(btnAUTOMARKALL, c);

            JPanel tmpPnl = new JPanel(new BorderLayout());
            tmpPnl.add(pnl, BorderLayout.CENTER);
            pnl = new JPanel(new BorderLayout());
            pnl.add(tmpPnl, BorderLayout.NORTH);

            add(pnl); // , BorderLayout.CENTER);

            // right list panel
            JPanel listPnl = new JPanel(new BorderLayout());
            pnl = new JPanel(new BorderLayout());
            JPanel miniPnl = new JPanel(new BorderLayout());
            miniPnl.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
            miniPnl.add(cmbMASK, BorderLayout.CENTER);
            pnl.add(miniPnl, BorderLayout.CENTER);
            miniPnl = new JPanel(new BorderLayout());
            miniPnl.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
            miniPnl.add(cmbLVLMASK, BorderLayout.CENTER);
            pnl.add(miniPnl, BorderLayout.EAST);

            listPnl.add(pnl, BorderLayout.NORTH);

            JScrollPane JSP = new JScrollPane(pnlBUILD);
            JSP.setPreferredSize(new Dimension(200, 320));
            JScrollBar Jscr = JSP.getVerticalScrollBar();
            Jscr.setBlockIncrement(100);
            Jscr.setUnitIncrement(20);
            JSP.setVerticalScrollBar(Jscr);
            miniPnl = new JPanel(new BorderLayout());
            miniPnl.setBorder(BorderFactory.createEmptyBorder(0, 5, 0, 5));
            miniPnl.add(JSP, BorderLayout.CENTER);
            listPnl.add(miniPnl, BorderLayout.CENTER);
            miniPnl = new JPanel(new BorderLayout());
            miniPnl.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
            miniPnl.add(btnMARKALL, BorderLayout.CENTER);
            listPnl.add(miniPnl, BorderLayout.SOUTH);

            add(listPnl); //, BorderLayout.EAST);

        add(Box.createHorizontalGlue());

        //fill
		str = Language.getString("StartConGUI.5"); //$NON-NLS-1$
		try{
			cmbMASK.addItem(new ID(Language.getString("StartConGUI.6"),0)); //$NON-NLS-1$
			for (int n=0; n<5; n++){
				cmbMASK.addItem(new ID(RACE.getName(n), n+1));
			}
			cmbMASK.addItem(new ID(Language.getString("StartConGUI.7"), 6)); //$NON-NLS-1$
			for (int n=0; n<5; n++){
				cmbMASK.addItem(new ID(str.replace("%1", RACE.getName(n)), n+7)); //$NON-NLS-1$
			}
			cmbMASK.addItem(new ID(Language.getString("StartConGUI.8"), 12)); //$NON-NLS-1$
		}catch (Exception t){
			UE.displayError(t);
		}
		try{
			cmbLVLMASK.addItem(new ID(Language.getString("StartConGUI.9"),0)); //$NON-NLS-1$
			str = Language.getString("StartConGUI.10"); //$NON-NLS-1$
			for (int n=0; n<10; n++){
				cmbLVLMASK.addItem(new ID(str.replace("%1", Integer.toString(n)), n+1)); //$NON-NLS-1$
			}
		}catch (Exception t){
			UE.displayError(t);
		}
		
		
		short[] butt = STARTCON.getAll();
        ID[] ids = new ID[butt.length];
		int hum = 1;

		for (int i=0; i< butt.length; i++)
        {
			try
            {


				if (str==null){
					hum = 1;
					str = RACE.getName(butt[i]);
				}else if (str.equals(RACE.getName(butt[i]))){
					hum++;
				}else{
					hum = 1;
					str = RACE.getName(butt[i]);
				}

				ids[i] = new ID(str+" "+hum, i); //$NON-NLS-1$
			}
            catch (Exception z)
            {
				UE.displayError(z);
			}
		}

        lstRACE.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        lstRACE.setListData(ids);
        lstRACE.setSelectedIndex(0);
	}
	
	private void fillList()
    {
		if (SELECTED<0)
        {
			return;
		}

		try
        {
			byte msk = (byte)cmbMASK.getSelectedIndex();
			byte lvlmsk = (byte)cmbLVLMASK.getSelectedIndex();
			ID[] ed = BUILDING.getShortIDs(msk, 20);
			pnlBUILD.removeAll();
			GridBagConstraints c = new GridBagConstraints();
			c.insets=new Insets(5, 5, 5, 5);
			c.fill=GridBagConstraints.BOTH;
			c.gridwidth = 1;
			c.gridheight = 1;
			c.gridy = 0;
			c.gridx = 0;
			Font def = UE.SETTINGS.getDefaultFont();
			int y = 0;
			ArrayList<ID> accept = new ArrayList<ID>();
			for (int i=0; i<ed.length; i++){
				try{
					if (lvlmsk==0){
						accept.add(ed[i]);
					}else{
						if (BUILDING.getTechLvl(ed[i].hashCode())==(byte)(lvlmsk-1)){
							accept.add(ed[i]);
						}
					}
				}catch (Exception z){
					UE.displayError(z);
				}
			}
			
            chkBUILD = new IndexedCheckBox[accept.size()];
            int bid;

            for (int i = 0; i < accept.size(); i++)
            {
                bid = accept.get(i).hashCode();

				try{
					c.gridy = y++;
					chkBUILD[i] = new IndexedCheckBox(bid + ": " + BUILDING.getName(bid), bid,
                            STARTCON.isAvailable(SELECTED, bid));
					chkBUILD[i].setFont(def);
					pnlBUILD.add(chkBUILD[i], c);
				}catch (Exception z){
					UE.displayError(z);
				}
			}

            this.validate();
			pnlBUILD.setVisible(false);
			pnlBUILD.setVisible(true);
		}catch (Exception z){
			UE.displayError(z);
		}
	}
	
	private class IndexedCheckBox extends JCheckBox
    {
		public int chk_INDEX;

		public IndexedCheckBox(String str, int index, boolean value)
        {
			super(str, value);
			chk_INDEX = index;
		}
	}
	
	@Override
	public void finalWarning() throws Exception
    {
		if (SELECTED < 0)
        {
			return;
		}

        short q = -1;
        int w = -1;

        for (int i = 0; i < 7; i++)
        {
            q = Short.parseShort(txtLVL[i].getText());
            w = Integer.parseInt(txtPNT[i].getText());

            if (q >= 0)
            {
                STARTCON.setTechLvl(SELECTED, i, q);
            }
            if (w>=0) {
                STARTCON.setTechPnt(SELECTED, i, w);
            }
        }

        for (int j = 0; j<chkBUILD.length; j++)
        {
            STARTCON.setAvailable(SELECTED, chkBUILD[j].chk_INDEX, chkBUILD[j].isSelected());
        }
	}

    private boolean isBuildable(int techEraIndex, int buildingID,
            boolean testUpgrades) throws Exception
    {
        // ready data
        int race = STARTCON.getRaceID(techEraIndex);
        int LVL[] = new int[6];

        for (int i=0; i < 6; i++)
        {
            LVL[i] = STARTCON.getTechLvl(techEraIndex, i);
        }

        long mask = 1L << race;

        if (race >= 5)
        {
            if ((mask & BUILDING.getReqRace(buildingID)) != mask)
                return false;

            int sysReq = BUILDING.getSysReq(buildingID);

            if (sysReq == Edifice.SYS_REQ_DILITHIUM &&
                    !RACE.getDilithium(race))
                    return false;

            if (sysReq <= Edifice.SYS_REQ_VOLCANIC_PLANET &&
                    sysReq != PLANET.getType(PLANET.getIndex(RACE.getPlanet(race))))
                return false;

            // if the building is not buildable by all empires
            // and is not a main building
            if ((BUILDING.getExEmpire(buildingID) | 0xE0) != 0xE0
                    && !BUILDING.isMainBuilding(buildingID))
            {
                return false;
            }

            //check tech levels
            int typ = BUILDING.getTechReq(buildingID);
            int lvl = BUILDING.getTechLvl(buildingID);

            if (typ == 6)
            {   // all techs
                if (LVL[0] < lvl || LVL[1] < lvl || LVL[2] < lvl
                        || LVL[3] < lvl || LVL[4] < lvl || LVL[5] < lvl)
                    return false;
            }
            else
            {
                if ( LVL[typ] < lvl)
                    return false;
            }
        }
        else
        {
            if ((mask & BUILDING.getExEmpire(buildingID)) == mask)
                return false;

            //check tech levels
            int typ = BUILDING.getTechReq(buildingID);
            int lvl = BUILDING.getTechLvl(buildingID);

            if (typ == 6)
            {   // all techs
                if (LVL[0] < lvl || LVL[1] < lvl || LVL[2] < lvl
                        || LVL[3] < lvl || LVL[4] < lvl || LVL[5] < lvl)
                    return false;
            }
            else
            {
                if ( LVL[typ] < lvl)
                    return false;
            }
        }

        if (testUpgrades)
        {
            // check if buildings that this one upgrades to are buildable
            // and if so make this one not buildable
            for (int id = 0; id < BUILDING.getNumberOfEntries(); id++)
            {
                if (buildingID == id)
                    continue;

                if (BUILDING.getUpgradedFrom(id) == buildingID)
                {
                    if (this.isBuildable(techEraIndex, id, false))
                        return false;
                }
            }
        }

        return true;
    }
}
