/**
 * Ultimate Editor for Birth Of The Federation 1.02
 * Copyright (C) 2005-2011  Alan Podlesek
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * File: WDFEditablePointTreeNode.java
 *
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 *
 * Created: 1.8.2011
 */

package ue.gui.stbof.wdf;

import java.awt.Point;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 *
 */
public abstract class WDFEditablePointTreeNode extends DefaultMutableTreeNode
{
    public WDFEditablePointTreeNode(String name, final Point pos)
    {
        super(name);

        add(new WDFEditableIntegerValueTreeNode("X", pos.x, 5, Integer.MIN_VALUE, Integer.MAX_VALUE)
        {
            @Override
            public void setInteger(int value) {
                if (pos.x != value)
                {
                    pos.x = value;
                    setPoint(pos);
                }
            }
        });
        add(new WDFEditableIntegerValueTreeNode("Y", pos.y, 5, Integer.MIN_VALUE, Integer.MAX_VALUE)
        {
            @Override
            public void setInteger(int value) {
                if (pos.y != value)
                {
                    pos.y = value;
                    setPoint(pos);
                }
            }
        });
    }

    public abstract void setPoint(Point point);
}
