/**
 * Ultimate Editor
 * Copyright (C) 2009 Alan Podlesek
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * File: CommonStrings.java
 * 
 * Written by: Alan Podlesek <seqdcer@yahoo.com>
 * 
 * Created: 13.5.2009
 */
package ue.util;

import ue.Language;

/**
 * @author Alan Podlesek
 */
public abstract class CommonStrings
{
    /**
     * Invalid index: %1
     */
    public static final String InvalidIndex_1 = "CommonStrings.0"; //$NON-NLS-1$
    /**
     * Image %1 has invalid pixel depth, should be 16-bit but is %2-bit.
     */
    public static final String Image_1_HasInvalidPixelDepth_2 = "CommonStrings.1"; //$NON-NLS-1$
    /**
     * File not found: %1
     */
    public static final String FileNotFound_1 = "CommonStrings.2"; //$NON-NLS-1$
    /**
     * Image %1 is not an uncompressed 16-bit tga image.
     */
    public static final String TGAImage_1_IsNotUncompressed = "CommonStrings.3"; //$NON-NLS-1$
    /**
     * Image %1 size is %2x%3 pixels should be %4x5 pixels.
     */
    public static final String WrongImage_1_Size_23_Expected_45 = "CommonStrings.4"; //$NON-NLS-1$
    /**
     * File is corrupted: %1
     */
    public static final String File_Is_Corrupted_1 = "CommonStrings.5";
    /**
     * Edit
     */
    public static final String Edit = "CommonStrings.6";

    /**
     * @param string The string with %1 and the like
     * @param args Strings to replace %1...
     * @return
     */
    public static String populateString(String string, String[] args)
    {
        if (string != null && args != null)
        {
            int i = 1;
            
            for (String arg : args)
            {
                if (arg != null)
                {
                    string = string.replaceAll("%" + i, arg); //$NON-NLS-1$
                    i++;
                }
            }
        }
        
        return string;
    }
    
    /**
     * 
     * @param string oe of the fields feom this class
     * @param args arguments to replace %1 and the like
     * @return
     */
    public static String getLocalizedString(String string, String[] args)
    {
        return populateString(Language.getString(string), args);
    }
}
