/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ue.util;

import java.awt.Image;
import java.io.File;
import java.util.HashMap;

/**
 *
 */
public class ImageCache
{
    public ImageSource source;
    public HashMap<String, Image> cache;
    
    public ImageCache(ImageSource source)
    {
        this.source = source;
        cache = new HashMap<String, Image>();
    }

    public Image getImage(String name)
    {
        if (!cache.containsKey(name))
        {
            cache.put(name, source.getImage(name));
        }

        return cache.get(name);
    }

    public Image getCharacterImage(String font, char character)
    {
        String name = font + File.pathSeparator + character;

        if (!cache.containsKey(name))
        {
            cache.put(name, source.getCharacterImage(font, character));
        }

        return cache.get(name);
    }

    public void clearCache()
    {
        cache.clear();
    }
}
