/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: IntArray.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.util;

import java.io.*;

import ue.Language;
import ue.exception.*;

/**This class is an encapsulated int array.*/
public class IntArray{
	private int[] values;
	/**@param capacity the fixed size of the array.*/
	public IntArray(int capacity){
		values = new int[capacity];
	}
	/**Sets the value in array.
	@param index the index of the value to be set
	@param value the value to replace the old one*/
	public void set(int index, int value) throws InvalidArgumentsException{
		try{
			values[index] = value;
		}catch (Exception ze) {
			ze.printStackTrace();
			throw new InvalidArgumentsException(Language.getString("IntArray.0")); //$NON-NLS-1$
		}
	}
	/**returns the value in array.
	@param index the index of the value to be returned
	@return the value in array at specified index*/
	public int get(int index) throws InvalidArgumentsException{
		try{
			return values[index];
		}catch (Exception ze) {
			ze.printStackTrace();
			throw new InvalidArgumentsException(Language.getString("IntArray.0")); //$NON-NLS-1$
		}
	}
	/**writes all values to the OutputStream.*/
	public void dump(OutputStream out) throws IOException{
		int j = values.length;
		for (int i=0; i<j; i++){
			out.write(Tools.toByte(values[i], true));
		}
	}
	/**return an array of values*/
	public int[] toArray(){
		int[] ret = new int[values.length];
		System.arraycopy(values, 0, ret, 0, values.length);
		return ret;
	}
}
