/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: Pair.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.util;

/**
 * A pair of objects stuck together.
 */
public class Pair <A, B>
{
    public A LEFT;
    public B RIGHT;

    /**
     * Constructor, takes two objects and saves them as a pair
     */
    public Pair(A left, B right)
    {
        LEFT = left;
        RIGHT = right;
    }

    @Override
    public boolean equals(Object other)
    {
        Pair<?, ?> o = (Pair<?, ?>)other;
        
        return (o.LEFT.equals(LEFT) && o.RIGHT.equals(RIGHT));
    }

    @Override
    public int hashCode()
    {
        return LEFT.hashCode() + RIGHT.hashCode();
    }

    @Override
    public String toString()
    {
        return LEFT + ":" + RIGHT;
    }
}
