/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: RandomReader.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.util;

import java.io.*;

import ue.Language;

// FIXME: remove and find alternative

/**This class is used to read from the underlying stream in random order.

THIS CLASS EATS MEMORY - DON'T USE!
*/
public class RandomReader extends InputStream{
	private byte[] buffer;
	private long index=0;
	// strings
	private static String errSEEK = Language.getString("RandomReader.0"); //$NON-NLS-1$
	
	public RandomReader(InputStream in) throws IOException{
		try{
			buffer = new byte[in.available()];
			int off = 0;
			while (in.available()>0){
				int len = in.read(buffer, off, in.available());
				off+=len;
			}
		}catch (Exception e){
			throw new IOException();
		}
		in.close();
	}
	
	public void seek(long i) throws IOException{
		if (i > buffer.length || i < 0) {
			throw new IOException(errSEEK.replace("%1", Long.toString(i))); //$NON-NLS-1$
		}
		index = i;
	}
	
	public long getPointer(){ return index; }
	
	@Override
	public int available() throws IOException{
		try{
			if (buffer.length - index<=0) {
				return -1;
			}
			return (buffer.length - (int)index);
		}catch (Exception e){
			throw new IOException();
		}
	}

	@Override
	public void close() throws IOException{
		buffer = null;
		super.close();
	}
	
	@Override
	public long skip(long n) throws IOException{
		try{
			if (buffer.length - (index + n) < 0) {
				throw new IOException();
			} else {
				index+=n;
			}
		}catch (Exception e){
			throw new IOException();
		}
		return n;
	}
	
	@Override
	public int read(byte[] b, int off, int len) throws IOException{
		if (len > buffer.length - index) {
			len = buffer.length - (int)index;
		}
		for (int i=0; i<len; i++){
			b[off+i] = buffer[(int)index];
			index++;
		}
		return len;
	}
	
	@Override
	public int read(byte[] b) throws IOException{
		int len=0;
		try{
			if (buffer.length - index > b.length){
				int i;
				for (i=0; i< b.length; i++){
					b[i] = buffer[(int)index];
					index++;
					len++;
				}
			} else {
				int i;
				long dupe = buffer.length - index;
				for (i=0; i < dupe; i++){
					b[i] = buffer[(int)index];
					index++;
					len++;
				}
			}
		}catch (Exception e){
			throw new IOException();
		}
		return len;
	}
	
	@Override
	public int read() throws IOException{
		int r=0;
		try{
			r = buffer[(int)index];
			index++;
		}catch (Exception e){
			throw new IOException();
		}
		return r;
	}
	
	@Override
	public boolean markSupported(){ return false;}
}

