/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: RandomWriter.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.util;

import java.io.*;

import ue.Language;

// FIXME: remove and find alternative

/**This OutputStream is used to write to the underlying stream randomly.

THIS CLASS LEAKS MEMORY - DON'T USE!
*/
public class RandomWriter extends OutputStream{
	private byte[] BUFFER;
	private OutputStream OUT;
	private int INDEX=0;
	// strings
	private static String errRANGE = Language.getString("RandomWriter.0"); //$NON-NLS-1$
	
	/**Creates an instance of this class.
	@param out the OutputStream to write to.
	@param size the size in bytes of the data to be written to the stream*/
	public RandomWriter(OutputStream out, int size) throws IOException{
		if (size<0) {
			throw new IOException(Language.getString("RandomWriter.1")); //$NON-NLS-1$
		}
		BUFFER = new byte[size];
		OUT=out;
	}
	/**Flushes all written data to the underlying stream and closes both streams.*/
	@Override
	public void close() throws IOException{
		OUT.write(BUFFER);
		OUT.flush();
		BUFFER = null;
		OUT.close();
	}
	/**Does nothing.*/
	@Override
	public void flush() throws IOException{
	}
	/**Positions itself at the specified index.
	@param i the index*/
	public void seek(int i) throws IOException{
		if (i < 0 && i>=BUFFER.length) {
			throw new IOException(errRANGE.replace("%1", Integer.toString(i))); //$NON-NLS-1$
		}
		INDEX = i;
	}

	/**Returns the current position of the stream.*/
	public int getPointer(){ return INDEX; }

	/**Writes the byte array to the stream.*/
	@Override
	public void write(byte[] b) throws IOException{
		for (int i=0; i<b.length; i++){
			if (INDEX>=BUFFER.length) {
				throw new IOException(Language.getString("RandomWriter.2")); //$NON-NLS-1$
			}
			BUFFER[INDEX++] = b[i];
		}
	}
	/**Writes the byte array to the stream.
	@param off offset
	@param len length*/
	@Override
	public void write(byte[] b, int off, int len) throws IOException{
		for ( int i=0; i<len && (off + i < b.length); i++){
			if (INDEX>=BUFFER.length) {
				throw new IOException(Language.getString("RandomWriter.2")); //$NON-NLS-1$
			}
			BUFFER[INDEX++] = b[off + i];
		}
	}
	/**Writes the byte to the stream.
	*/
	@Override
	public void write(int b) throws IOException{
		if (INDEX>=BUFFER.length) {
			throw new IOException(Language.getString("RandomWriter.2")); //$NON-NLS-1$
		}
		BUFFER[INDEX++] = (byte)b;
	}
}

