/*
	Ultimate Editor for Birth Of The Federation 1.02
	Copyright (C) 2005-2007  Alan Podlesek
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
	
	
	File: StringGroup.java
	
	Written by: Alan Podlesek <seqdcer@yahoo.com>
	
	Last modified: 6.9.2007
*/

package ue.util;

import ue.Language;
import ue.exception.*;

/**
A group of strings.
*/

public class StringGroup implements Comparable<StringGroup>{
	private String NAME; //name of the group
	private String[] STRINGS; //the strings in this group
	
	public StringGroup(String name, String[] str) throws Exception{
		if (str == null) {
			throw new InvalidArgumentsException(Language.getString("StringGroup.0")); //$NON-NLS-1$
		}
		NAME = name;
		STRINGS = str;
	}
	
	public String getName(){ return NAME;}
	
	public String[] getStrings(){ return STRINGS;}
	
	@Override
	public boolean equals(Object o){
		if (!(o instanceof StringGroup)) {
			return false;
		}
		return (hashCode()==o.hashCode());
	}
	/**Returns the file's hashcode.*/
	@Override
	public int hashCode(){
		return NAME.hashCode();
	}
	public int compareTo(StringGroup obj){
		return NAME.compareTo(obj.getName());
	}
}
